#ifndef included_ASE_Compiler_Attribute_stub
#define included_ASE_Compiler_Attribute_stub

#ifdef __cplusplus
extern "C" {
#endif

#ifndef included_ASE_Compiler_Attribute
#include <ASE/Compiler/Attribute_IOR.h>
#endif

/* ASE.Compiler.Attribute.Attribute: Constructor and cast method */
void *ASE_Compiler_Attribute_Attribute(/*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getReferenceCount:  Retrieve the intrinsic reference count of the underlying object */
int32_t ASE_Compiler_Attribute_getReferenceCount(struct ASE_Compiler_Attribute__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.addReference:  Add one to the intrinsic reference count of the underlying object
 - Objects continue to exist as long as the reference count is positive
 - Clients should call this method whenever they create another ongoing reference to an object or interface */
void ASE_Compiler_Attribute_addReference(struct ASE_Compiler_Attribute__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.deleteReference:  Decrease by one the intrinsic reference count of the underlying object
 - Delete the object if the reference count is non-positive
 - Clients should call this method whenever they remove a reference to an object or interface */
void ASE_Compiler_Attribute_deleteReference(struct ASE_Compiler_Attribute__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isSame:  Return true if and only if <code>obj</code> refers to the same underlying object as this object */
int ASE_Compiler_Attribute_isSame(struct ASE_Compiler_Attribute__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getClassName:  Return the type name of the underlying class object */
const char *ASE_Compiler_Attribute_getClassName(struct ASE_Compiler_Attribute__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isInstanceOf:  Return <code>true</code> if this object is an instance of the specified type
 - This routine will return <code>true</code> if and only if a cast to the specified type would succeed */
int ASE_Compiler_Attribute_isInstanceOf(struct ASE_Compiler_Attribute__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getSuper:  Retrieve an object with the parent interface
 IMPL: Obviously, this must be implemented in the IOR of each interface/class */
struct ASE_BaseInterface__object *ASE_Compiler_Attribute_getSuper(struct ASE_Compiler_Attribute__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Attribute.getName:  Get the attribute name */
const char *ASE_Compiler_Attribute_getName(struct ASE_Compiler_Attribute__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Attribute.setName:  Set the attribute name */
void ASE_Compiler_Attribute_setName(struct ASE_Compiler_Attribute__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);

#ifdef __cplusplus
}
#endif
#endif
