#ifndef included_ASE_Compiler_Cxx_Declarator_stub
#define included_ASE_Compiler_Cxx_Declarator_stub

#ifdef __cplusplus
extern "C" {
#endif

#ifndef included_ASE_Compiler_Cxx_Declarator
#include <ASE/Compiler/Cxx/Declarator_IOR.h>
#endif

/* ASE.Compiler.Cxx.Declarator.Declarator: Constructor and cast method */
void *ASE_Compiler_Cxx_Declarator_Declarator(/*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.clone:  Return an empty object of the same type */
struct ASE_Compiler_Vertex__object *ASE_Compiler_Cxx_Declarator_clone(struct ASE_Compiler_Cxx_Declarator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.getIdentifier:  Retrieve the identifier associated with this vertex */
const char *ASE_Compiler_Cxx_Declarator_getIdentifier(struct ASE_Compiler_Cxx_Declarator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.setIdentifier:  Assign the identifier associated with this vertex */
void ASE_Compiler_Cxx_Declarator_setIdentifier(struct ASE_Compiler_Cxx_Declarator__object *self, /*in*/ const char *identifier, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.getAttributes:  Get attribute list for this element */
struct ASE_Compiler_Attribute__array *ASE_Compiler_Cxx_Declarator_getAttributes(struct ASE_Compiler_Cxx_Declarator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.setAttributes:  Set attribute list for this element */
void ASE_Compiler_Cxx_Declarator_setAttributes(struct ASE_Compiler_Cxx_Declarator__object *self, /*in*/ struct ASE_Compiler_Attribute__array *attributes, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.hasAttribute:  Determine whether an attribute is present on this vertex */
int ASE_Compiler_Cxx_Declarator_hasAttribute(struct ASE_Compiler_Cxx_Declarator__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.addAttribute:  Add attribute to this vertex */
void ASE_Compiler_Cxx_Declarator_addAttribute(struct ASE_Compiler_Cxx_Declarator__object *self, /*in*/ struct ASE_Compiler_Attribute__object *attribute, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.deleteAttribute:  Remove an attribute on this vertex
   Throws an exception if the attribute does not exist */
void ASE_Compiler_Cxx_Declarator_deleteAttribute(struct ASE_Compiler_Cxx_Declarator__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.getAttribute:  Get an attribute on this vertex
   Throws an exception if the attribute does not exist */
struct ASE_Compiler_Attribute__object *ASE_Compiler_Cxx_Declarator_getAttribute(struct ASE_Compiler_Cxx_Declarator__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.getParent:  Retrieve the parent of this vertex */
struct ASE_Compiler_Vertex__object *ASE_Compiler_Cxx_Declarator_getParent(struct ASE_Compiler_Cxx_Declarator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.setParent:  Assign the parent of this vertex */
void ASE_Compiler_Cxx_Declarator_setParent(struct ASE_Compiler_Cxx_Declarator__object *self, /*in*/ struct ASE_Compiler_Vertex__object *parent, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.getChildren:  Retrieve the children of this vertex */
struct ASE_Compiler_Vertex__array *ASE_Compiler_Cxx_Declarator_getChildren(struct ASE_Compiler_Cxx_Declarator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.setChildren:  Set the children of this vertex */
void ASE_Compiler_Cxx_Declarator_setChildren(struct ASE_Compiler_Cxx_Declarator__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.addChildren:  Add children to this vertex (duplicates allowed) */
void ASE_Compiler_Cxx_Declarator_addChildren(struct ASE_Compiler_Cxx_Declarator__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.removeChildren:  Remove children from this vertex
   Throws an exception if any child does not exist */
void ASE_Compiler_Cxx_Declarator_removeChildren(struct ASE_Compiler_Cxx_Declarator__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.getLineNumber:  Retrieve the line number associated with this vertex */
int32_t ASE_Compiler_Cxx_Declarator_getLineNumber(struct ASE_Compiler_Cxx_Declarator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.setLineNumber:  Set the line number associated with this vertex */
void ASE_Compiler_Cxx_Declarator_setLineNumber(struct ASE_Compiler_Cxx_Declarator__object *self, /*in*/ int32_t lineNumber, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.getComments:  Retrieve the comments of this vertex */
struct ASE_Compiler_Comment__array *ASE_Compiler_Cxx_Declarator_getComments(struct ASE_Compiler_Cxx_Declarator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.setComments:  Set the children of this vertex */
void ASE_Compiler_Cxx_Declarator_setComments(struct ASE_Compiler_Cxx_Declarator__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.addComments:  Add comments to this vertex (duplicates allowed) */
void ASE_Compiler_Cxx_Declarator_addComments(struct ASE_Compiler_Cxx_Declarator__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.removeComments:  Remove comments from this vertex
   Throws an exception if a comment does not exist */
void ASE_Compiler_Cxx_Declarator_removeComments(struct ASE_Compiler_Cxx_Declarator__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getReferenceCount:  Retrieve the intrinsic reference count of the underlying object */
int32_t ASE_Compiler_Cxx_Declarator_getReferenceCount(struct ASE_Compiler_Cxx_Declarator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.addReference:  Add one to the intrinsic reference count of the underlying object
 - Objects continue to exist as long as the reference count is positive
 - Clients should call this method whenever they create another ongoing reference to an object or interface */
void ASE_Compiler_Cxx_Declarator_addReference(struct ASE_Compiler_Cxx_Declarator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.deleteReference:  Decrease by one the intrinsic reference count of the underlying object
 - Delete the object if the reference count is non-positive
 - Clients should call this method whenever they remove a reference to an object or interface */
void ASE_Compiler_Cxx_Declarator_deleteReference(struct ASE_Compiler_Cxx_Declarator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isSame:  Return true if and only if <code>obj</code> refers to the same underlying object as this object */
int ASE_Compiler_Cxx_Declarator_isSame(struct ASE_Compiler_Cxx_Declarator__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getClassName:  Return the type name of the underlying class object */
const char *ASE_Compiler_Cxx_Declarator_getClassName(struct ASE_Compiler_Cxx_Declarator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getName:  Retrieve the object name */
const char *ASE_Compiler_Cxx_Declarator_getName(struct ASE_Compiler_Cxx_Declarator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.setName:  Set the object name */
void ASE_Compiler_Cxx_Declarator_setName(struct ASE_Compiler_Cxx_Declarator__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isInstanceOf:  Return <code>true</code> if this object is an instance of the specified type
 - This routine will return <code>true</code> if and only if a cast to the specified type would succeed */
int ASE_Compiler_Cxx_Declarator_isInstanceOf(struct ASE_Compiler_Cxx_Declarator__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getSuper:  Retrieve an object with the parent interface
 IMPL: Obviously, this must be implemented in the IOR of each interface/class */
struct ASE_BaseInterface__object *ASE_Compiler_Cxx_Declarator_getSuper(struct ASE_Compiler_Cxx_Declarator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Vertex.copy:  Need to override this */
struct ASE_Compiler_Cxx_Vertex__object *ASE_Compiler_Cxx_Declarator_copy(struct ASE_Compiler_Cxx_Declarator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Declarator.accept:  Overridden to dispatch correctly */
void ASE_Compiler_Cxx_Declarator_accept(struct ASE_Compiler_Cxx_Declarator__object *self, /*in*/ struct ASE_Compiler_Cxx_Visitor__object *visitor, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Declarator.getType:  Retrieve the declarator type */
struct ASE_Compiler_Cxx_Type__object *ASE_Compiler_Cxx_Declarator_getType(struct ASE_Compiler_Cxx_Declarator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Declarator.setType:  Set the declarator type */
void ASE_Compiler_Cxx_Declarator_setType(struct ASE_Compiler_Cxx_Declarator__object *self, /*in*/ struct ASE_Compiler_Cxx_Type__object *type, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Declarator.getStatic:  Retrieve the flag for static storage (nonstatic storage is called automatic) */
int ASE_Compiler_Cxx_Declarator_getStatic(struct ASE_Compiler_Cxx_Declarator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Declarator.setStatic:  Set the flag for static storage (nonstatic storage is called automatic) */
void ASE_Compiler_Cxx_Declarator_setStatic(struct ASE_Compiler_Cxx_Declarator__object *self, /*in*/ int isStatic, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Declarator.getExtern:  Retrieve the flag for external linkage */
int ASE_Compiler_Cxx_Declarator_getExtern(struct ASE_Compiler_Cxx_Declarator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Declarator.setExtern:  Set the flag for external linkage */
void ASE_Compiler_Cxx_Declarator_setExtern(struct ASE_Compiler_Cxx_Declarator__object *self, /*in*/ int isExtern, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Declarator.getTypedef:  Retrieve the flag for a typedef */
int ASE_Compiler_Cxx_Declarator_getTypedef(struct ASE_Compiler_Cxx_Declarator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Declarator.setTypedef:  Set the flag for a typedef */
void ASE_Compiler_Cxx_Declarator_setTypedef(struct ASE_Compiler_Cxx_Declarator__object *self, /*in*/ int isTypedef, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Declarator.getInitializer:  Retrieve the initializer */
struct ASE_Compiler_Cxx_Initializer__object *ASE_Compiler_Cxx_Declarator_getInitializer(struct ASE_Compiler_Cxx_Declarator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Declarator.setInitializer:  Set the initializer */
void ASE_Compiler_Cxx_Declarator_setInitializer(struct ASE_Compiler_Cxx_Declarator__object *self, /*in*/ struct ASE_Compiler_Cxx_Initializer__object *initializer, /*out*/ struct ASE_BaseException__object **_exception);

#ifdef __cplusplus
}
#endif
#endif
