#include <stdlib.h>

#ifndef included_ASE_Compiler_Cxx_Function_stub
#include "ASE/Compiler/Cxx/Function_Stub.h"
#endif

#ifndef included_ASE_ASEException
#include <ASE/ASEException_IOR.h>
#endif

#ifndef included_ASE_Loader
#include <ASE/Loader_IOR.h>
#endif

void *ASE_Compiler_Cxx_Function_Function(/*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  if (obj)
  {
    return (*(obj->d_epv->castObject))(obj, "ASE.Compiler.Cxx.Function", _exception);
  }
  else
  {
    const struct ASE_Compiler_Cxx_Function__external *(*_extFunc)(void);
    
    _extFunc = (const struct ASE_Compiler_Cxx_Function__external *(*)(void)) ASE_Loader__externals()->getStaticEPV(&_exception)->getClassMethodTable("ASE.Compiler.Cxx.Function", &_exception);
    return (*((*_extFunc)()->createObject))(_exception);
  }
}

struct ASE_Compiler_Vertex__object *ASE_Compiler_Cxx_Function_clone(struct ASE_Compiler_Cxx_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->clone))(self->d_object, _exception);
}

const char *ASE_Compiler_Cxx_Function_getIdentifier(struct ASE_Compiler_Cxx_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getIdentifier))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Function_setIdentifier(struct ASE_Compiler_Cxx_Function__object *self, /*in*/ const char *identifier, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setIdentifier))(self->d_object, identifier, _exception);
}

struct ASE_Compiler_Attribute__array *ASE_Compiler_Cxx_Function_getAttributes(struct ASE_Compiler_Cxx_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getAttributes))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Function_setAttributes(struct ASE_Compiler_Cxx_Function__object *self, /*in*/ struct ASE_Compiler_Attribute__array *attributes, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setAttributes))(self->d_object, attributes, _exception);
}

int ASE_Compiler_Cxx_Function_hasAttribute(struct ASE_Compiler_Cxx_Function__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->hasAttribute))(self->d_object, name, _exception);
}

void ASE_Compiler_Cxx_Function_addAttribute(struct ASE_Compiler_Cxx_Function__object *self, /*in*/ struct ASE_Compiler_Attribute__object *attribute, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addAttribute))(self->d_object, attribute, _exception);
}

void ASE_Compiler_Cxx_Function_deleteAttribute(struct ASE_Compiler_Cxx_Function__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->deleteAttribute))(self->d_object, name, _exception);
}

struct ASE_Compiler_Attribute__object *ASE_Compiler_Cxx_Function_getAttribute(struct ASE_Compiler_Cxx_Function__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getAttribute))(self->d_object, name, _exception);
}

struct ASE_Compiler_Vertex__object *ASE_Compiler_Cxx_Function_getParent(struct ASE_Compiler_Cxx_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getParent))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Function_setParent(struct ASE_Compiler_Cxx_Function__object *self, /*in*/ struct ASE_Compiler_Vertex__object *parent, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setParent))(self->d_object, parent, _exception);
}

struct ASE_Compiler_Vertex__array *ASE_Compiler_Cxx_Function_getChildren(struct ASE_Compiler_Cxx_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getChildren))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Function_setChildren(struct ASE_Compiler_Cxx_Function__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setChildren))(self->d_object, children, _exception);
}

void ASE_Compiler_Cxx_Function_addChildren(struct ASE_Compiler_Cxx_Function__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addChildren))(self->d_object, children, _exception);
}

void ASE_Compiler_Cxx_Function_removeChildren(struct ASE_Compiler_Cxx_Function__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->removeChildren))(self->d_object, children, _exception);
}

int32_t ASE_Compiler_Cxx_Function_getLineNumber(struct ASE_Compiler_Cxx_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getLineNumber))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Function_setLineNumber(struct ASE_Compiler_Cxx_Function__object *self, /*in*/ int32_t lineNumber, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setLineNumber))(self->d_object, lineNumber, _exception);
}

struct ASE_Compiler_Comment__array *ASE_Compiler_Cxx_Function_getComments(struct ASE_Compiler_Cxx_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getComments))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Function_setComments(struct ASE_Compiler_Cxx_Function__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setComments))(self->d_object, comments, _exception);
}

void ASE_Compiler_Cxx_Function_addComments(struct ASE_Compiler_Cxx_Function__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addComments))(self->d_object, comments, _exception);
}

void ASE_Compiler_Cxx_Function_removeComments(struct ASE_Compiler_Cxx_Function__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->removeComments))(self->d_object, comments, _exception);
}

int32_t ASE_Compiler_Cxx_Function_getReferenceCount(struct ASE_Compiler_Cxx_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getReferenceCount))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Function_addReference(struct ASE_Compiler_Cxx_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addReference))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Function_deleteReference(struct ASE_Compiler_Cxx_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->deleteReference))(self->d_object, _exception);
}

int ASE_Compiler_Cxx_Function_isSame(struct ASE_Compiler_Cxx_Function__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->isSame))(self->d_object, obj, _exception);
}

const char *ASE_Compiler_Cxx_Function_getClassName(struct ASE_Compiler_Cxx_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getClassName))(self->d_object, _exception);
}

const char *ASE_Compiler_Cxx_Function_getName(struct ASE_Compiler_Cxx_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getName))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Function_setName(struct ASE_Compiler_Cxx_Function__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setName))(self->d_object, name, _exception);
}

int ASE_Compiler_Cxx_Function_isInstanceOf(struct ASE_Compiler_Cxx_Function__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->isInstanceOf))(self->d_object, typeName, _exception);
}

struct ASE_BaseInterface__object *ASE_Compiler_Cxx_Function_getSuper(struct ASE_Compiler_Cxx_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getSuper))(self->d_object, _exception);
}

struct ASE_Compiler_Cxx_Vertex__object *ASE_Compiler_Cxx_Function_copy(struct ASE_Compiler_Cxx_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->copy))(self->d_object, _exception);
}

struct ASE_Compiler_Cxx_Type__object *ASE_Compiler_Cxx_Function_getType(struct ASE_Compiler_Cxx_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getType))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Function_setType(struct ASE_Compiler_Cxx_Function__object *self, /*in*/ struct ASE_Compiler_Cxx_Type__object *type, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setType))(self->d_object, type, _exception);
}

int ASE_Compiler_Cxx_Function_getStatic(struct ASE_Compiler_Cxx_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getStatic))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Function_setStatic(struct ASE_Compiler_Cxx_Function__object *self, /*in*/ int isStatic, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setStatic))(self->d_object, isStatic, _exception);
}

int ASE_Compiler_Cxx_Function_getExtern(struct ASE_Compiler_Cxx_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getExtern))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Function_setExtern(struct ASE_Compiler_Cxx_Function__object *self, /*in*/ int isExtern, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setExtern))(self->d_object, isExtern, _exception);
}

int ASE_Compiler_Cxx_Function_getTypedef(struct ASE_Compiler_Cxx_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getTypedef))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Function_setTypedef(struct ASE_Compiler_Cxx_Function__object *self, /*in*/ int isTypedef, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setTypedef))(self->d_object, isTypedef, _exception);
}

struct ASE_Compiler_Cxx_Initializer__object *ASE_Compiler_Cxx_Function_getInitializer(struct ASE_Compiler_Cxx_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getInitializer))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Function_setInitializer(struct ASE_Compiler_Cxx_Function__object *self, /*in*/ struct ASE_Compiler_Cxx_Initializer__object *initializer, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setInitializer))(self->d_object, initializer, _exception);
}

void ASE_Compiler_Cxx_Function_accept(struct ASE_Compiler_Cxx_Function__object *self, /*in*/ struct ASE_Compiler_Cxx_Visitor__object *visitor, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->accept))(self->d_object, visitor, _exception);
}

struct ASE_Compiler_Cxx_Parameter__array *ASE_Compiler_Cxx_Function_getParameters(struct ASE_Compiler_Cxx_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getParameters))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Function_setParameters(struct ASE_Compiler_Cxx_Function__object *self, /*in*/ struct ASE_Compiler_Cxx_Parameter__array *parameters, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setParameters))(self->d_object, parameters, _exception);
}

void ASE_Compiler_Cxx_Function_addParameters(struct ASE_Compiler_Cxx_Function__object *self, /*in*/ struct ASE_Compiler_Cxx_Parameter__array *parameters, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addParameters))(self->d_object, parameters, _exception);
}

void ASE_Compiler_Cxx_Function_removeParameters(struct ASE_Compiler_Cxx_Function__object *self, /*in*/ struct ASE_Compiler_Cxx_Parameter__array *parameters, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->removeParameters))(self->d_object, parameters, _exception);
}

int ASE_Compiler_Cxx_Function_getOptionalArguments(struct ASE_Compiler_Cxx_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getOptionalArguments))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Function_setOptionalArguments(struct ASE_Compiler_Cxx_Function__object *self, /*in*/ int optionalArguments, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setOptionalArguments))(self->d_object, optionalArguments, _exception);
}

struct ASE_Compiler_Cxx_CompoundStatement__object *ASE_Compiler_Cxx_Function_getBody(struct ASE_Compiler_Cxx_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getBody))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Function_setBody(struct ASE_Compiler_Cxx_Function__object *self, /*in*/ struct ASE_Compiler_Cxx_CompoundStatement__object *body, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setBody))(self->d_object, body, _exception);
}
