#ifndef included_ASE_Compiler_Cxx_Visitor_stub
#define included_ASE_Compiler_Cxx_Visitor_stub

#ifdef __cplusplus
extern "C" {
#endif

#ifndef included_ASE_Compiler_Cxx_Visitor
#include <ASE/Compiler/Cxx/Visitor_IOR.h>
#endif

/* ASE.Compiler.Cxx.Visitor.Visitor: Constructor and cast method */
void *ASE_Compiler_Cxx_Visitor_Visitor(/*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getReferenceCount:  Retrieve the intrinsic reference count of the underlying object */
int32_t ASE_Compiler_Cxx_Visitor_getReferenceCount(struct ASE_Compiler_Cxx_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.addReference:  Add one to the intrinsic reference count of the underlying object
 - Objects continue to exist as long as the reference count is positive
 - Clients should call this method whenever they create another ongoing reference to an object or interface */
void ASE_Compiler_Cxx_Visitor_addReference(struct ASE_Compiler_Cxx_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.deleteReference:  Decrease by one the intrinsic reference count of the underlying object
 - Delete the object if the reference count is non-positive
 - Clients should call this method whenever they remove a reference to an object or interface */
void ASE_Compiler_Cxx_Visitor_deleteReference(struct ASE_Compiler_Cxx_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isSame:  Return true if and only if <code>obj</code> refers to the same underlying object as this object */
int ASE_Compiler_Cxx_Visitor_isSame(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getClassName:  Return the type name of the underlying class object */
const char *ASE_Compiler_Cxx_Visitor_getClassName(struct ASE_Compiler_Cxx_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getName:  Retrieve the object name */
const char *ASE_Compiler_Cxx_Visitor_getName(struct ASE_Compiler_Cxx_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.setName:  Set the object name */
void ASE_Compiler_Cxx_Visitor_setName(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isInstanceOf:  Return <code>true</code> if this object is an instance of the specified type
 - This routine will return <code>true</code> if and only if a cast to the specified type would succeed */
int ASE_Compiler_Cxx_Visitor_isInstanceOf(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getSuper:  Retrieve an object with the parent interface
 IMPL: Obviously, this must be implemented in the IOR of each interface/class */
struct ASE_BaseInterface__object *ASE_Compiler_Cxx_Visitor_getSuper(struct ASE_Compiler_Cxx_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.getRepository:  Retrieve auxilliary ASTs */
struct ASE_Compiler_Vertex__array *ASE_Compiler_Cxx_Visitor_getRepository(struct ASE_Compiler_Cxx_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.setRepository:  Set auxilliary ASTs */
void ASE_Compiler_Cxx_Visitor_setRepository(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Vertex__array *repository, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.visitVertex:  */
void ASE_Compiler_Cxx_Visitor_visitVertex(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitSource:  */
void ASE_Compiler_Cxx_Visitor_visitSource(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Source__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitHeader:  */
void ASE_Compiler_Cxx_Visitor_visitHeader(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Header__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitPythonModule:  */
void ASE_Compiler_Cxx_Visitor_visitPythonModule(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_PythonModule__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitInclude:  */
void ASE_Compiler_Cxx_Visitor_visitInclude(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Include__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitDefine:  */
void ASE_Compiler_Cxx_Visitor_visitDefine(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Define__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitMacro:  */
void ASE_Compiler_Cxx_Visitor_visitMacro(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Macro__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitPreprocessorConditional:  */
void ASE_Compiler_Cxx_Visitor_visitPreprocessorConditional(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_PreprocessorConditional__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitType:  */
void ASE_Compiler_Cxx_Visitor_visitType(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Type__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitPointer:  */
void ASE_Compiler_Cxx_Visitor_visitPointer(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Pointer__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitStruct:  */
void ASE_Compiler_Cxx_Visitor_visitStruct(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Struct__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitBitField:  */
void ASE_Compiler_Cxx_Visitor_visitBitField(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_BitField__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitEnumeration:  */
void ASE_Compiler_Cxx_Visitor_visitEnumeration(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Enumeration__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitEnumerator:  */
void ASE_Compiler_Cxx_Visitor_visitEnumerator(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Enumerator__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitTypedef:  */
void ASE_Compiler_Cxx_Visitor_visitTypedef(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Typedef__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitGroup:  */
void ASE_Compiler_Cxx_Visitor_visitGroup(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Group__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitDeclarator:  */
void ASE_Compiler_Cxx_Visitor_visitDeclarator(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Declarator__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitDeclaratorGroup:  */
void ASE_Compiler_Cxx_Visitor_visitDeclaratorGroup(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_DeclaratorGroup__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitArray:  */
void ASE_Compiler_Cxx_Visitor_visitArray(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Array__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitFunction:  */
void ASE_Compiler_Cxx_Visitor_visitFunction(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Function__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitParameter:  */
void ASE_Compiler_Cxx_Visitor_visitParameter(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Parameter__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitDeclaration:  */
void ASE_Compiler_Cxx_Visitor_visitDeclaration(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Declaration__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitStatement:  */
void ASE_Compiler_Cxx_Visitor_visitStatement(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Statement__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitExpressionStatement:  */
void ASE_Compiler_Cxx_Visitor_visitExpressionStatement(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_ExpressionStatement__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitCompoundStatement:  */
void ASE_Compiler_Cxx_Visitor_visitCompoundStatement(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_CompoundStatement__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitIf:  */
void ASE_Compiler_Cxx_Visitor_visitIf(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_If__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitSwitch:  */
void ASE_Compiler_Cxx_Visitor_visitSwitch(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Switch__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitWhile:  */
void ASE_Compiler_Cxx_Visitor_visitWhile(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_While__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitFor:  */
void ASE_Compiler_Cxx_Visitor_visitFor(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_For__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitGoto:  */
void ASE_Compiler_Cxx_Visitor_visitGoto(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Goto__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitContinue:  */
void ASE_Compiler_Cxx_Visitor_visitContinue(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Continue__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitBreak:  */
void ASE_Compiler_Cxx_Visitor_visitBreak(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Break__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitReturn:  */
void ASE_Compiler_Cxx_Visitor_visitReturn(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Return__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitInitializer:  */
void ASE_Compiler_Cxx_Visitor_visitInitializer(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Initializer__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitExpression:  */
void ASE_Compiler_Cxx_Visitor_visitExpression(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Expression__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitAssignment:  */
void ASE_Compiler_Cxx_Visitor_visitAssignment(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Assignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitInclusiveOrAssignment:  */
void ASE_Compiler_Cxx_Visitor_visitInclusiveOrAssignment(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_InclusiveOrAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitExclusiveOrAssignment:  */
void ASE_Compiler_Cxx_Visitor_visitExclusiveOrAssignment(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_ExclusiveOrAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitAndAssignment:  */
void ASE_Compiler_Cxx_Visitor_visitAndAssignment(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_AndAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitLeftShiftAssignment:  */
void ASE_Compiler_Cxx_Visitor_visitLeftShiftAssignment(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_LeftShiftAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitRightShiftAssignment:  */
void ASE_Compiler_Cxx_Visitor_visitRightShiftAssignment(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_RightShiftAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitAdditionAssignment:  */
void ASE_Compiler_Cxx_Visitor_visitAdditionAssignment(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_AdditionAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitSubtractionAssignment:  */
void ASE_Compiler_Cxx_Visitor_visitSubtractionAssignment(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_SubtractionAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitMultiplicationAssignment:  */
void ASE_Compiler_Cxx_Visitor_visitMultiplicationAssignment(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_MultiplicationAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitDivisionAssignment:  */
void ASE_Compiler_Cxx_Visitor_visitDivisionAssignment(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_DivisionAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitModuloAssignment:  */
void ASE_Compiler_Cxx_Visitor_visitModuloAssignment(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_ModuloAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitLogicalOr:  */
void ASE_Compiler_Cxx_Visitor_visitLogicalOr(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_LogicalOr__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitLogicalAnd:  */
void ASE_Compiler_Cxx_Visitor_visitLogicalAnd(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_LogicalAnd__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitInclusiveOr:  */
void ASE_Compiler_Cxx_Visitor_visitInclusiveOr(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_InclusiveOr__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitExclusiveOr:  */
void ASE_Compiler_Cxx_Visitor_visitExclusiveOr(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_ExclusiveOr__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitAnd:  */
void ASE_Compiler_Cxx_Visitor_visitAnd(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_And__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitEquality:  */
void ASE_Compiler_Cxx_Visitor_visitEquality(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Equality__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitInequality:  */
void ASE_Compiler_Cxx_Visitor_visitInequality(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Inequality__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitLessThan:  */
void ASE_Compiler_Cxx_Visitor_visitLessThan(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_LessThan__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitGreaterThan:  */
void ASE_Compiler_Cxx_Visitor_visitGreaterThan(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_GreaterThan__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitLessThanOrEqual:  */
void ASE_Compiler_Cxx_Visitor_visitLessThanOrEqual(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_LessThanOrEqual__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitGreaterThanOrEqual:  */
void ASE_Compiler_Cxx_Visitor_visitGreaterThanOrEqual(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_GreaterThanOrEqual__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitLeftShift:  */
void ASE_Compiler_Cxx_Visitor_visitLeftShift(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_LeftShift__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitRightShift:  */
void ASE_Compiler_Cxx_Visitor_visitRightShift(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_RightShift__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitAddition:  */
void ASE_Compiler_Cxx_Visitor_visitAddition(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Addition__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitSubtraction:  */
void ASE_Compiler_Cxx_Visitor_visitSubtraction(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Subtraction__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitMultiplication:  */
void ASE_Compiler_Cxx_Visitor_visitMultiplication(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Multiplication__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitDivision:  */
void ASE_Compiler_Cxx_Visitor_visitDivision(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Division__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitModulo:  */
void ASE_Compiler_Cxx_Visitor_visitModulo(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Modulo__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitCast:  */
void ASE_Compiler_Cxx_Visitor_visitCast(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Cast__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitSizeof:  */
void ASE_Compiler_Cxx_Visitor_visitSizeof(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Sizeof__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitAddress:  */
void ASE_Compiler_Cxx_Visitor_visitAddress(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Address__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitIndirection:  */
void ASE_Compiler_Cxx_Visitor_visitIndirection(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Indirection__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitUnaryPlus:  */
void ASE_Compiler_Cxx_Visitor_visitUnaryPlus(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_UnaryPlus__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitUnaryMinus:  */
void ASE_Compiler_Cxx_Visitor_visitUnaryMinus(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_UnaryMinus__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitComplement:  */
void ASE_Compiler_Cxx_Visitor_visitComplement(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Complement__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitNegation:  */
void ASE_Compiler_Cxx_Visitor_visitNegation(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Negation__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitIncrement:  */
void ASE_Compiler_Cxx_Visitor_visitIncrement(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Increment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitStructReference:  */
void ASE_Compiler_Cxx_Visitor_visitStructReference(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_StructReference__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitArrayReference:  */
void ASE_Compiler_Cxx_Visitor_visitArrayReference(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_ArrayReference__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitFunctionCall:  */
void ASE_Compiler_Cxx_Visitor_visitFunctionCall(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_FunctionCall__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitVariable:  */
void ASE_Compiler_Cxx_Visitor_visitVariable(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Variable__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitConstant:  */
void ASE_Compiler_Cxx_Visitor_visitConstant(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Constant__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

#ifdef __cplusplus
}
#endif
#endif
