#ifndef included_ASE_Compiler_ParserException_stub
#define included_ASE_Compiler_ParserException_stub

#ifdef __cplusplus
extern "C" {
#endif

#ifndef included_ASE_Compiler_ParserException
#include <ASE/Compiler/ParserException_IOR.h>
#endif

/* ASE.Compiler.ParserException.ParserException: Constructor and cast method */
void *ASE_Compiler_ParserException_ParserException(/*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseException.getMessage:  Return the message associated with the exception. */
const char *ASE_Compiler_ParserException_getMessage(struct ASE_Compiler_ParserException__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseException.setMessage:  Set the message associated with the exception. */
void ASE_Compiler_ParserException_setMessage(struct ASE_Compiler_ParserException__object *self, /*in*/ const char *message, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseException.getStackTrace:  Returns formatted string containing the concatenation of all tracelines */
const char *ASE_Compiler_ParserException_getStackTrace(struct ASE_Compiler_ParserException__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseException.addStackLine:  Adds a line to the stack trace. */
void ASE_Compiler_ParserException_addStackLine(struct ASE_Compiler_ParserException__object *self, /*in*/ const char *line, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseException.addStackEntry:  Formats and adds an entry to the stack trace based on the file name, line number, and method name */
void ASE_Compiler_ParserException_addStackEntry(struct ASE_Compiler_ParserException__object *self, /*in*/ const char *filename, /*in*/ int32_t lineNumber, /*in*/ const char *methodName, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getReferenceCount:  Retrieve the intrinsic reference count of the underlying object */
int32_t ASE_Compiler_ParserException_getReferenceCount(struct ASE_Compiler_ParserException__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.addReference:  Add one to the intrinsic reference count of the underlying object
 - Objects continue to exist as long as the reference count is positive
 - Clients should call this method whenever they create another ongoing reference to an object or interface */
void ASE_Compiler_ParserException_addReference(struct ASE_Compiler_ParserException__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.deleteReference:  Decrease by one the intrinsic reference count of the underlying object
 - Delete the object if the reference count is non-positive
 - Clients should call this method whenever they remove a reference to an object or interface */
void ASE_Compiler_ParserException_deleteReference(struct ASE_Compiler_ParserException__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isSame:  Return true if and only if <code>obj</code> refers to the same underlying object as this object */
int ASE_Compiler_ParserException_isSame(struct ASE_Compiler_ParserException__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getClassName:  Return the type name of the underlying class object */
const char *ASE_Compiler_ParserException_getClassName(struct ASE_Compiler_ParserException__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getName:  Retrieve the object name */
const char *ASE_Compiler_ParserException_getName(struct ASE_Compiler_ParserException__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.setName:  Set the object name */
void ASE_Compiler_ParserException_setName(struct ASE_Compiler_ParserException__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isInstanceOf:  Return <code>true</code> if this object is an instance of the specified type
 - This routine will return <code>true</code> if and only if a cast to the specified type would succeed */
int ASE_Compiler_ParserException_isInstanceOf(struct ASE_Compiler_ParserException__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getSuper:  Retrieve an object with the parent interface
 IMPL: Obviously, this must be implemented in the IOR of each interface/class */
struct ASE_BaseInterface__object *ASE_Compiler_ParserException_getSuper(struct ASE_Compiler_ParserException__object *self, /*out*/ struct ASE_BaseException__object **_exception);

#ifdef __cplusplus
}
#endif
#endif
