#include <stdlib.h>

#ifndef included_ASE_Compiler_Python_ExceptionHandler_stub
#include "ASE/Compiler/Python/ExceptionHandler_Stub.h"
#endif

#ifndef included_ASE_ASEException
#include <ASE/ASEException_IOR.h>
#endif

#ifndef included_ASE_Loader
#include <ASE/Loader_IOR.h>
#endif

void *ASE_Compiler_Python_ExceptionHandler_ExceptionHandler(/*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  if (obj)
  {
    return (*(obj->d_epv->castObject))(obj, "ASE.Compiler.Python.ExceptionHandler", _exception);
  }
  else
  {
    const struct ASE_Compiler_Python_ExceptionHandler__external *(*_extFunc)(void);
    
    _extFunc = (const struct ASE_Compiler_Python_ExceptionHandler__external *(*)(void)) ASE_Loader__externals()->getStaticEPV(&_exception)->getClassMethodTable("ASE.Compiler.Python.ExceptionHandler", &_exception);
    return (*((*_extFunc)()->createObject))(_exception);
  }
}

struct ASE_Compiler_Vertex__object *ASE_Compiler_Python_ExceptionHandler_clone(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->clone))(self->d_object, _exception);
}

void ASE_Compiler_Python_ExceptionHandler_accept(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*in*/ struct ASE_Compiler_Visitor__object *visitor, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->accept))(self->d_object, visitor, _exception);
}

const char *ASE_Compiler_Python_ExceptionHandler_getIdentifier(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getIdentifier))(self->d_object, _exception);
}

void ASE_Compiler_Python_ExceptionHandler_setIdentifier(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*in*/ const char *identifier, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setIdentifier))(self->d_object, identifier, _exception);
}

struct ASE_Compiler_Attribute__array *ASE_Compiler_Python_ExceptionHandler_getAttributes(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getAttributes))(self->d_object, _exception);
}

void ASE_Compiler_Python_ExceptionHandler_setAttributes(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*in*/ struct ASE_Compiler_Attribute__array *attributes, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setAttributes))(self->d_object, attributes, _exception);
}

int ASE_Compiler_Python_ExceptionHandler_hasAttribute(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->hasAttribute))(self->d_object, name, _exception);
}

void ASE_Compiler_Python_ExceptionHandler_addAttribute(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*in*/ struct ASE_Compiler_Attribute__object *attribute, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addAttribute))(self->d_object, attribute, _exception);
}

void ASE_Compiler_Python_ExceptionHandler_deleteAttribute(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->deleteAttribute))(self->d_object, name, _exception);
}

struct ASE_Compiler_Attribute__object *ASE_Compiler_Python_ExceptionHandler_getAttribute(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getAttribute))(self->d_object, name, _exception);
}

struct ASE_Compiler_Vertex__object *ASE_Compiler_Python_ExceptionHandler_getParent(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getParent))(self->d_object, _exception);
}

void ASE_Compiler_Python_ExceptionHandler_setParent(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*in*/ struct ASE_Compiler_Vertex__object *parent, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setParent))(self->d_object, parent, _exception);
}

struct ASE_Compiler_Vertex__array *ASE_Compiler_Python_ExceptionHandler_getChildren(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getChildren))(self->d_object, _exception);
}

void ASE_Compiler_Python_ExceptionHandler_setChildren(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setChildren))(self->d_object, children, _exception);
}

void ASE_Compiler_Python_ExceptionHandler_addChildren(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addChildren))(self->d_object, children, _exception);
}

void ASE_Compiler_Python_ExceptionHandler_removeChildren(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->removeChildren))(self->d_object, children, _exception);
}

int32_t ASE_Compiler_Python_ExceptionHandler_getLineNumber(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getLineNumber))(self->d_object, _exception);
}

void ASE_Compiler_Python_ExceptionHandler_setLineNumber(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*in*/ int32_t lineNumber, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setLineNumber))(self->d_object, lineNumber, _exception);
}

struct ASE_Compiler_Comment__array *ASE_Compiler_Python_ExceptionHandler_getComments(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getComments))(self->d_object, _exception);
}

void ASE_Compiler_Python_ExceptionHandler_setComments(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setComments))(self->d_object, comments, _exception);
}

void ASE_Compiler_Python_ExceptionHandler_addComments(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addComments))(self->d_object, comments, _exception);
}

void ASE_Compiler_Python_ExceptionHandler_removeComments(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->removeComments))(self->d_object, comments, _exception);
}

int32_t ASE_Compiler_Python_ExceptionHandler_getReferenceCount(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getReferenceCount))(self->d_object, _exception);
}

void ASE_Compiler_Python_ExceptionHandler_addReference(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addReference))(self->d_object, _exception);
}

void ASE_Compiler_Python_ExceptionHandler_deleteReference(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->deleteReference))(self->d_object, _exception);
}

int ASE_Compiler_Python_ExceptionHandler_isSame(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->isSame))(self->d_object, obj, _exception);
}

const char *ASE_Compiler_Python_ExceptionHandler_getClassName(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getClassName))(self->d_object, _exception);
}

const char *ASE_Compiler_Python_ExceptionHandler_getName(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getName))(self->d_object, _exception);
}

void ASE_Compiler_Python_ExceptionHandler_setName(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setName))(self->d_object, name, _exception);
}

int ASE_Compiler_Python_ExceptionHandler_isInstanceOf(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->isInstanceOf))(self->d_object, typeName, _exception);
}

struct ASE_BaseInterface__object *ASE_Compiler_Python_ExceptionHandler_getSuper(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getSuper))(self->d_object, _exception);
}

struct ASE_Compiler_Python_Vertex__object *ASE_Compiler_Python_ExceptionHandler_copy(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->copy))(self->d_object, _exception);
}

struct ASE_Compiler_Python_Vertex__object *ASE_Compiler_Python_ExceptionHandler_getType(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getType))(self->d_object, _exception);
}

void ASE_Compiler_Python_ExceptionHandler_setType(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*in*/ struct ASE_Compiler_Python_Vertex__object *type, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setType))(self->d_object, type, _exception);
}

struct ASE_Compiler_Python_Vertex__object *ASE_Compiler_Python_ExceptionHandler_getVariable(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getVariable))(self->d_object, _exception);
}

void ASE_Compiler_Python_ExceptionHandler_setVariable(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*in*/ struct ASE_Compiler_Python_Vertex__object *variable, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setVariable))(self->d_object, variable, _exception);
}
