#ifndef included_ASE_Compiler_Python_Printer_stub
#define included_ASE_Compiler_Python_Printer_stub

#ifdef __cplusplus
extern "C" {
#endif

#ifndef included_ASE_Compiler_Python_Printer
#include <ASE/Compiler/Python/Printer_IOR.h>
#endif

/* ASE.Compiler.Python.Printer.Printer: Constructor and cast method */
void *ASE_Compiler_Python_Printer_Printer(/*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.getTab:  Retrieve the tab string */
const char *ASE_Compiler_Python_Printer_getTab(struct ASE_Compiler_Python_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.setTab:  Set the tab string */
void ASE_Compiler_Python_Printer_setTab(struct ASE_Compiler_Python_Printer__object *self, /*in*/ const char *tab, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.getIndentSize:  Retrieve the number of tabs of the current indent */
int32_t ASE_Compiler_Python_Printer_getIndentSize(struct ASE_Compiler_Python_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.setIndentSize:  Set the number of tabs of the current indent
   Throws an exception on a negative indent size */
void ASE_Compiler_Python_Printer_setIndentSize(struct ASE_Compiler_Python_Printer__object *self, /*in*/ int32_t indentSize, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.increaseIndent:  Increase the index size by one */
void ASE_Compiler_Python_Printer_increaseIndent(struct ASE_Compiler_Python_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.decreaseIndent:  Decrease the index size by one
   Throws an exception on a negative indent size */
void ASE_Compiler_Python_Printer_decreaseIndent(struct ASE_Compiler_Python_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.indent:  Output the current indent (the indent size in tabs) */
void ASE_Compiler_Python_Printer_indent(struct ASE_Compiler_Python_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.write:  Output a string */
void ASE_Compiler_Python_Printer_write(struct ASE_Compiler_Python_Printer__object *self, /*in*/ const char *s, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.println:  Output a string, properly indented and followed by a newline */
void ASE_Compiler_Python_Printer_println(struct ASE_Compiler_Python_Printer__object *self, /*in*/ const char *s, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.getRepository:  Retrieve auxilliary ASTs */
struct ASE_Compiler_Vertex__array *ASE_Compiler_Python_Printer_getRepository(struct ASE_Compiler_Python_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.setRepository:  Set auxilliary ASTs */
void ASE_Compiler_Python_Printer_setRepository(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Vertex__array *repository, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.visitVertex:  */
void ASE_Compiler_Python_Printer_visitVertex(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.getReverseEdges:  Retrieve the flag for reversing the orientation of edges in the traversal */
int ASE_Compiler_Python_Printer_getReverseEdges(struct ASE_Compiler_Python_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.setReverseEdges:  Set the flag for reversing the orientation of edges in the traversal */
void ASE_Compiler_Python_Printer_setReverseEdges(struct ASE_Compiler_Python_Printer__object *self, /*in*/ int reverseEdges, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.traverseVertex:  Traverse each edge of this vertex */
void ASE_Compiler_Python_Printer_traverseVertex(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.resetVertexNumbering:  Reset the vertex discovery and finish numbering */
void ASE_Compiler_Python_Printer_resetVertexNumbering(struct ASE_Compiler_Python_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.discoverVertex:  Mark a vertex as discovered and increment the count */
void ASE_Compiler_Python_Printer_discoverVertex(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.finishVertex:  Mark a vertex as finished and increment the count */
void ASE_Compiler_Python_Printer_finishVertex(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.getVerticesSeen:  Retrieve the list of vertices discovered */
struct ASE_Compiler_Vertex__array *ASE_Compiler_Python_Printer_getVerticesSeen(struct ASE_Compiler_Python_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.setVerticesSeen:  Set the list of vertices discovered */
void ASE_Compiler_Python_Printer_setVerticesSeen(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Vertex__array *seen, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.getVertexSeen:  Retrieve the vertex discovery state */
int ASE_Compiler_Python_Printer_getVertexSeen(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.setVertexSeen:  Set the vertex discovery state */
void ASE_Compiler_Python_Printer_setVertexSeen(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*in*/ int state, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getReferenceCount:  Retrieve the intrinsic reference count of the underlying object */
int32_t ASE_Compiler_Python_Printer_getReferenceCount(struct ASE_Compiler_Python_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.addReference:  Add one to the intrinsic reference count of the underlying object
 - Objects continue to exist as long as the reference count is positive
 - Clients should call this method whenever they create another ongoing reference to an object or interface */
void ASE_Compiler_Python_Printer_addReference(struct ASE_Compiler_Python_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.deleteReference:  Decrease by one the intrinsic reference count of the underlying object
 - Delete the object if the reference count is non-positive
 - Clients should call this method whenever they remove a reference to an object or interface */
void ASE_Compiler_Python_Printer_deleteReference(struct ASE_Compiler_Python_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isSame:  Return true if and only if <code>obj</code> refers to the same underlying object as this object */
int ASE_Compiler_Python_Printer_isSame(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getClassName:  Return the type name of the underlying class object */
const char *ASE_Compiler_Python_Printer_getClassName(struct ASE_Compiler_Python_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getName:  Retrieve the object name */
const char *ASE_Compiler_Python_Printer_getName(struct ASE_Compiler_Python_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.setName:  Set the object name */
void ASE_Compiler_Python_Printer_setName(struct ASE_Compiler_Python_Printer__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isInstanceOf:  Return <code>true</code> if this object is an instance of the specified type
 - This routine will return <code>true</code> if and only if a cast to the specified type would succeed */
int ASE_Compiler_Python_Printer_isInstanceOf(struct ASE_Compiler_Python_Printer__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getSuper:  Retrieve an object with the parent interface
 IMPL: Obviously, this must be implemented in the IOR of each interface/class */
struct ASE_BaseInterface__object *ASE_Compiler_Python_Printer_getSuper(struct ASE_Compiler_Python_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitAdd:  */
void ASE_Compiler_Python_Printer_visitAdd(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Add__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitAnd:  */
void ASE_Compiler_Python_Printer_visitAnd(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_And__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitAssAttr:  */
void ASE_Compiler_Python_Printer_visitAssAttr(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_AssAttr__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitAssList:  */
void ASE_Compiler_Python_Printer_visitAssList(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_AssList__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitAssName:  */
void ASE_Compiler_Python_Printer_visitAssName(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_AssName__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitAssTuple:  */
void ASE_Compiler_Python_Printer_visitAssTuple(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_AssTuple__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitAssign:  */
void ASE_Compiler_Python_Printer_visitAssign(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Assign__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitAugAssign:  */
void ASE_Compiler_Python_Printer_visitAugAssign(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_AugAssign__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitBitand:  */
void ASE_Compiler_Python_Printer_visitBitand(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Bitand__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitBitor:  */
void ASE_Compiler_Python_Printer_visitBitor(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Bitor__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitBitxor:  */
void ASE_Compiler_Python_Printer_visitBitxor(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Bitxor__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitBreak:  */
void ASE_Compiler_Python_Printer_visitBreak(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Break__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitCallFunc:  */
void ASE_Compiler_Python_Printer_visitCallFunc(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_CallFunc__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitClass:  */
void ASE_Compiler_Python_Printer_visitClass(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Class__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitCompare:  */
void ASE_Compiler_Python_Printer_visitCompare(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Compare__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitConst:  */
void ASE_Compiler_Python_Printer_visitConst(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Const__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitPyNone:  */
void ASE_Compiler_Python_Printer_visitPyNone(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_PyNone__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitContinue:  */
void ASE_Compiler_Python_Printer_visitContinue(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Continue__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitDict:  */
void ASE_Compiler_Python_Printer_visitDict(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Dict__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitDiscard:  */
void ASE_Compiler_Python_Printer_visitDiscard(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Discard__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitDiv:  */
void ASE_Compiler_Python_Printer_visitDiv(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Div__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitEllipsis:  */
void ASE_Compiler_Python_Printer_visitEllipsis(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Ellipsis__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitFor:  */
void ASE_Compiler_Python_Printer_visitFor(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_For__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitListCompFor:  */
void ASE_Compiler_Python_Printer_visitListCompFor(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_ListCompFor__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitFunction:  */
void ASE_Compiler_Python_Printer_visitFunction(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Function__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitLambda:  */
void ASE_Compiler_Python_Printer_visitLambda(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Lambda__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitGetAttr:  */
void ASE_Compiler_Python_Printer_visitGetAttr(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_GetAttr__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitGlobal:  */
void ASE_Compiler_Python_Printer_visitGlobal(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Global__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitIf:  */
void ASE_Compiler_Python_Printer_visitIf(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_If__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitListCompIf:  */
void ASE_Compiler_Python_Printer_visitListCompIf(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_ListCompIf__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitImport:  */
void ASE_Compiler_Python_Printer_visitImport(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Import__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitFrom:  */
void ASE_Compiler_Python_Printer_visitFrom(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_From__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitInvert:  */
void ASE_Compiler_Python_Printer_visitInvert(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Invert__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitKeyword:  */
void ASE_Compiler_Python_Printer_visitKeyword(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Keyword__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitLeftShift:  */
void ASE_Compiler_Python_Printer_visitLeftShift(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_LeftShift__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitList:  */
void ASE_Compiler_Python_Printer_visitList(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_List__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitListComp:  */
void ASE_Compiler_Python_Printer_visitListComp(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_ListComp__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitMod:  */
void ASE_Compiler_Python_Printer_visitMod(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Mod__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitModule:  */
void ASE_Compiler_Python_Printer_visitModule(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Module__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitMul:  */
void ASE_Compiler_Python_Printer_visitMul(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Mul__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitName:  */
void ASE_Compiler_Python_Printer_visitName(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Name__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitNot:  */
void ASE_Compiler_Python_Printer_visitNot(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Not__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitOr:  */
void ASE_Compiler_Python_Printer_visitOr(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Or__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitPass:  */
void ASE_Compiler_Python_Printer_visitPass(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Pass__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitPower:  */
void ASE_Compiler_Python_Printer_visitPower(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Power__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitPrint:  */
void ASE_Compiler_Python_Printer_visitPrint(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Print__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitPrintnl:  */
void ASE_Compiler_Python_Printer_visitPrintnl(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Printnl__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitRaise:  */
void ASE_Compiler_Python_Printer_visitRaise(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Raise__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitReturn:  */
void ASE_Compiler_Python_Printer_visitReturn(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Return__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitRightShift:  */
void ASE_Compiler_Python_Printer_visitRightShift(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_RightShift__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitSlice:  */
void ASE_Compiler_Python_Printer_visitSlice(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Slice__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitStmt:  */
void ASE_Compiler_Python_Printer_visitStmt(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Stmt__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitSub:  */
void ASE_Compiler_Python_Printer_visitSub(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Sub__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitSubscript:  */
void ASE_Compiler_Python_Printer_visitSubscript(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Subscript__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitTryExcept:  */
void ASE_Compiler_Python_Printer_visitTryExcept(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_TryExcept__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitTryFinally:  */
void ASE_Compiler_Python_Printer_visitTryFinally(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_TryFinally__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitTuple:  */
void ASE_Compiler_Python_Printer_visitTuple(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Tuple__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitUnaryAdd:  */
void ASE_Compiler_Python_Printer_visitUnaryAdd(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_UnaryAdd__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitUnarySub:  */
void ASE_Compiler_Python_Printer_visitUnarySub(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_UnarySub__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitWhile:  */
void ASE_Compiler_Python_Printer_visitWhile(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_While__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitYield:  */
void ASE_Compiler_Python_Printer_visitYield(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Yield__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.printDocComment:  */
void ASE_Compiler_Python_Printer_printDocComment(struct ASE_Compiler_Python_Printer__object *self, /*in*/ struct ASE_Compiler_Python_Vertex__object *node, /*out*/ struct ASE_BaseException__object **_exception);

#ifdef __cplusplus
}
#endif
#endif
