#include <stdlib.h>

#ifndef included_ASE_Compiler_Python_Visitor_stub
#include "ASE/Compiler/Python/Visitor_Stub.h"
#endif

#ifndef included_ASE_ASEException
#include <ASE/ASEException_IOR.h>
#endif

#ifndef included_ASE_Loader
#include <ASE/Loader_IOR.h>
#endif

void *ASE_Compiler_Python_Visitor_Visitor(/*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_Python_Visitor__object *_result = NULL;
  
  if (!obj)
  {
    struct ASE_ASEException__object *_local_exception = ASE_ASEException__externals()->createObject(NULL);
    
    _local_exception->d_epv->setMessage(_local_exception, "Interfaces require an argument for the constructor", _exception);
    if (_exception)
    {
      *_exception = (struct ASE_BaseException__object *) _local_exception;
    }
    return _result;
  }
  return (*(obj->d_epv->castObject))(obj, "ASE.Compiler.Python.Visitor", _exception);
}

int32_t ASE_Compiler_Python_Visitor_getReferenceCount(struct ASE_Compiler_Python_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getReferenceCount))(self->d_object, _exception);
}

void ASE_Compiler_Python_Visitor_addReference(struct ASE_Compiler_Python_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addReference))(self->d_object, _exception);
}

void ASE_Compiler_Python_Visitor_deleteReference(struct ASE_Compiler_Python_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->deleteReference))(self->d_object, _exception);
}

int ASE_Compiler_Python_Visitor_isSame(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->isSame))(self->d_object, obj, _exception);
}

const char *ASE_Compiler_Python_Visitor_getClassName(struct ASE_Compiler_Python_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getClassName))(self->d_object, _exception);
}

const char *ASE_Compiler_Python_Visitor_getName(struct ASE_Compiler_Python_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getName))(self->d_object, _exception);
}

void ASE_Compiler_Python_Visitor_setName(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setName))(self->d_object, name, _exception);
}

int ASE_Compiler_Python_Visitor_isInstanceOf(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->isInstanceOf))(self->d_object, typeName, _exception);
}

struct ASE_BaseInterface__object *ASE_Compiler_Python_Visitor_getSuper(struct ASE_Compiler_Python_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getSuper))(self->d_object, _exception);
}

struct ASE_Compiler_Vertex__array *ASE_Compiler_Python_Visitor_getRepository(struct ASE_Compiler_Python_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getRepository))(self->d_object, _exception);
}

void ASE_Compiler_Python_Visitor_setRepository(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Vertex__array *repository, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setRepository))(self->d_object, repository, _exception);
}

void ASE_Compiler_Python_Visitor_visitVertex(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitVertex))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Python_Visitor_visitAdd(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Add__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitAdd))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitAnd(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_And__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitAnd))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitAssAttr(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_AssAttr__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitAssAttr))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitAssList(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_AssList__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitAssList))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitAssName(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_AssName__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitAssName))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitAssTuple(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_AssTuple__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitAssTuple))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitAssign(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Assign__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitAssign))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitAugAssign(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_AugAssign__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitAugAssign))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitBitand(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Bitand__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitBitand))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitBitor(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Bitor__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitBitor))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitBitxor(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Bitxor__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitBitxor))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitBreak(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Break__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitBreak))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitCallFunc(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_CallFunc__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitCallFunc))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitClass(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Class__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitClass))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitCompare(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Compare__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitCompare))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitConst(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Const__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitConst))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitPyNone(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_PyNone__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitPyNone))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitContinue(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Continue__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitContinue))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitDict(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Dict__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitDict))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitDiscard(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Discard__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitDiscard))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitDiv(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Div__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitDiv))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitEllipsis(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Ellipsis__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitEllipsis))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitFor(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_For__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitFor))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitListCompFor(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_ListCompFor__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitListCompFor))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitFunction(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Function__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitFunction))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitLambda(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Lambda__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitLambda))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitGetAttr(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_GetAttr__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitGetAttr))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitGlobal(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Global__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitGlobal))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitIf(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_If__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitIf))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitListCompIf(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_ListCompIf__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitListCompIf))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitImport(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Import__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitImport))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitFrom(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_From__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitFrom))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitInvert(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Invert__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitInvert))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitKeyword(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Keyword__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitKeyword))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitLeftShift(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_LeftShift__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitLeftShift))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitList(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_List__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitList))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitListComp(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_ListComp__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitListComp))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitMod(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Mod__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitMod))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitModule(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Module__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitModule))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitMul(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Mul__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitMul))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitName(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Name__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitName))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitNot(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Not__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitNot))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitOr(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Or__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitOr))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitPass(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Pass__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitPass))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitPower(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Power__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitPower))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitPrint(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Print__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitPrint))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitPrintnl(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Printnl__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitPrintnl))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitRaise(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Raise__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitRaise))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitReturn(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Return__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitReturn))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitRightShift(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_RightShift__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitRightShift))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitSlice(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Slice__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitSlice))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitStmt(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Stmt__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitStmt))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitSub(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Sub__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitSub))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitSubscript(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Subscript__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitSubscript))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitTryExcept(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_TryExcept__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitTryExcept))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitTryFinally(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_TryFinally__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitTryFinally))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitTuple(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Tuple__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitTuple))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitUnaryAdd(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_UnaryAdd__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitUnaryAdd))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitUnarySub(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_UnarySub__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitUnarySub))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitWhile(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_While__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitWhile))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Visitor_visitYield(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Yield__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitYield))(self->d_object, node, _exception);
}
