#ifndef included_ASE_Compiler_SIDL_Iterator_stub
#define included_ASE_Compiler_SIDL_Iterator_stub

#ifdef __cplusplus
extern "C" {
#endif

#ifndef included_ASE_Compiler_SIDL_Iterator
#include <ASE/Compiler/SIDL/Iterator_IOR.h>
#endif

/* ASE.Compiler.SIDL.Iterator.Iterator: Constructor and cast method */
void *ASE_Compiler_SIDL_Iterator_Iterator(/*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.clone:  Return an empty object of the same type */
struct ASE_Compiler_Vertex__object *ASE_Compiler_SIDL_Iterator_clone(struct ASE_Compiler_SIDL_Iterator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.getIdentifier:  Retrieve the identifier associated with this vertex */
const char *ASE_Compiler_SIDL_Iterator_getIdentifier(struct ASE_Compiler_SIDL_Iterator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.setIdentifier:  Assign the identifier associated with this vertex */
void ASE_Compiler_SIDL_Iterator_setIdentifier(struct ASE_Compiler_SIDL_Iterator__object *self, /*in*/ const char *identifier, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.getAttributes:  Get attribute list for this element */
struct ASE_Compiler_Attribute__array *ASE_Compiler_SIDL_Iterator_getAttributes(struct ASE_Compiler_SIDL_Iterator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.setAttributes:  Set attribute list for this element */
void ASE_Compiler_SIDL_Iterator_setAttributes(struct ASE_Compiler_SIDL_Iterator__object *self, /*in*/ struct ASE_Compiler_Attribute__array *attributes, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.hasAttribute:  Determine whether an attribute is present on this vertex */
int ASE_Compiler_SIDL_Iterator_hasAttribute(struct ASE_Compiler_SIDL_Iterator__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.addAttribute:  Add attribute to this vertex */
void ASE_Compiler_SIDL_Iterator_addAttribute(struct ASE_Compiler_SIDL_Iterator__object *self, /*in*/ struct ASE_Compiler_Attribute__object *attribute, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.deleteAttribute:  Remove an attribute on this vertex
   Throws an exception if the attribute does not exist */
void ASE_Compiler_SIDL_Iterator_deleteAttribute(struct ASE_Compiler_SIDL_Iterator__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.getAttribute:  Get an attribute on this vertex
   Throws an exception if the attribute does not exist */
struct ASE_Compiler_Attribute__object *ASE_Compiler_SIDL_Iterator_getAttribute(struct ASE_Compiler_SIDL_Iterator__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.getParent:  Retrieve the parent of this vertex */
struct ASE_Compiler_Vertex__object *ASE_Compiler_SIDL_Iterator_getParent(struct ASE_Compiler_SIDL_Iterator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.setParent:  Assign the parent of this vertex */
void ASE_Compiler_SIDL_Iterator_setParent(struct ASE_Compiler_SIDL_Iterator__object *self, /*in*/ struct ASE_Compiler_Vertex__object *parent, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.getChildren:  Retrieve the children of this vertex */
struct ASE_Compiler_Vertex__array *ASE_Compiler_SIDL_Iterator_getChildren(struct ASE_Compiler_SIDL_Iterator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.setChildren:  Set the children of this vertex */
void ASE_Compiler_SIDL_Iterator_setChildren(struct ASE_Compiler_SIDL_Iterator__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.addChildren:  Add children to this vertex (duplicates allowed) */
void ASE_Compiler_SIDL_Iterator_addChildren(struct ASE_Compiler_SIDL_Iterator__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.removeChildren:  Remove children from this vertex
   Throws an exception if any child does not exist */
void ASE_Compiler_SIDL_Iterator_removeChildren(struct ASE_Compiler_SIDL_Iterator__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.getLineNumber:  Retrieve the line number associated with this vertex */
int32_t ASE_Compiler_SIDL_Iterator_getLineNumber(struct ASE_Compiler_SIDL_Iterator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.setLineNumber:  Set the line number associated with this vertex */
void ASE_Compiler_SIDL_Iterator_setLineNumber(struct ASE_Compiler_SIDL_Iterator__object *self, /*in*/ int32_t lineNumber, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.getComments:  Retrieve the comments of this vertex */
struct ASE_Compiler_Comment__array *ASE_Compiler_SIDL_Iterator_getComments(struct ASE_Compiler_SIDL_Iterator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.setComments:  Set the children of this vertex */
void ASE_Compiler_SIDL_Iterator_setComments(struct ASE_Compiler_SIDL_Iterator__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.addComments:  Add comments to this vertex (duplicates allowed) */
void ASE_Compiler_SIDL_Iterator_addComments(struct ASE_Compiler_SIDL_Iterator__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.removeComments:  Remove comments from this vertex
   Throws an exception if a comment does not exist */
void ASE_Compiler_SIDL_Iterator_removeComments(struct ASE_Compiler_SIDL_Iterator__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getReferenceCount:  Retrieve the intrinsic reference count of the underlying object */
int32_t ASE_Compiler_SIDL_Iterator_getReferenceCount(struct ASE_Compiler_SIDL_Iterator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.addReference:  Add one to the intrinsic reference count of the underlying object
 - Objects continue to exist as long as the reference count is positive
 - Clients should call this method whenever they create another ongoing reference to an object or interface */
void ASE_Compiler_SIDL_Iterator_addReference(struct ASE_Compiler_SIDL_Iterator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.deleteReference:  Decrease by one the intrinsic reference count of the underlying object
 - Delete the object if the reference count is non-positive
 - Clients should call this method whenever they remove a reference to an object or interface */
void ASE_Compiler_SIDL_Iterator_deleteReference(struct ASE_Compiler_SIDL_Iterator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isSame:  Return true if and only if <code>obj</code> refers to the same underlying object as this object */
int ASE_Compiler_SIDL_Iterator_isSame(struct ASE_Compiler_SIDL_Iterator__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getClassName:  Return the type name of the underlying class object */
const char *ASE_Compiler_SIDL_Iterator_getClassName(struct ASE_Compiler_SIDL_Iterator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getName:  Retrieve the object name */
const char *ASE_Compiler_SIDL_Iterator_getName(struct ASE_Compiler_SIDL_Iterator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.setName:  Set the object name */
void ASE_Compiler_SIDL_Iterator_setName(struct ASE_Compiler_SIDL_Iterator__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isInstanceOf:  Return <code>true</code> if this object is an instance of the specified type
 - This routine will return <code>true</code> if and only if a cast to the specified type would succeed */
int ASE_Compiler_SIDL_Iterator_isInstanceOf(struct ASE_Compiler_SIDL_Iterator__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getSuper:  Retrieve an object with the parent interface
 IMPL: Obviously, this must be implemented in the IOR of each interface/class */
struct ASE_BaseInterface__object *ASE_Compiler_SIDL_Iterator_getSuper(struct ASE_Compiler_SIDL_Iterator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Vertex.getDependencies:  Retrieve nodes on which this node depends */
struct ASE_Compiler_SIDL_Vertex__array *ASE_Compiler_SIDL_Iterator_getDependencies(struct ASE_Compiler_SIDL_Iterator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Vertex.setDependencies:  Set nodes on which this node depends */
void ASE_Compiler_SIDL_Iterator_setDependencies(struct ASE_Compiler_SIDL_Iterator__object *self, /*in*/ struct ASE_Compiler_SIDL_Vertex__array *dependencies, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Vertex.addDependencies:  Add nodes on which this node depends */
void ASE_Compiler_SIDL_Iterator_addDependencies(struct ASE_Compiler_SIDL_Iterator__object *self, /*in*/ struct ASE_Compiler_SIDL_Vertex__array *dependencies, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Vertex.removeDependencies:  Remove nodes on which this node depends
   Throws an exception if a dependency does not exist */
void ASE_Compiler_SIDL_Iterator_removeDependencies(struct ASE_Compiler_SIDL_Iterator__object *self, /*in*/ struct ASE_Compiler_SIDL_Vertex__array *dependencies, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Type.copy:  Need to override this */
struct ASE_Compiler_SIDL_Vertex__object *ASE_Compiler_SIDL_Iterator_copy(struct ASE_Compiler_SIDL_Iterator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Type.getBaseType:  Get flag indicating whether this is a base type */
int ASE_Compiler_SIDL_Iterator_getBaseType(struct ASE_Compiler_SIDL_Iterator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Type.setBaseType:  Set flag indicating whether this is a base type */
void ASE_Compiler_SIDL_Iterator_setBaseType(struct ASE_Compiler_SIDL_Iterator__object *self, /*in*/ int baseType, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Iterator.accept:  Overridden to dispatch correctly */
void ASE_Compiler_SIDL_Iterator_accept(struct ASE_Compiler_SIDL_Iterator__object *self, /*in*/ struct ASE_Compiler_SIDL_Visitor__object *visitor, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Iterator.getFullIdentifier:  Need to override this to calculate the fully qualified type name */
const char *ASE_Compiler_SIDL_Iterator_getFullIdentifier(struct ASE_Compiler_SIDL_Iterator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Iterator.getType:  Retrieve the element type */
struct ASE_Compiler_SIDL_Type__object *ASE_Compiler_SIDL_Iterator_getType(struct ASE_Compiler_SIDL_Iterator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Iterator.setType:  Set the element type */
void ASE_Compiler_SIDL_Iterator_setType(struct ASE_Compiler_SIDL_Iterator__object *self, /*in*/ struct ASE_Compiler_SIDL_Type__object *type, /*out*/ struct ASE_BaseException__object **_exception);

#ifdef __cplusplus
}
#endif
#endif
