#ifndef included_ASE_Compiler_SIDL_Printer_stub
#define included_ASE_Compiler_SIDL_Printer_stub

#ifdef __cplusplus
extern "C" {
#endif

#ifndef included_ASE_Compiler_SIDL_Printer
#include <ASE/Compiler/SIDL/Printer_IOR.h>
#endif

/* ASE.Compiler.SIDL.Printer.Printer: Constructor and cast method */
void *ASE_Compiler_SIDL_Printer_Printer(/*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.getTab:  Retrieve the tab string */
const char *ASE_Compiler_SIDL_Printer_getTab(struct ASE_Compiler_SIDL_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.setTab:  Set the tab string */
void ASE_Compiler_SIDL_Printer_setTab(struct ASE_Compiler_SIDL_Printer__object *self, /*in*/ const char *tab, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.getIndentSize:  Retrieve the number of tabs of the current indent */
int32_t ASE_Compiler_SIDL_Printer_getIndentSize(struct ASE_Compiler_SIDL_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.setIndentSize:  Set the number of tabs of the current indent
   Throws an exception on a negative indent size */
void ASE_Compiler_SIDL_Printer_setIndentSize(struct ASE_Compiler_SIDL_Printer__object *self, /*in*/ int32_t indentSize, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.increaseIndent:  Increase the index size by one */
void ASE_Compiler_SIDL_Printer_increaseIndent(struct ASE_Compiler_SIDL_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.decreaseIndent:  Decrease the index size by one
   Throws an exception on a negative indent size */
void ASE_Compiler_SIDL_Printer_decreaseIndent(struct ASE_Compiler_SIDL_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.indent:  Output the current indent (the indent size in tabs) */
void ASE_Compiler_SIDL_Printer_indent(struct ASE_Compiler_SIDL_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.write:  Output a string */
void ASE_Compiler_SIDL_Printer_write(struct ASE_Compiler_SIDL_Printer__object *self, /*in*/ const char *s, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.println:  Output a string, properly indented and followed by a newline */
void ASE_Compiler_SIDL_Printer_println(struct ASE_Compiler_SIDL_Printer__object *self, /*in*/ const char *s, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.getRepository:  Retrieve auxilliary ASTs */
struct ASE_Compiler_Vertex__array *ASE_Compiler_SIDL_Printer_getRepository(struct ASE_Compiler_SIDL_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.setRepository:  Set auxilliary ASTs */
void ASE_Compiler_SIDL_Printer_setRepository(struct ASE_Compiler_SIDL_Printer__object *self, /*in*/ struct ASE_Compiler_Vertex__array *repository, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.visitVertex:  */
void ASE_Compiler_SIDL_Printer_visitVertex(struct ASE_Compiler_SIDL_Printer__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Visitor.visitSpecification:  */
void ASE_Compiler_SIDL_Printer_visitSpecification(struct ASE_Compiler_SIDL_Printer__object *self, /*in*/ struct ASE_Compiler_SIDL_Specification__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.getReverseEdges:  Retrieve the flag for reversing the orientation of edges in the traversal */
int ASE_Compiler_SIDL_Printer_getReverseEdges(struct ASE_Compiler_SIDL_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.setReverseEdges:  Set the flag for reversing the orientation of edges in the traversal */
void ASE_Compiler_SIDL_Printer_setReverseEdges(struct ASE_Compiler_SIDL_Printer__object *self, /*in*/ int reverseEdges, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.traverseVertex:  Traverse each edge of this vertex */
void ASE_Compiler_SIDL_Printer_traverseVertex(struct ASE_Compiler_SIDL_Printer__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.resetVertexNumbering:  Reset the vertex discovery and finish numbering */
void ASE_Compiler_SIDL_Printer_resetVertexNumbering(struct ASE_Compiler_SIDL_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.discoverVertex:  Mark a vertex as discovered and increment the count */
void ASE_Compiler_SIDL_Printer_discoverVertex(struct ASE_Compiler_SIDL_Printer__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.finishVertex:  Mark a vertex as finished and increment the count */
void ASE_Compiler_SIDL_Printer_finishVertex(struct ASE_Compiler_SIDL_Printer__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.getVerticesSeen:  Retrieve the list of vertices discovered */
struct ASE_Compiler_Vertex__array *ASE_Compiler_SIDL_Printer_getVerticesSeen(struct ASE_Compiler_SIDL_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.setVerticesSeen:  Set the list of vertices discovered */
void ASE_Compiler_SIDL_Printer_setVerticesSeen(struct ASE_Compiler_SIDL_Printer__object *self, /*in*/ struct ASE_Compiler_Vertex__array *seen, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.getVertexSeen:  Retrieve the vertex discovery state */
int ASE_Compiler_SIDL_Printer_getVertexSeen(struct ASE_Compiler_SIDL_Printer__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.setVertexSeen:  Set the vertex discovery state */
void ASE_Compiler_SIDL_Printer_setVertexSeen(struct ASE_Compiler_SIDL_Printer__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*in*/ int state, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getReferenceCount:  Retrieve the intrinsic reference count of the underlying object */
int32_t ASE_Compiler_SIDL_Printer_getReferenceCount(struct ASE_Compiler_SIDL_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.addReference:  Add one to the intrinsic reference count of the underlying object
 - Objects continue to exist as long as the reference count is positive
 - Clients should call this method whenever they create another ongoing reference to an object or interface */
void ASE_Compiler_SIDL_Printer_addReference(struct ASE_Compiler_SIDL_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.deleteReference:  Decrease by one the intrinsic reference count of the underlying object
 - Delete the object if the reference count is non-positive
 - Clients should call this method whenever they remove a reference to an object or interface */
void ASE_Compiler_SIDL_Printer_deleteReference(struct ASE_Compiler_SIDL_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isSame:  Return true if and only if <code>obj</code> refers to the same underlying object as this object */
int ASE_Compiler_SIDL_Printer_isSame(struct ASE_Compiler_SIDL_Printer__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getClassName:  Return the type name of the underlying class object */
const char *ASE_Compiler_SIDL_Printer_getClassName(struct ASE_Compiler_SIDL_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getName:  Retrieve the object name */
const char *ASE_Compiler_SIDL_Printer_getName(struct ASE_Compiler_SIDL_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.setName:  Set the object name */
void ASE_Compiler_SIDL_Printer_setName(struct ASE_Compiler_SIDL_Printer__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isInstanceOf:  Return <code>true</code> if this object is an instance of the specified type
 - This routine will return <code>true</code> if and only if a cast to the specified type would succeed */
int ASE_Compiler_SIDL_Printer_isInstanceOf(struct ASE_Compiler_SIDL_Printer__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getSuper:  Retrieve an object with the parent interface
 IMPL: Obviously, this must be implemented in the IOR of each interface/class */
struct ASE_BaseInterface__object *ASE_Compiler_SIDL_Printer_getSuper(struct ASE_Compiler_SIDL_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Printer.visitPackage:  */
void ASE_Compiler_SIDL_Printer_visitPackage(struct ASE_Compiler_SIDL_Printer__object *self, /*in*/ struct ASE_Compiler_SIDL_Package__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Printer.visitType:  */
void ASE_Compiler_SIDL_Printer_visitType(struct ASE_Compiler_SIDL_Printer__object *self, /*in*/ struct ASE_Compiler_SIDL_Type__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Printer.visitTypeUniverse:  */
void ASE_Compiler_SIDL_Printer_visitTypeUniverse(struct ASE_Compiler_SIDL_Printer__object *self, /*in*/ struct ASE_Compiler_SIDL_TypeUniverse__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Printer.visitEnumeration:  */
void ASE_Compiler_SIDL_Printer_visitEnumeration(struct ASE_Compiler_SIDL_Printer__object *self, /*in*/ struct ASE_Compiler_SIDL_Enumeration__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Printer.visitEnumerator:  */
void ASE_Compiler_SIDL_Printer_visitEnumerator(struct ASE_Compiler_SIDL_Printer__object *self, /*in*/ struct ASE_Compiler_SIDL_Enumerator__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Printer.visitArray:  */
void ASE_Compiler_SIDL_Printer_visitArray(struct ASE_Compiler_SIDL_Printer__object *self, /*in*/ struct ASE_Compiler_SIDL_Array__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Printer.visitIterator:  */
void ASE_Compiler_SIDL_Printer_visitIterator(struct ASE_Compiler_SIDL_Printer__object *self, /*in*/ struct ASE_Compiler_SIDL_Iterator__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Printer.visitInterface:  */
void ASE_Compiler_SIDL_Printer_visitInterface(struct ASE_Compiler_SIDL_Printer__object *self, /*in*/ struct ASE_Compiler_SIDL_Interface__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Printer.visitClass:  */
void ASE_Compiler_SIDL_Printer_visitClass(struct ASE_Compiler_SIDL_Printer__object *self, /*in*/ struct ASE_Compiler_SIDL_Class__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Printer.visitParameter:  */
void ASE_Compiler_SIDL_Printer_visitParameter(struct ASE_Compiler_SIDL_Printer__object *self, /*in*/ struct ASE_Compiler_SIDL_Parameter__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Printer.visitMethod:  */
void ASE_Compiler_SIDL_Printer_visitMethod(struct ASE_Compiler_SIDL_Printer__object *self, /*in*/ struct ASE_Compiler_SIDL_Method__object *node, /*out*/ struct ASE_BaseException__object **_exception);

#ifdef __cplusplus
}
#endif
#endif
