#ifndef included_ASE_Compiler_SIDL_Visitor_stub
#define included_ASE_Compiler_SIDL_Visitor_stub

#ifdef __cplusplus
extern "C" {
#endif

#ifndef included_ASE_Compiler_SIDL_Visitor
#include <ASE/Compiler/SIDL/Visitor_IOR.h>
#endif

/* ASE.Compiler.SIDL.Visitor.Visitor: Constructor and cast method */
void *ASE_Compiler_SIDL_Visitor_Visitor(/*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getReferenceCount:  Retrieve the intrinsic reference count of the underlying object */
int32_t ASE_Compiler_SIDL_Visitor_getReferenceCount(struct ASE_Compiler_SIDL_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.addReference:  Add one to the intrinsic reference count of the underlying object
 - Objects continue to exist as long as the reference count is positive
 - Clients should call this method whenever they create another ongoing reference to an object or interface */
void ASE_Compiler_SIDL_Visitor_addReference(struct ASE_Compiler_SIDL_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.deleteReference:  Decrease by one the intrinsic reference count of the underlying object
 - Delete the object if the reference count is non-positive
 - Clients should call this method whenever they remove a reference to an object or interface */
void ASE_Compiler_SIDL_Visitor_deleteReference(struct ASE_Compiler_SIDL_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isSame:  Return true if and only if <code>obj</code> refers to the same underlying object as this object */
int ASE_Compiler_SIDL_Visitor_isSame(struct ASE_Compiler_SIDL_Visitor__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getClassName:  Return the type name of the underlying class object */
const char *ASE_Compiler_SIDL_Visitor_getClassName(struct ASE_Compiler_SIDL_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getName:  Retrieve the object name */
const char *ASE_Compiler_SIDL_Visitor_getName(struct ASE_Compiler_SIDL_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.setName:  Set the object name */
void ASE_Compiler_SIDL_Visitor_setName(struct ASE_Compiler_SIDL_Visitor__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isInstanceOf:  Return <code>true</code> if this object is an instance of the specified type
 - This routine will return <code>true</code> if and only if a cast to the specified type would succeed */
int ASE_Compiler_SIDL_Visitor_isInstanceOf(struct ASE_Compiler_SIDL_Visitor__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getSuper:  Retrieve an object with the parent interface
 IMPL: Obviously, this must be implemented in the IOR of each interface/class */
struct ASE_BaseInterface__object *ASE_Compiler_SIDL_Visitor_getSuper(struct ASE_Compiler_SIDL_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.getRepository:  Retrieve auxilliary ASTs */
struct ASE_Compiler_Vertex__array *ASE_Compiler_SIDL_Visitor_getRepository(struct ASE_Compiler_SIDL_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.setRepository:  Set auxilliary ASTs */
void ASE_Compiler_SIDL_Visitor_setRepository(struct ASE_Compiler_SIDL_Visitor__object *self, /*in*/ struct ASE_Compiler_Vertex__array *repository, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.visitVertex:  */
void ASE_Compiler_SIDL_Visitor_visitVertex(struct ASE_Compiler_SIDL_Visitor__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Visitor.visitSpecification:  */
void ASE_Compiler_SIDL_Visitor_visitSpecification(struct ASE_Compiler_SIDL_Visitor__object *self, /*in*/ struct ASE_Compiler_SIDL_Specification__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Visitor.visitPackage:  */
void ASE_Compiler_SIDL_Visitor_visitPackage(struct ASE_Compiler_SIDL_Visitor__object *self, /*in*/ struct ASE_Compiler_SIDL_Package__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Visitor.visitType:  */
void ASE_Compiler_SIDL_Visitor_visitType(struct ASE_Compiler_SIDL_Visitor__object *self, /*in*/ struct ASE_Compiler_SIDL_Type__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Visitor.visitTypeUniverse:  */
void ASE_Compiler_SIDL_Visitor_visitTypeUniverse(struct ASE_Compiler_SIDL_Visitor__object *self, /*in*/ struct ASE_Compiler_SIDL_TypeUniverse__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Visitor.visitEnumeration:  */
void ASE_Compiler_SIDL_Visitor_visitEnumeration(struct ASE_Compiler_SIDL_Visitor__object *self, /*in*/ struct ASE_Compiler_SIDL_Enumeration__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Visitor.visitEnumerator:  */
void ASE_Compiler_SIDL_Visitor_visitEnumerator(struct ASE_Compiler_SIDL_Visitor__object *self, /*in*/ struct ASE_Compiler_SIDL_Enumerator__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Visitor.visitArray:  */
void ASE_Compiler_SIDL_Visitor_visitArray(struct ASE_Compiler_SIDL_Visitor__object *self, /*in*/ struct ASE_Compiler_SIDL_Array__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Visitor.visitIterator:  */
void ASE_Compiler_SIDL_Visitor_visitIterator(struct ASE_Compiler_SIDL_Visitor__object *self, /*in*/ struct ASE_Compiler_SIDL_Iterator__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Visitor.visitInterface:  */
void ASE_Compiler_SIDL_Visitor_visitInterface(struct ASE_Compiler_SIDL_Visitor__object *self, /*in*/ struct ASE_Compiler_SIDL_Interface__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Visitor.visitClass:  */
void ASE_Compiler_SIDL_Visitor_visitClass(struct ASE_Compiler_SIDL_Visitor__object *self, /*in*/ struct ASE_Compiler_SIDL_Class__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Visitor.visitParameter:  */
void ASE_Compiler_SIDL_Visitor_visitParameter(struct ASE_Compiler_SIDL_Visitor__object *self, /*in*/ struct ASE_Compiler_SIDL_Parameter__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Visitor.visitMethod:  */
void ASE_Compiler_SIDL_Visitor_visitMethod(struct ASE_Compiler_SIDL_Visitor__object *self, /*in*/ struct ASE_Compiler_SIDL_Method__object *node, /*out*/ struct ASE_BaseException__object **_exception);

#ifdef __cplusplus
}
#endif
#endif
