#ifndef included_ASE_Compiler_SkeletonGenerator_stub
#define included_ASE_Compiler_SkeletonGenerator_stub

#ifdef __cplusplus
extern "C" {
#endif

#ifndef included_ASE_Compiler_SkeletonGenerator
#include <ASE/Compiler/SkeletonGenerator_IOR.h>
#endif

/* ASE.Compiler.SkeletonGenerator.SkeletonGenerator: Constructor and cast method */
void *ASE_Compiler_SkeletonGenerator_SkeletonGenerator(/*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getReferenceCount:  Retrieve the intrinsic reference count of the underlying object */
int32_t ASE_Compiler_SkeletonGenerator_getReferenceCount(struct ASE_Compiler_SkeletonGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.addReference:  Add one to the intrinsic reference count of the underlying object
 - Objects continue to exist as long as the reference count is positive
 - Clients should call this method whenever they create another ongoing reference to an object or interface */
void ASE_Compiler_SkeletonGenerator_addReference(struct ASE_Compiler_SkeletonGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.deleteReference:  Decrease by one the intrinsic reference count of the underlying object
 - Delete the object if the reference count is non-positive
 - Clients should call this method whenever they remove a reference to an object or interface */
void ASE_Compiler_SkeletonGenerator_deleteReference(struct ASE_Compiler_SkeletonGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isSame:  Return true if and only if <code>obj</code> refers to the same underlying object as this object */
int ASE_Compiler_SkeletonGenerator_isSame(struct ASE_Compiler_SkeletonGenerator__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getClassName:  Return the type name of the underlying class object */
const char *ASE_Compiler_SkeletonGenerator_getClassName(struct ASE_Compiler_SkeletonGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getName:  Retrieve the object name */
const char *ASE_Compiler_SkeletonGenerator_getName(struct ASE_Compiler_SkeletonGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.setName:  Set the object name */
void ASE_Compiler_SkeletonGenerator_setName(struct ASE_Compiler_SkeletonGenerator__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isInstanceOf:  Return <code>true</code> if this object is an instance of the specified type
 - This routine will return <code>true</code> if and only if a cast to the specified type would succeed */
int ASE_Compiler_SkeletonGenerator_isInstanceOf(struct ASE_Compiler_SkeletonGenerator__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getSuper:  Retrieve an object with the parent interface
 IMPL: Obviously, this must be implemented in the IOR of each interface/class */
struct ASE_BaseInterface__object *ASE_Compiler_SkeletonGenerator_getSuper(struct ASE_Compiler_SkeletonGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.getRepository:  Retrieve auxilliary ASTs */
struct ASE_Compiler_Vertex__array *ASE_Compiler_SkeletonGenerator_getRepository(struct ASE_Compiler_SkeletonGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.setRepository:  Set auxilliary ASTs */
void ASE_Compiler_SkeletonGenerator_setRepository(struct ASE_Compiler_SkeletonGenerator__object *self, /*in*/ struct ASE_Compiler_Vertex__array *repository, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.visitVertex:  */
void ASE_Compiler_SkeletonGenerator_visitVertex(struct ASE_Compiler_SkeletonGenerator__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Generator.getSourceLanguages:  Retrieve the list of the languages in which ASTs are produced */
struct string__array *ASE_Compiler_SkeletonGenerator_getSourceLanguages(struct ASE_Compiler_SkeletonGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Generator.setSourceLanguages:  Set the list of the languages in which ASTs are produced */
void ASE_Compiler_SkeletonGenerator_setSourceLanguages(struct ASE_Compiler_SkeletonGenerator__object *self, /*in*/ struct string__array *outputLanguages, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Generator.getSource:  Retrieve the list of source ASTs for the given language
   Throw an exception if the language does not exist */
struct ASE_Compiler_Vertex__array *ASE_Compiler_SkeletonGenerator_getSource(struct ASE_Compiler_SkeletonGenerator__object *self, /*in*/ const char *language, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Generator.setSource:  Set the list of source ASTs for the given language
   Throw an exception if the language does not exist */
void ASE_Compiler_SkeletonGenerator_setSource(struct ASE_Compiler_SkeletonGenerator__object *self, /*in*/ const char *language, /*in*/ struct ASE_Compiler_Vertex__array *vertices, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Generator.addSource:  Add to the list of source ASTs for the given language
   Throw an exception if the language does not exist */
void ASE_Compiler_SkeletonGenerator_addSource(struct ASE_Compiler_SkeletonGenerator__object *self, /*in*/ const char *language, /*in*/ struct ASE_Compiler_Vertex__array *vertices, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Generator.removeSource:  Remove to the list of source ASTs for the given language
   Throw an exception if a vertex or language does not exist */
void ASE_Compiler_SkeletonGenerator_removeSource(struct ASE_Compiler_SkeletonGenerator__object *self, /*in*/ const char *language, /*in*/ struct ASE_Compiler_Vertex__array *vertices, /*out*/ struct ASE_BaseException__object **_exception);

#ifdef __cplusplus
}
#endif
#endif
