#ifndef included_ASE_Compiler_CompilerException
#define included_ASE_Compiler_CompilerException

#ifdef __cplusplus
extern "C" {
#endif

#include <sys/types.h>

/* These structures are used in this header */
struct ASE_Compiler_CompilerException__object;

struct ASE_Compiler_CompilerException__iterator;

struct ASE_Compiler_CompilerException__array;

struct ASE_BaseException__object;

struct ASE_BaseException__array;

#ifndef included_int
#include <int_IOR.h>
#endif

/* These structures are used in this header */
struct ASE_ASEException__object;

struct ASE_ASEException__iterator;

struct ASE_ASEException__array;

/* These structures are used in this header */
struct ASE_BaseInterface__object;

struct ASE_BaseInterface__iterator;

struct ASE_BaseInterface__array;

#ifndef included_string
#include <string_IOR.h>
#endif

/* These structures are used in this header */
struct ASE_BaseException__object;

struct ASE_BaseException__iterator;

struct ASE_BaseException__array;

#ifndef included_bool
#include <bool_IOR.h>
#endif

#ifndef included_ASE_ASEException
#include <ASE/ASEException_IOR.h>
#endif

/* The entry point vector (EPV) is the virtual function table for this interface */
struct ASE_Compiler_CompilerException__epv {
  /* ASE.Compiler.CompilerException.castObject: Builtin method */
  void *(*castObject)(struct ASE_Compiler_CompilerException__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.CompilerException.iterNext: Builtin method */
  struct ASE_Compiler_CompilerException__object *(*iterNext)(struct ASE_Compiler_CompilerException__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.CompilerException.destroyObject: Builtin method */
  void (*destroyObject)(struct ASE_Compiler_CompilerException__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.CompilerException.strObject: Builtin method */
  const char *(*strObject)(struct ASE_Compiler_CompilerException__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.CompilerException.CompilerException: Builtin method */
  void (*CompilerException)(/*in*/ struct ASE_Compiler_CompilerException__object *obj, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.CompilerException.CompilerException_: Builtin method */
  void (*CompilerException_)(struct ASE_Compiler_CompilerException__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseException.getMessage:  Return the message associated with the exception. */
  const char *(*getMessage)(struct ASE_Compiler_CompilerException__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseException.setMessage:  Set the message associated with the exception. */
  void (*setMessage)(struct ASE_Compiler_CompilerException__object *self, /*in*/ const char *message, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseException.getStackTrace:  Returns formatted string containing the concatenation of all tracelines */
  const char *(*getStackTrace)(struct ASE_Compiler_CompilerException__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseException.addStackLine:  Adds a line to the stack trace. */
  void (*addStackLine)(struct ASE_Compiler_CompilerException__object *self, /*in*/ const char *line, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseException.addStackEntry:  Formats and adds an entry to the stack trace based on the file name, line number, and method name */
  void (*addStackEntry)(struct ASE_Compiler_CompilerException__object *self, /*in*/ const char *filename, /*in*/ int32_t lineNumber, /*in*/ const char *methodName, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.getReferenceCount:  Retrieve the intrinsic reference count of the underlying object */
  int32_t (*getReferenceCount)(struct ASE_Compiler_CompilerException__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.addReference:  Add one to the intrinsic reference count of the underlying object
 - Objects continue to exist as long as the reference count is positive
 - Clients should call this method whenever they create another ongoing reference to an object or interface */
  void (*addReference)(struct ASE_Compiler_CompilerException__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.deleteReference:  Decrease by one the intrinsic reference count of the underlying object
 - Delete the object if the reference count is non-positive
 - Clients should call this method whenever they remove a reference to an object or interface */
  void (*deleteReference)(struct ASE_Compiler_CompilerException__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.isSame:  Return true if and only if <code>obj</code> refers to the same underlying object as this object */
  int (*isSame)(struct ASE_Compiler_CompilerException__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.getClassName:  Return the type name of the underlying class object */
  const char *(*getClassName)(struct ASE_Compiler_CompilerException__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.getName:  Retrieve the object name */
  const char *(*getName)(struct ASE_Compiler_CompilerException__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.setName:  Set the object name */
  void (*setName)(struct ASE_Compiler_CompilerException__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.isInstanceOf:  Return <code>true</code> if this object is an instance of the specified type
 - This routine will return <code>true</code> if and only if a cast to the specified type would succeed */
  int (*isInstanceOf)(struct ASE_Compiler_CompilerException__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.getSuper:  Retrieve an object with the parent interface
 IMPL: Obviously, this must be implemented in the IOR of each interface/class */
  struct ASE_BaseInterface__object *(*getSuper)(struct ASE_Compiler_CompilerException__object *self, /*out*/ struct ASE_BaseException__object **_exception);
};

/* The IOR object structure for this type */
struct ASE_Compiler_CompilerException__object {
  struct ASE_ASEException__object ase_aseexception;
  struct ASE_Compiler_CompilerException__epv *d_epv;
  struct ASE_Compiler_CompilerException__epv *d_oldEpv;
  void *d_object;
  void *d_data;
};

/* The IOR array structure for this type */
struct ASE_Compiler_CompilerException__array {
  struct ASE_Compiler_CompilerException__object **d_firstElement;
  int32_t *d_lower;
  int32_t *d_upper;
  int32_t *d_stride;
  int d_borrowed;
  int32_t d_dimen;
};

#ifndef included_ASE_BaseClass
#include <ASE/BaseClass_IOR.h>
#endif

/* The IOR iterator structure for this type */
struct ASE_Compiler_CompilerException__iterator {
  struct ASE_BaseClass__object ase_baseclass;
  void *iterator;
  void *objWrapper;
};

/* The entry points into the DLL containing this type */
struct ASE_Compiler_CompilerException__external {
  /* ASE.Compiler.CompilerException.createObject: Builtin method */
  struct ASE_Compiler_CompilerException__object *(*createObject)(/*out*/ struct ASE_BaseException__object **_exception);
  /* initObject:  */
  void (*initObject)(/*in*/ struct ASE_Compiler_CompilerException__object *self, /*in*/ void *obj, /*out*/ struct ASE_BaseException__object **_exception);
  /* finiObject:  */
  void (*finiObject)(/*in*/ struct ASE_Compiler_CompilerException__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* createArray: Create a dense array of the given dimension with specified index bounds
This array owns and manages its data
All object pointers are initialized to NULL */
  struct ASE_Compiler_CompilerException__array *(*createArray)(/*in*/ int32_t dimen, /*in*/ struct int__array *lower, /*in*/ struct int__array *upper, /*out*/ struct ASE_BaseException__object **_exception);
  /* borrowArray: Create an array using user-provided memory */
  struct ASE_Compiler_CompilerException__array *(*borrowArray)(/*in*/ int32_t dimen, /*in*/ struct int__array *lower, /*in*/ struct int__array *upper, /*in*/ struct int__array *stride, /*in*/ void *first, /*out*/ struct ASE_BaseException__object **_exception);
  /* destroyArray: Destroy the array (NULL arrays are ignored) */
  void (*destroyArray)(/*in*/ struct ASE_Compiler_CompilerException__array *array, /*out*/ struct ASE_BaseException__object **_exception);
  /* getDimen: Return the number of dimensions in the array
If the array pointer is NULL, zero is returned */
  int32_t (*getDimen)(/*in*/ struct ASE_Compiler_CompilerException__array *array, /*out*/ struct ASE_BaseException__object **_exception);
  /* getLower: Return the lower bound on dimension ind
If the array pointer is NULL or dimen is not a valid dimension, zero is returned */
  int32_t (*getLower)(/*in*/ struct ASE_Compiler_CompilerException__array *array, /*in*/ int32_t dimen, /*out*/ struct ASE_BaseException__object **_exception);
  /* getUpper: Return the upper bound on dimension ind
If the array pointer is NULL or dimen is not a valid dimension, -1 is returned */
  int32_t (*getUpper)(/*in*/ struct ASE_Compiler_CompilerException__array *array, /*in*/ int32_t dimen, /*out*/ struct ASE_BaseException__object **_exception);
  /* getElement: Get an element of a multi-dimensional array
This will use the indices provided up to the actual dimension of the array, ignoring extra indices
If the return value is non-NULL, the client owns one reference to the object/interface
The client must decrement the reference count when done with the reference */
  struct ASE_Compiler_CompilerException__object *(*getElement)(/*in*/ struct ASE_Compiler_CompilerException__array *array, /*in*/ struct int__array *indices, /*out*/ struct ASE_BaseException__object **_exception);
  /* getElement4: Get an element of a multi-dimensional array
This will use the indices provided up to the actual dimension of the array, ignoring extra indices
If the return value is non-NULL, the client owns one reference to the object/interface
The client must decrement the reference count when done with the reference */
  struct ASE_Compiler_CompilerException__object *(*getElement4)(/*in*/ struct ASE_Compiler_CompilerException__array *array, /*in*/ int32_t i1, /*in*/ int32_t i2, /*in*/ int32_t i3, /*in*/ int32_t i4, /*out*/ struct ASE_BaseException__object **_exception);
  /* setElement: Set an element of a multi-dimensional array
This will use the indices provided up to the actual dimension of the array, ignoring extra indices
If the incoming value is non-NULL, this function will increment the reference code of the object/interface
If it is overwriting a non-NULL pointer, the reference count of the object/interface being overwritten will be decremented */
  void (*setElement)(/*in*/ struct ASE_Compiler_CompilerException__array *array, /*in*/ struct int__array *indices, /*in*/ struct ASE_Compiler_CompilerException__object *value, /*out*/ struct ASE_BaseException__object **_exception);
  /* setElement4: Set an element of a multi-dimensional array
This will use the indices provided up to the actual dimension of the array, ignoring extra indices
If the incoming value is non-NULL, this function will increment the reference code of the object/interface
If it is overwriting a non-NULL pointer, the reference count of the object/interface being overwritten will be decremented */
  void (*setElement4)(/*in*/ struct ASE_Compiler_CompilerException__array *array, /*in*/ int32_t i1, /*in*/ int32_t i2, /*in*/ int32_t i3, /*in*/ int32_t i4, /*in*/ struct ASE_Compiler_CompilerException__object *value, /*out*/ struct ASE_BaseException__object **_exception);
  /* createIterator: Create an iterator */
  struct ASE_Compiler_CompilerException__iterator *(*createIterator)(/*in*/ void *iterator, /*in*/ void *iterNext, /*out*/ struct ASE_BaseException__object **_exception);
  /* destroyIterator: Destroy an iterator */
  void (*destroyIterator)(/*in*/ struct ASE_Compiler_CompilerException__iterator *self, /*out*/ struct ASE_BaseException__object **_exception);
};

/* This function, called upon loading the DLL, returns a pointer to the static structure of DLL entry points */
const struct ASE_Compiler_CompilerException__external *ASE_Compiler_CompilerException__externals(void);

#ifdef __cplusplus
}
#endif
#endif
