# Starting imports section
pass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.Attribute
import ASE.Compiler.Comment
import ASE.Compiler.CompilerException
import ASE.Compiler.Cxx.Vertex
import ASE.Compiler.Cxx.Visitor
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class Enumerator:
  '''
  A component of a C enumeration
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.isInitialized = 0
    self.value = 0
  
  def accept(self, visitor):
    '''
    Overridden to dispatch correctly
    '''
    visitor.visitEnumerator(self.__IORself)
  
  def copy(self):
    '''
    Need to override this
    '''
    root = ASE.Compiler.Cxx.Enumerator.Enumerator()
    root.setIdentifier(self.__IORself.getIdentifier())
    root.setAttributes(self.__IORself.getAttributes())
    root.setLineNumber(self.__IORself.getLineNumber())
    root.setComments(self.__IORself.getComments())
    root.setChildren([child.copy() for child in self.__IORself.getChildren()])
    [child.deleteReference() for child in root.getChildren()]
    root.setInitialized(self.__IORself.getInitialized())
    root.setValue(self.__IORself.getValue())
    root.addReference()
    return root
  
  def getInitialized(self):
    '''
    Retrieve the flag indicating whether the entry had an initializer
    '''
    return self.isInitialized
  
  def setInitialized(self, initialized):
    '''
    Set the flag indicating whether the entry had an initializer
    '''
    self.isInitialized = initialized
  
  def getValue(self):
    '''
    Retrieve the entry value
    '''
    return self.value
  
  def setValue(self, value):
    '''
    Set the entry value
    '''
    self.value = value
  # Ending class methods section
  pass
