# Starting imports section
pass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.Attribute
import ASE.Compiler.Comment
import ASE.Compiler.CompilerException
import ASE.Compiler.Cxx.Vertex
import ASE.Compiler.Cxx.Visitor
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class PreprocessorConditional:
  '''
  This represents a #if, #ifdef, or #ifndef
  The identifier is the conditional name, e.g. ifdef
  The children are the active code trees
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.branchExpression = None
    self.value = 0
    self.inactiveCode = None
  
  def accept(self, visitor):
    '''
    Overridden to dispatch correctly
    '''
    visitor.visitPreprocessorConditional(self.__IORself)
  
  def getBranchExpression(self):
    '''
    Retrieve the branch expression text
    '''
    return self.branchExpression
  
  def setBranchExpression(self, branchExpression):
    '''
    Set the branch expression text
    '''
    self.branchExpression = branchExpression
  
  def getValue(self):
    '''
    Retrieve the value of the branch expression
    '''
    return self.value
  
  def setValue(self, value):
    '''
    Set the value of the branch expression
    '''
    self.value = value
  
  def getInactiveCode(self):
    '''
    Retrieve the code bypassed by the jump
    '''
    return self.inactiveCode
  
  def setInactiveCode(self, inactiveCode):
    '''
    Set the code bypassed by the jump
    '''
    self.inactiveCode = inactiveCode
  # Ending class methods section
  pass
