# Starting imports section
pass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.Attribute
import ASE.Compiler.Comment
import ASE.Compiler.CompilerException
import ASE.Compiler.Cxx.Type
import ASE.Compiler.Cxx.Vertex
import ASE.Compiler.Cxx.Visitor
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class Struct:
  '''
  A C struct or union
  The children are structure entries if present
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.isUnion = 0
  
  def accept(self, visitor):
    '''
    Overridden to dispatch correctly
    '''
    visitor.visitStruct(self.__IORself)
  
  def copy(self):
    '''
    Need to override this
    '''
    root = ASE.Compiler.Cxx.Struct.Struct()
    root.setIdentifier(self.__IORself.getIdentifier())
    root.setAttributes(self.__IORself.getAttributes())
    root.setLineNumber(self.__IORself.getLineNumber())
    root.setComments(self.__IORself.getComments())
    root.setChildren([child.copy() for child in self.__IORself.getChildren()])
    [child.deleteReference() for child in root.getChildren()]
    root.setBaseType(self.__IORself.getBaseType())
    root.setConst(self.__IORself.getConst())
    root.setVolatile(self.__IORself.getVolatile())
    root.setUnion(self.__IORself.getUnion())
    root.addReference()
    return root
  
  def getUnion(self):
    '''
    Retrieve the flag indicating a union
    '''
    return self.isUnion
  
  def setUnion(self, isUnion):
    '''
    Set the flag indicating a union
    '''
    self.isUnion = isUnion
  # Ending class methods section
  pass
