# Starting imports section
pass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.Attribute
import ASE.Compiler.Comment
import ASE.Compiler.CompilerException
import ASE.Compiler.Cxx.Declaration
import ASE.Compiler.Cxx.Statement
import ASE.Compiler.Cxx.Visitor
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class CompoundStatement:
  '''
  A (possibly empty) set of C declarations and statements delimited by braces
  The enclosed statements are children
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.declarations = []
  
  def accept(self, visitor):
    '''
    Overridden to dispatch correctly
    '''
    visitor.visitCompoundStatement(self.__IORself)
  
  def getDeclarations(self):
    '''
    Retrieve the superclasses of this class
    '''
    return self.declarations
  
  def setDeclarations(self, declarations):
    '''
    Set the superclasses of this class
    '''
    self.declarations = list(declarations)
  
  def addDeclarations(self, declarations):
    '''
    Add superclasses to this class
    '''
    self.declarations.extend(declarations)
  
  def removeDeclarations(self, declarations):
    '''
    Remove superclasses from this class
    Throws an exception if a parent does not exist
    '''
    for declaration in declarations:
      if declaration in self.declarations:
        self.declarations.remove(declaration)
      else:
        e = ASE.Compiler.CompilerException()
        e.setMessage('Declaration does not exist: ' + declaration.getIdentifier())
        raise e
  # Ending class methods section
  pass
