# Starting imports section
pass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.Attribute
import ASE.Compiler.Comment
import ASE.Compiler.CompilerException
import ASE.Compiler.Cxx.Expression
import ASE.Compiler.Cxx.Statement
import ASE.Compiler.Cxx.Vertex
import ASE.Compiler.Cxx.Visitor
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class For:
  '''
  A C for statement
  The child is the iteration statement
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.initialization = None
    self.branch = None
    self.increment = None
  
  def accept(self, visitor):
    '''
    Overridden to dispatch correctly
    '''
    visitor.visitFor(self.__IORself)
  
  def copy(self):
    '''
    Need to override this
    '''
    root = ASE.Compiler.Cxx.For.For()
    root.setIdentifier(self.__IORself.getIdentifier())
    root.setAttributes(self.__IORself.getAttributes())
    root.setLineNumber(self.__IORself.getLineNumber())
    root.setComments(self.__IORself.getComments())
    root.setChildren([child.copy() for child in self.__IORself.getChildren()])
    [child.deleteReference() for child in root.getChildren()]
    if not (self.__IORself.getInitialization() is None):
      root.setInitialization(self.__IORself.getInitialization())
    if not (self.__IORself.getBranch() is None):
      root.setBranch(self.__IORself.getBranch())
    if not (self.__IORself.getIncrement() is None):
      root.setIncrement(self.__IORself.getIncrement())
    root.addReference()
    return root
  
  def getInitialization(self):
    '''
    Retrieve the initialization expression
    '''
    return self.initialization
  
  def setInitialization(self, initialization):
    '''
    Set the initialization expression
    '''
    self.initialization = initialization
  
  def getBranch(self):
    '''
    Retrieve the branch expression
    '''
    return self.branch
  
  def setBranch(self, branch):
    '''
    Set the branch expression
    '''
    self.branch = branch
  
  def getIncrement(self):
    '''
    Retrieve the increment expression
    '''
    return self.increment
  
  def setIncrement(self, increment):
    '''
    Set the increment expression
    '''
    self.increment = increment
  # Ending class methods section
  pass
