# Starting imports section
pass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.Attribute
import ASE.Compiler.Comment
import ASE.Compiler.CompilerException
import ASE.Compiler.Cxx.Vertex
import ASE.Compiler.Cxx.Visitor
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class Initializer:
  '''
  A C variable initializer
  The children are the initializer expressions
  If there are multiple children, this is a structure initializer
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.isList = 0
  
  def accept(self, visitor):
    '''
    Overridden to dispatch correctly
    '''
    visitor.visitInitializer(self.__IORself)
  
  def copy(self):
    '''
    Need to override this
    '''
    root = ASE.Compiler.Cxx.Initializer.Initializer()
    root.setIdentifier(self.__IORself.getIdentifier())
    root.setAttributes(self.__IORself.getAttributes())
    root.setLineNumber(self.__IORself.getLineNumber())
    root.setComments(self.__IORself.getComments())
    root.setChildren([child.copy() for child in self.__IORself.getChildren()])
    [child.deleteReference() for child in root.getChildren()]
    root.setList(self.__IORself.getList())
    root.addReference()
    return root
  
  def getList(self):
    '''
    Retrieve the flag for an initializer list
    '''
    return self.isList
  
  def setList(self, isList):
    '''
    Set the flag for an initializer list
    '''
    self.isList = isList
  # Ending class methods section
  pass
