#include <stdlib.h>

#include <string.h>

#ifndef included_ASE_Compiler_Cxx_DepthFirstVisitor
#include <ASE/Compiler/Cxx/DepthFirstVisitor_IOR.h>
#endif

#ifndef included_ASE_Loader
#include <ASE/Loader_IOR.h>
#endif

/* Initialization routine defined in the skeleton */
extern void ASE_Compiler_Cxx_DepthFirstVisitor__set_epv(struct ASE_Compiler_Cxx_DepthFirstVisitor__epv *epv, struct ASE_BaseException__object **_exception);

static const char *getClassName(struct ASE_Compiler_Cxx_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return strdup("ASE.Compiler.Cxx.DepthFirstVisitor");
}

#ifndef included_ASE_ASEException
#include <ASE/ASEException_IOR.h>
#endif

static void *castObject(struct ASE_Compiler_Cxx_DepthFirstVisitor__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  /* We are guaranteed here that the first member in any IOR is a ASE.BaseInterface object */
  struct ASE_Compiler_Cxx_DepthFirstVisitor__object *obj = ((struct ASE_BaseInterface__object *) self)->d_object;
  void *cast = NULL;
  
  if (!strcmp(name, "ASE.Compiler.Cxx.DepthFirstVisitor"))
  {
    cast = obj;
  }
  else
  if (!strcmp(name, "ASE.BaseClass"))
  {
    cast = (&obj->ase_baseclass);
  }
  else
  if (!strcmp(name, "ASE.BaseInterface"))
  {
    cast = (&(&obj->ase_baseclass)->ase_baseinterface);
  }
  else
  if (!strcmp(name, "ASE.Compiler.Cxx.Visitor"))
  {
    cast = (&obj->ase_compiler_cxx_visitor);
  }
  else
  if (!strcmp(name, "ASE.Compiler.Visitor"))
  {
    cast = (&(&obj->ase_compiler_cxx_visitor)->ase_compiler_visitor);
  }
  else
  if (!strcmp(name, "ASE.Compiler.Search"))
  {
    cast = (&obj->ase_compiler_search);
  }
  return cast;
}

static const char *strObject(struct ASE_Compiler_Cxx_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return "ASE.Compiler.Cxx.DepthFirstVisitor";
}

static void finiObject(/*in*/ struct ASE_Compiler_Cxx_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_BaseClass__object *parent = &self->ase_baseclass;
  const struct ASE_BaseClass__external *(*extFunc)(void) = (const struct ASE_BaseClass__external *(*)(void)) ASE_Loader__externals()->getStaticEPV(_exception)->getClassMethodTable("ASE.BaseClass", _exception);
  void (*parentFini)(/*in*/ struct ASE_BaseClass__object *, /*out*/ struct ASE_BaseException__object **_exception) = (extFunc())->finiObject;
  
  self->ase_compiler_cxx_visitor.d_epv = self->ase_compiler_cxx_visitor.d_oldEpv;
  self->ase_compiler_search.d_epv = self->ase_compiler_search.d_oldEpv;
  self->ase_baseclass.d_epv = self->ase_baseclass.d_oldEpv;
  (*(self->d_epv->DepthFirstVisitor_))(self, _exception);
  if (!parentFini)
  {
    struct ASE_ASEException__object *_local_exception = ASE_ASEException__externals()->createObject(NULL);
    
    _local_exception->d_epv->setMessage(_local_exception, "Unable to find finalizer for ASE.BaseClass", _exception);
    if (_exception)
    {
      *_exception = (struct ASE_BaseException__object *) _local_exception;
    }
    return;
  }
  (*parentFini)(parent, _exception);
}

static void destroyObject(struct ASE_Compiler_Cxx_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  finiObject(self->d_object, _exception);
  memset(self->d_object, 0, sizeof(struct ASE_Compiler_Cxx_DepthFirstVisitor__object));
  free(self->d_object);
}

static void initObject(/*in*/ struct ASE_Compiler_Cxx_DepthFirstVisitor__object *self, /*in*/ void *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_BaseClass__object *parent = &self->ase_baseclass;
  const struct ASE_BaseClass__external *(*extFunc)(void) = (const struct ASE_BaseClass__external *(*)(void)) ASE_Loader__externals()->getStaticEPV(_exception)->getClassMethodTable("ASE.BaseClass", _exception);
  void (*parentInit)(/*in*/ struct ASE_BaseClass__object *, /*in*/ void *, /*out*/ struct ASE_BaseException__object **_exception) = (extFunc())->initObject;
  static int epvInitialized = 0;
  static struct ASE_Compiler_Cxx_DepthFirstVisitor__epv ASE_Compiler_Cxx_DepthFirstVisitor_epv;
  static struct ASE_BaseClass__epv ASE_BaseClass_epv;
  static struct ASE_BaseInterface__epv ASE_BaseInterface_epv;
  static struct ASE_Compiler_Cxx_Visitor__epv ASE_Compiler_Cxx_Visitor_epv;
  static struct ASE_Compiler_Visitor__epv ASE_Compiler_Visitor_epv;
  static struct ASE_Compiler_Search__epv ASE_Compiler_Search_epv;
  
  if (!parentInit)
  {
    struct ASE_ASEException__object *_local_exception = ASE_ASEException__externals()->createObject(NULL);
    
    _local_exception->d_epv->setMessage(_local_exception, "Unable to find initializer for ASE.BaseClass", _exception);
    if (_exception)
    {
      *_exception = (struct ASE_BaseException__object *) _local_exception;
    }
    return;
  }
  (*parentInit)(parent, obj, _exception);
  if (!epvInitialized)
  {
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.castObject = (void *(*)(struct ASE_Compiler_Cxx_DepthFirstVisitor__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)) castObject;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.destroyObject = (void (*)(struct ASE_Compiler_Cxx_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) destroyObject;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.strObject = (const char *(*)(struct ASE_Compiler_Cxx_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) strObject;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.getClassName = (const char *(*)(struct ASE_Compiler_Cxx_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) getClassName;
    ASE_Compiler_Cxx_DepthFirstVisitor__set_epv(&ASE_Compiler_Cxx_DepthFirstVisitor_epv, _exception);
    /* Override class ASE.Compiler.Cxx.DepthFirstVisitor methods with those of superclass ASE.BaseClass */
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.getReferenceCount = (int32_t (*)(struct ASE_Compiler_Cxx_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_baseclass.d_epv->getReferenceCount;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.addReference = (void (*)(struct ASE_Compiler_Cxx_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_baseclass.d_epv->addReference;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.deleteReference = (void (*)(struct ASE_Compiler_Cxx_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_baseclass.d_epv->deleteReference;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.isSame = (int (*)(struct ASE_Compiler_Cxx_DepthFirstVisitor__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_baseclass.d_epv->isSame;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.getName = (const char *(*)(struct ASE_Compiler_Cxx_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_baseclass.d_epv->getName;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.setName = (void (*)(struct ASE_Compiler_Cxx_DepthFirstVisitor__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_baseclass.d_epv->setName;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.isInstanceOf = (int (*)(struct ASE_Compiler_Cxx_DepthFirstVisitor__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_baseclass.d_epv->isInstanceOf;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.getSuper = (struct ASE_BaseInterface__object *(*)(struct ASE_Compiler_Cxx_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_baseclass.d_epv->getSuper;
    /* Virtualize superclass ASE.BaseClass methods with those of class ASE.Compiler.Cxx.DepthFirstVisitor */
    ASE_BaseClass_epv.castObject = (void *(*)(struct ASE_BaseClass__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.castObject;
    ASE_BaseClass_epv.iterNext = (struct ASE_Compiler_Cxx_DepthFirstVisitor__object *(*)(struct ASE_BaseClass__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.iterNext;
    ASE_BaseClass_epv.destroyObject = (void (*)(struct ASE_BaseClass__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.destroyObject;
    ASE_BaseClass_epv.strObject = (const char *(*)(struct ASE_BaseClass__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.strObject;
    ASE_BaseClass_epv.getReferenceCount = (int32_t (*)(struct ASE_BaseClass__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.getReferenceCount;
    ASE_BaseClass_epv.addReference = (void (*)(struct ASE_BaseClass__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.addReference;
    ASE_BaseClass_epv.deleteReference = (void (*)(struct ASE_BaseClass__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.deleteReference;
    ASE_BaseClass_epv.isSame = (int (*)(struct ASE_BaseClass__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.isSame;
    ASE_BaseClass_epv.getClassName = (const char *(*)(struct ASE_BaseClass__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.getClassName;
    ASE_BaseClass_epv.getName = (const char *(*)(struct ASE_BaseClass__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.getName;
    ASE_BaseClass_epv.setName = (void (*)(struct ASE_BaseClass__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.setName;
    ASE_BaseClass_epv.isInstanceOf = (int (*)(struct ASE_BaseClass__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.isInstanceOf;
    ASE_BaseClass_epv.getSuper = (struct ASE_BaseInterface__object *(*)(struct ASE_BaseClass__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.getSuper;
    /* Initialize interface ASE.Compiler.Cxx.Visitor methods with those of class ASE.Compiler.Cxx.DepthFirstVisitor */
    ASE_Compiler_Cxx_Visitor_epv.castObject = (void *(*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.castObject;
    ASE_Compiler_Cxx_Visitor_epv.iterNext = (struct ASE_Compiler_Cxx_Visitor__object *(*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.iterNext;
    ASE_Compiler_Cxx_Visitor_epv.destroyObject = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.destroyObject;
    ASE_Compiler_Cxx_Visitor_epv.strObject = (const char *(*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.strObject;
    ASE_Compiler_Cxx_Visitor_epv.getReferenceCount = (int32_t (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.getReferenceCount;
    ASE_Compiler_Cxx_Visitor_epv.addReference = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.addReference;
    ASE_Compiler_Cxx_Visitor_epv.deleteReference = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.deleteReference;
    ASE_Compiler_Cxx_Visitor_epv.isSame = (int (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.isSame;
    ASE_Compiler_Cxx_Visitor_epv.getClassName = (const char *(*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.getClassName;
    ASE_Compiler_Cxx_Visitor_epv.getName = (const char *(*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.getName;
    ASE_Compiler_Cxx_Visitor_epv.setName = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.setName;
    ASE_Compiler_Cxx_Visitor_epv.isInstanceOf = (int (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.isInstanceOf;
    ASE_Compiler_Cxx_Visitor_epv.getSuper = (struct ASE_BaseInterface__object *(*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.getSuper;
    ASE_Compiler_Cxx_Visitor_epv.getRepository = (struct ASE_Compiler_Vertex__array *(*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.getRepository;
    ASE_Compiler_Cxx_Visitor_epv.setRepository = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Vertex__array *repository, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.setRepository;
    ASE_Compiler_Cxx_Visitor_epv.visitVertex = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitVertex;
    ASE_Compiler_Cxx_Visitor_epv.visitSource = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Source__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitSource;
    ASE_Compiler_Cxx_Visitor_epv.visitHeader = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Header__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitHeader;
    ASE_Compiler_Cxx_Visitor_epv.visitPythonModule = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_PythonModule__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitPythonModule;
    ASE_Compiler_Cxx_Visitor_epv.visitInclude = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Include__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitInclude;
    ASE_Compiler_Cxx_Visitor_epv.visitDefine = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Define__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitDefine;
    ASE_Compiler_Cxx_Visitor_epv.visitMacro = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Macro__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitMacro;
    ASE_Compiler_Cxx_Visitor_epv.visitPreprocessorConditional = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_PreprocessorConditional__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitPreprocessorConditional;
    ASE_Compiler_Cxx_Visitor_epv.visitType = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Type__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitType;
    ASE_Compiler_Cxx_Visitor_epv.visitPointer = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Pointer__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitPointer;
    ASE_Compiler_Cxx_Visitor_epv.visitStruct = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Struct__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitStruct;
    ASE_Compiler_Cxx_Visitor_epv.visitBitField = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_BitField__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitBitField;
    ASE_Compiler_Cxx_Visitor_epv.visitEnumeration = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Enumeration__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitEnumeration;
    ASE_Compiler_Cxx_Visitor_epv.visitEnumerator = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Enumerator__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitEnumerator;
    ASE_Compiler_Cxx_Visitor_epv.visitTypedef = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Typedef__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitTypedef;
    ASE_Compiler_Cxx_Visitor_epv.visitGroup = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Group__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitGroup;
    ASE_Compiler_Cxx_Visitor_epv.visitDeclarator = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Declarator__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitDeclarator;
    ASE_Compiler_Cxx_Visitor_epv.visitDeclaratorGroup = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_DeclaratorGroup__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitDeclaratorGroup;
    ASE_Compiler_Cxx_Visitor_epv.visitArray = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Array__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitArray;
    ASE_Compiler_Cxx_Visitor_epv.visitFunction = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Function__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitFunction;
    ASE_Compiler_Cxx_Visitor_epv.visitParameter = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Parameter__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitParameter;
    ASE_Compiler_Cxx_Visitor_epv.visitDeclaration = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Declaration__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitDeclaration;
    ASE_Compiler_Cxx_Visitor_epv.visitStatement = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Statement__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitStatement;
    ASE_Compiler_Cxx_Visitor_epv.visitExpressionStatement = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_ExpressionStatement__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitExpressionStatement;
    ASE_Compiler_Cxx_Visitor_epv.visitCompoundStatement = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_CompoundStatement__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitCompoundStatement;
    ASE_Compiler_Cxx_Visitor_epv.visitIf = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_If__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitIf;
    ASE_Compiler_Cxx_Visitor_epv.visitSwitch = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Switch__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitSwitch;
    ASE_Compiler_Cxx_Visitor_epv.visitWhile = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_While__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitWhile;
    ASE_Compiler_Cxx_Visitor_epv.visitFor = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_For__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitFor;
    ASE_Compiler_Cxx_Visitor_epv.visitGoto = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Goto__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitGoto;
    ASE_Compiler_Cxx_Visitor_epv.visitContinue = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Continue__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitContinue;
    ASE_Compiler_Cxx_Visitor_epv.visitBreak = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Break__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitBreak;
    ASE_Compiler_Cxx_Visitor_epv.visitReturn = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Return__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitReturn;
    ASE_Compiler_Cxx_Visitor_epv.visitInitializer = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Initializer__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitInitializer;
    ASE_Compiler_Cxx_Visitor_epv.visitExpression = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Expression__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitExpression;
    ASE_Compiler_Cxx_Visitor_epv.visitAssignment = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Assignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitAssignment;
    ASE_Compiler_Cxx_Visitor_epv.visitInclusiveOrAssignment = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_InclusiveOrAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitInclusiveOrAssignment;
    ASE_Compiler_Cxx_Visitor_epv.visitExclusiveOrAssignment = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_ExclusiveOrAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitExclusiveOrAssignment;
    ASE_Compiler_Cxx_Visitor_epv.visitAndAssignment = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_AndAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitAndAssignment;
    ASE_Compiler_Cxx_Visitor_epv.visitLeftShiftAssignment = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_LeftShiftAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitLeftShiftAssignment;
    ASE_Compiler_Cxx_Visitor_epv.visitRightShiftAssignment = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_RightShiftAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitRightShiftAssignment;
    ASE_Compiler_Cxx_Visitor_epv.visitAdditionAssignment = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_AdditionAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitAdditionAssignment;
    ASE_Compiler_Cxx_Visitor_epv.visitSubtractionAssignment = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_SubtractionAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitSubtractionAssignment;
    ASE_Compiler_Cxx_Visitor_epv.visitMultiplicationAssignment = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_MultiplicationAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitMultiplicationAssignment;
    ASE_Compiler_Cxx_Visitor_epv.visitDivisionAssignment = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_DivisionAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitDivisionAssignment;
    ASE_Compiler_Cxx_Visitor_epv.visitModuloAssignment = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_ModuloAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitModuloAssignment;
    ASE_Compiler_Cxx_Visitor_epv.visitLogicalOr = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_LogicalOr__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitLogicalOr;
    ASE_Compiler_Cxx_Visitor_epv.visitLogicalAnd = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_LogicalAnd__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitLogicalAnd;
    ASE_Compiler_Cxx_Visitor_epv.visitInclusiveOr = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_InclusiveOr__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitInclusiveOr;
    ASE_Compiler_Cxx_Visitor_epv.visitExclusiveOr = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_ExclusiveOr__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitExclusiveOr;
    ASE_Compiler_Cxx_Visitor_epv.visitAnd = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_And__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitAnd;
    ASE_Compiler_Cxx_Visitor_epv.visitEquality = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Equality__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitEquality;
    ASE_Compiler_Cxx_Visitor_epv.visitInequality = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Inequality__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitInequality;
    ASE_Compiler_Cxx_Visitor_epv.visitLessThan = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_LessThan__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitLessThan;
    ASE_Compiler_Cxx_Visitor_epv.visitGreaterThan = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_GreaterThan__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitGreaterThan;
    ASE_Compiler_Cxx_Visitor_epv.visitLessThanOrEqual = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_LessThanOrEqual__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitLessThanOrEqual;
    ASE_Compiler_Cxx_Visitor_epv.visitGreaterThanOrEqual = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_GreaterThanOrEqual__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitGreaterThanOrEqual;
    ASE_Compiler_Cxx_Visitor_epv.visitLeftShift = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_LeftShift__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitLeftShift;
    ASE_Compiler_Cxx_Visitor_epv.visitRightShift = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_RightShift__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitRightShift;
    ASE_Compiler_Cxx_Visitor_epv.visitAddition = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Addition__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitAddition;
    ASE_Compiler_Cxx_Visitor_epv.visitSubtraction = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Subtraction__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitSubtraction;
    ASE_Compiler_Cxx_Visitor_epv.visitMultiplication = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Multiplication__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitMultiplication;
    ASE_Compiler_Cxx_Visitor_epv.visitDivision = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Division__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitDivision;
    ASE_Compiler_Cxx_Visitor_epv.visitModulo = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Modulo__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitModulo;
    ASE_Compiler_Cxx_Visitor_epv.visitCast = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Cast__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitCast;
    ASE_Compiler_Cxx_Visitor_epv.visitSizeof = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Sizeof__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitSizeof;
    ASE_Compiler_Cxx_Visitor_epv.visitAddress = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Address__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitAddress;
    ASE_Compiler_Cxx_Visitor_epv.visitIndirection = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Indirection__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitIndirection;
    ASE_Compiler_Cxx_Visitor_epv.visitUnaryPlus = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_UnaryPlus__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitUnaryPlus;
    ASE_Compiler_Cxx_Visitor_epv.visitUnaryMinus = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_UnaryMinus__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitUnaryMinus;
    ASE_Compiler_Cxx_Visitor_epv.visitComplement = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Complement__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitComplement;
    ASE_Compiler_Cxx_Visitor_epv.visitNegation = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Negation__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitNegation;
    ASE_Compiler_Cxx_Visitor_epv.visitIncrement = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Increment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitIncrement;
    ASE_Compiler_Cxx_Visitor_epv.visitStructReference = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_StructReference__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitStructReference;
    ASE_Compiler_Cxx_Visitor_epv.visitArrayReference = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_ArrayReference__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitArrayReference;
    ASE_Compiler_Cxx_Visitor_epv.visitFunctionCall = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_FunctionCall__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitFunctionCall;
    ASE_Compiler_Cxx_Visitor_epv.visitVariable = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Variable__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitVariable;
    ASE_Compiler_Cxx_Visitor_epv.visitConstant = (void (*)(struct ASE_Compiler_Cxx_Visitor__object *self, /*in*/ struct ASE_Compiler_Cxx_Constant__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitConstant;
    /* Initialize interface ASE.Compiler.Visitor methods with those of class ASE.Compiler.Cxx.DepthFirstVisitor */
    ASE_Compiler_Visitor_epv.castObject = (void *(*)(struct ASE_Compiler_Visitor__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.castObject;
    ASE_Compiler_Visitor_epv.iterNext = (struct ASE_Compiler_Visitor__object *(*)(struct ASE_Compiler_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.iterNext;
    ASE_Compiler_Visitor_epv.destroyObject = (void (*)(struct ASE_Compiler_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.destroyObject;
    ASE_Compiler_Visitor_epv.strObject = (const char *(*)(struct ASE_Compiler_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.strObject;
    ASE_Compiler_Visitor_epv.getReferenceCount = (int32_t (*)(struct ASE_Compiler_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.getReferenceCount;
    ASE_Compiler_Visitor_epv.addReference = (void (*)(struct ASE_Compiler_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.addReference;
    ASE_Compiler_Visitor_epv.deleteReference = (void (*)(struct ASE_Compiler_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.deleteReference;
    ASE_Compiler_Visitor_epv.isSame = (int (*)(struct ASE_Compiler_Visitor__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.isSame;
    ASE_Compiler_Visitor_epv.getClassName = (const char *(*)(struct ASE_Compiler_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.getClassName;
    ASE_Compiler_Visitor_epv.getName = (const char *(*)(struct ASE_Compiler_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.getName;
    ASE_Compiler_Visitor_epv.setName = (void (*)(struct ASE_Compiler_Visitor__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.setName;
    ASE_Compiler_Visitor_epv.isInstanceOf = (int (*)(struct ASE_Compiler_Visitor__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.isInstanceOf;
    ASE_Compiler_Visitor_epv.getSuper = (struct ASE_BaseInterface__object *(*)(struct ASE_Compiler_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.getSuper;
    ASE_Compiler_Visitor_epv.getRepository = (struct ASE_Compiler_Vertex__array *(*)(struct ASE_Compiler_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.getRepository;
    ASE_Compiler_Visitor_epv.setRepository = (void (*)(struct ASE_Compiler_Visitor__object *self, /*in*/ struct ASE_Compiler_Vertex__array *repository, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.setRepository;
    ASE_Compiler_Visitor_epv.visitVertex = (void (*)(struct ASE_Compiler_Visitor__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitVertex;
    /* Initialize interface ASE.BaseInterface methods with those of class ASE.Compiler.Cxx.DepthFirstVisitor */
    ASE_BaseInterface_epv.castObject = (void *(*)(struct ASE_BaseInterface__object *self, /*in*/ const char *name, /*out*/ void **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.castObject;
    ASE_BaseInterface_epv.iterNext = (struct ASE_BaseInterface__object *(*)(struct ASE_BaseInterface__object *self, /*out*/ void **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.iterNext;
    ASE_BaseInterface_epv.destroyObject = (void (*)(struct ASE_BaseInterface__object *self, /*out*/ void **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.destroyObject;
    ASE_BaseInterface_epv.strObject = (const char *(*)(struct ASE_BaseInterface__object *self, /*out*/ void **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.strObject;
    ASE_BaseInterface_epv.getReferenceCount = (int32_t (*)(struct ASE_BaseInterface__object *self, /*out*/ void **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.getReferenceCount;
    ASE_BaseInterface_epv.addReference = (void (*)(struct ASE_BaseInterface__object *self, /*out*/ void **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.addReference;
    ASE_BaseInterface_epv.deleteReference = (void (*)(struct ASE_BaseInterface__object *self, /*out*/ void **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.deleteReference;
    ASE_BaseInterface_epv.isSame = (int (*)(struct ASE_BaseInterface__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ void **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.isSame;
    ASE_BaseInterface_epv.getClassName = (const char *(*)(struct ASE_BaseInterface__object *self, /*out*/ void **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.getClassName;
    ASE_BaseInterface_epv.getName = (const char *(*)(struct ASE_BaseInterface__object *self, /*out*/ void **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.getName;
    ASE_BaseInterface_epv.setName = (void (*)(struct ASE_BaseInterface__object *self, /*in*/ const char *name, /*out*/ void **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.setName;
    ASE_BaseInterface_epv.isInstanceOf = (int (*)(struct ASE_BaseInterface__object *self, /*in*/ const char *typeName, /*out*/ void **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.isInstanceOf;
    ASE_BaseInterface_epv.getSuper = (struct ASE_BaseInterface__object *(*)(struct ASE_BaseInterface__object *self, /*out*/ void **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.getSuper;
    /* Initialize interface ASE.Compiler.Search methods with those of class ASE.Compiler.Cxx.DepthFirstVisitor */
    ASE_Compiler_Search_epv.castObject = (void *(*)(struct ASE_Compiler_Search__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.castObject;
    ASE_Compiler_Search_epv.iterNext = (struct ASE_Compiler_Search__object *(*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.iterNext;
    ASE_Compiler_Search_epv.destroyObject = (void (*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.destroyObject;
    ASE_Compiler_Search_epv.strObject = (const char *(*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.strObject;
    ASE_Compiler_Search_epv.getReferenceCount = (int32_t (*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.getReferenceCount;
    ASE_Compiler_Search_epv.addReference = (void (*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.addReference;
    ASE_Compiler_Search_epv.deleteReference = (void (*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.deleteReference;
    ASE_Compiler_Search_epv.isSame = (int (*)(struct ASE_Compiler_Search__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.isSame;
    ASE_Compiler_Search_epv.getClassName = (const char *(*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.getClassName;
    ASE_Compiler_Search_epv.getName = (const char *(*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.getName;
    ASE_Compiler_Search_epv.setName = (void (*)(struct ASE_Compiler_Search__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.setName;
    ASE_Compiler_Search_epv.isInstanceOf = (int (*)(struct ASE_Compiler_Search__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.isInstanceOf;
    ASE_Compiler_Search_epv.getSuper = (struct ASE_BaseInterface__object *(*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.getSuper;
    ASE_Compiler_Search_epv.getReverseEdges = (int (*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.getReverseEdges;
    ASE_Compiler_Search_epv.setReverseEdges = (void (*)(struct ASE_Compiler_Search__object *self, /*in*/ int reverseEdges, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.setReverseEdges;
    ASE_Compiler_Search_epv.traverseVertex = (void (*)(struct ASE_Compiler_Search__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.traverseVertex;
    ASE_Compiler_Search_epv.resetVertexNumbering = (void (*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.resetVertexNumbering;
    ASE_Compiler_Search_epv.discoverVertex = (void (*)(struct ASE_Compiler_Search__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.discoverVertex;
    ASE_Compiler_Search_epv.finishVertex = (void (*)(struct ASE_Compiler_Search__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.finishVertex;
    ASE_Compiler_Search_epv.getVerticesSeen = (struct ASE_Compiler_Vertex__array *(*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.getVerticesSeen;
    ASE_Compiler_Search_epv.setVerticesSeen = (void (*)(struct ASE_Compiler_Search__object *self, /*in*/ struct ASE_Compiler_Vertex__array *seen, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.setVerticesSeen;
    ASE_Compiler_Search_epv.getVertexSeen = (int (*)(struct ASE_Compiler_Search__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.getVertexSeen;
    ASE_Compiler_Search_epv.setVertexSeen = (void (*)(struct ASE_Compiler_Search__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*in*/ int state, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Cxx_DepthFirstVisitor_epv.setVertexSeen;
    epvInitialized = 1;
  }
  self->ase_baseclass.ase_baseinterface.d_epv = &ASE_BaseInterface_epv;
  self->ase_baseclass.d_epv = &ASE_BaseClass_epv;
  self->ase_compiler_cxx_visitor.ase_compiler_visitor.ase_baseinterface.d_epv = &ASE_BaseInterface_epv;
  self->ase_compiler_cxx_visitor.ase_compiler_visitor.d_epv = &ASE_Compiler_Visitor_epv;
  self->ase_compiler_cxx_visitor.d_epv = &ASE_Compiler_Cxx_Visitor_epv;
  self->ase_compiler_search.ase_baseinterface.d_epv = &ASE_BaseInterface_epv;
  self->ase_compiler_search.d_epv = &ASE_Compiler_Search_epv;
  self->d_epv = &ASE_Compiler_Cxx_DepthFirstVisitor_epv;
  /* Save old EPV for getSuper() */
  self->d_oldEpv = self->d_epv;
  /* Initialize pointers to the original object */
  self->d_object = obj;
  self->ase_compiler_cxx_visitor.d_object = obj;
  self->ase_compiler_cxx_visitor.ase_compiler_visitor.d_object = obj;
  self->ase_compiler_cxx_visitor.ase_compiler_visitor.ase_baseinterface.d_object = obj;
  self->ase_compiler_search.d_object = obj;
  self->ase_compiler_search.ase_baseinterface.d_object = obj;
  /* Setup implementation data */
  self->d_data = NULL;
  /* Call the Skeleton constructor */
  (*(self->d_epv->DepthFirstVisitor))(self, _exception);
}

static struct ASE_Compiler_Cxx_DepthFirstVisitor__object *createObject(/*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_Cxx_DepthFirstVisitor__object *self = (struct ASE_Compiler_Cxx_DepthFirstVisitor__object *) malloc(sizeof(struct ASE_Compiler_Cxx_DepthFirstVisitor__object));
  
  initObject(self, self, _exception);
  return self;
}

#ifndef included_ASE_ASEException
#include <ASE/ASEException_IOR.h>
#endif

static struct ASE_Compiler_Cxx_DepthFirstVisitor__array *createArray(/*in*/ int32_t dimen, /*in*/ struct int__array *lower, /*in*/ struct int__array *upper, /*out*/ struct ASE_BaseException__object **_exception)
{
  static int32_t arraySize = sizeof(struct ASE_Compiler_Cxx_DepthFirstVisitor__array) + (sizeof(int32_t) - (sizeof(struct ASE_Compiler_Cxx_DepthFirstVisitor__array)) % sizeof(int32_t)) % sizeof(int32_t);
  struct ASE_Compiler_Cxx_DepthFirstVisitor__array *_return_value = (struct ASE_Compiler_Cxx_DepthFirstVisitor__array *) malloc(arraySize + 3 * sizeof(int32_t) * (dimen ? dimen : 1));
  int32_t size = 1;
  int32_t d = 0;
  
  /* Initialize array structure */
  _return_value->d_dimen = dimen;
  _return_value->d_borrowed = 0;
  _return_value->d_lower = (int32_t *) ((char *) _return_value + arraySize);
  _return_value->d_upper = _return_value->d_lower + (dimen ? dimen : 1);
  _return_value->d_stride = _return_value->d_upper + (dimen ? dimen : 1);
  _return_value->d_lower[0] = 0;
  _return_value->d_upper[0] = 0;
  _return_value->d_stride[0] = 1;
  /* Determine array size and set bounds */
  for(d = 0; d < dimen; d++)
  {
    _return_value->d_lower[d] = lower->d_firstElement[d];
    _return_value->d_upper[d] = upper->d_firstElement[d];
    _return_value->d_stride[d] = size;
    size *= upper->d_firstElement[d] - lower->d_firstElement[d] + 1;
  }
  size *= sizeof(struct ASE_Compiler_Cxx_DepthFirstVisitor__object *);
  /* Allocate and initialize data */
  _return_value->d_firstElement = (struct ASE_Compiler_Cxx_DepthFirstVisitor__object **) malloc(size);
  memset(_return_value->d_firstElement, 0, size);
  return _return_value;
}

static struct ASE_Compiler_Cxx_DepthFirstVisitor__array *borrowArray(/*in*/ int32_t dimen, /*in*/ struct int__array *lower, /*in*/ struct int__array *upper, /*in*/ struct int__array *stride, /*in*/ void *first, /*out*/ struct ASE_BaseException__object **_exception)
{
  static int32_t arraySize = sizeof(struct ASE_Compiler_Cxx_DepthFirstVisitor__array) + (sizeof(int32_t) - (sizeof(struct ASE_Compiler_Cxx_DepthFirstVisitor__array)) % sizeof(int32_t)) % sizeof(int32_t);
  struct ASE_Compiler_Cxx_DepthFirstVisitor__array *_return_value = (struct ASE_Compiler_Cxx_DepthFirstVisitor__array *) malloc(arraySize + 3 * sizeof(int32_t) * (dimen ? dimen : 1));
  int32_t size = 1;
  int32_t d = 0;
  
  /* Initialize array structure */
  _return_value->d_dimen = dimen;
  _return_value->d_borrowed = 1;
  _return_value->d_lower = (int32_t *) ((char *) _return_value + arraySize);
  _return_value->d_upper = _return_value->d_lower + (dimen ? dimen : 1);
  _return_value->d_stride = _return_value->d_upper + (dimen ? dimen : 1);
  _return_value->d_lower[0] = 0;
  _return_value->d_upper[0] = 0;
  _return_value->d_stride[0] = 1;
  /* Determine array size and set bounds */
  for(d = 0; d < dimen; d++)
  {
    _return_value->d_lower[d] = lower->d_firstElement[d];
    _return_value->d_upper[d] = upper->d_firstElement[d];
    _return_value->d_stride[d] = stride->d_firstElement[d];
    size *= upper->d_firstElement[d] - lower->d_firstElement[d] + 1;
  }
  size *= sizeof(struct ASE_Compiler_Cxx_DepthFirstVisitor__object *);
  _return_value->d_firstElement = (struct ASE_Compiler_Cxx_DepthFirstVisitor__object **) first;
  return _return_value;
}

static void destroyArray(/*in*/ struct ASE_Compiler_Cxx_DepthFirstVisitor__array *array, /*out*/ struct ASE_BaseException__object **_exception)
{
  if (!array->d_borrowed)
  {
    free(array->d_firstElement);
  }
  free(array);
}

static int32_t getDimen(/*in*/ struct ASE_Compiler_Cxx_DepthFirstVisitor__array *array, /*out*/ struct ASE_BaseException__object **_exception)
{
  return array->d_dimen;
}

static int32_t getLower(/*in*/ struct ASE_Compiler_Cxx_DepthFirstVisitor__array *array, /*in*/ int32_t dimen, /*out*/ struct ASE_BaseException__object **_exception)
{
  return array->d_lower[dimen];
}

static int32_t getUpper(/*in*/ struct ASE_Compiler_Cxx_DepthFirstVisitor__array *array, /*in*/ int32_t dimen, /*out*/ struct ASE_BaseException__object **_exception)
{
  return array->d_upper[dimen];
}

static struct ASE_Compiler_Cxx_DepthFirstVisitor__object *getElement(/*in*/ struct ASE_Compiler_Cxx_DepthFirstVisitor__array *array, /*in*/ struct int__array *indices, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_Cxx_DepthFirstVisitor__object *_result = NULL;
  struct ASE_Compiler_Cxx_DepthFirstVisitor__object **_element = NULL;
  int32_t d = 0;
  
  _element = array->d_firstElement;
  for(d = 0; d < array->d_dimen; d++)
  {
    if (indices->d_firstElement[d] < array->d_lower[d] || indices->d_firstElement[d] > array->d_upper[d])
    {
      struct ASE_ASEException__object *_local_exception = ASE_ASEException__externals()->createObject(NULL);
      
      _local_exception->d_epv->setMessage(_local_exception, "Invalid indices", _exception);
      if (_exception)
      {
        *_exception = (struct ASE_BaseException__object *) _local_exception;
      }
      return _result;
    }
    _element += array->d_stride[d] * (indices->d_firstElement[d] - array->d_lower[d]);
  }
  if (*_element)
  {
    (*(((struct ASE_BaseInterface__object *) (*_element)->d_object)->d_epv->deleteReference))((*_element)->d_object, (void **) _exception);
  }
  return *_element;
}

static struct ASE_Compiler_Cxx_DepthFirstVisitor__object *getElement4(/*in*/ struct ASE_Compiler_Cxx_DepthFirstVisitor__array *array, /*in*/ int32_t i1, /*in*/ int32_t i2, /*in*/ int32_t i3, /*in*/ int32_t i4, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_Cxx_DepthFirstVisitor__object *_result = NULL;
  
  return _result;
}

static void setElement(/*in*/ struct ASE_Compiler_Cxx_DepthFirstVisitor__array *array, /*in*/ struct int__array *indices, /*in*/ struct ASE_Compiler_Cxx_DepthFirstVisitor__object *value, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_Cxx_DepthFirstVisitor__object **_element = NULL;
  int32_t d = 0;
  
  _element = array->d_firstElement;
  for(d = 0; d < array->d_dimen; d++)
  {
    if (indices->d_firstElement[d] < array->d_lower[d] || indices->d_firstElement[d] > array->d_upper[d])
    {
      struct ASE_ASEException__object *_local_exception = ASE_ASEException__externals()->createObject(NULL);
      
      _local_exception->d_epv->setMessage(_local_exception, "Invalid indices", _exception);
      if (_exception)
      {
        *_exception = (struct ASE_BaseException__object *) _local_exception;
      }
      return;
    }
    _element += array->d_stride[d] * (indices->d_firstElement[d] - array->d_lower[d]);
  }
  if (value)
  {
    (*(((struct ASE_BaseInterface__object *) (value)->d_object)->d_epv->addReference))((value)->d_object, (void **) _exception);
  }
  if (*_element)
  {
    (*(((struct ASE_BaseInterface__object *) (*_element)->d_object)->d_epv->deleteReference))((*_element)->d_object, (void **) _exception);
  }
  *_element = value;
}

static void setElement4(/*in*/ struct ASE_Compiler_Cxx_DepthFirstVisitor__array *array, /*in*/ int32_t i1, /*in*/ int32_t i2, /*in*/ int32_t i3, /*in*/ int32_t i4, /*in*/ struct ASE_Compiler_Cxx_DepthFirstVisitor__object *value, /*out*/ struct ASE_BaseException__object **_exception)
{
}

static void *castIterator(struct ASE_Compiler_Cxx_DepthFirstVisitor__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  /* We are guaranteed here that the first member in any IOR is a ASE.BaseInterface object */
  struct ASE_BaseClass__object *obj = ((struct ASE_BaseInterface__object *) self)->d_object;
  void *cast = NULL;
  
  if (!strcmp(name, "ASE.Compiler.Cxx.DepthFirstVisitor"))
  {
    cast = self;
  }
  else
  if (!strcmp(name, "ASE.BaseClass"))
  {
    cast = obj;
  }
  else
  if (!strcmp(name, "ASE.BaseInterface"))
  {
    cast = (&obj->ase_baseinterface);
  }
  return cast;
}

static struct ASE_Compiler_Cxx_DepthFirstVisitor__iterator *createIterator(/*in*/ void *iterator, /*in*/ void *iterNext, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_Cxx_DepthFirstVisitor__iterator *self = (struct ASE_Compiler_Cxx_DepthFirstVisitor__iterator *) malloc(sizeof(struct ASE_Compiler_Cxx_DepthFirstVisitor__iterator));
  struct ASE_BaseClass__object *parent = &self->ase_baseclass;
  struct ASE_BaseClass__epv *ASE_BaseClass_epv = (struct ASE_BaseClass__epv *) malloc(sizeof(struct ASE_BaseClass__epv));
  struct ASE_BaseInterface__epv *ASE_BaseInterface_epv = (struct ASE_BaseInterface__epv *) malloc(sizeof(struct ASE_BaseInterface__epv));
  
  (*(ASE_BaseClass__externals()->initObject))(parent, self, _exception);
  ASE_BaseClass_epv->getReferenceCount = self->ase_baseclass.d_epv->getReferenceCount;
  ASE_BaseClass_epv->addReference = self->ase_baseclass.d_epv->addReference;
  ASE_BaseClass_epv->deleteReference = self->ase_baseclass.d_epv->deleteReference;
  ASE_BaseClass_epv->isSame = self->ase_baseclass.d_epv->isSame;
  ASE_BaseClass_epv->getClassName = self->ase_baseclass.d_epv->getClassName;
  ASE_BaseClass_epv->getName = self->ase_baseclass.d_epv->getName;
  ASE_BaseClass_epv->setName = self->ase_baseclass.d_epv->setName;
  ASE_BaseClass_epv->isInstanceOf = self->ase_baseclass.d_epv->isInstanceOf;
  ASE_BaseClass_epv->getSuper = self->ase_baseclass.d_epv->getSuper;
  ASE_BaseInterface_epv->getReferenceCount = self->ase_baseclass.ase_baseinterface.d_epv->getReferenceCount;
  ASE_BaseInterface_epv->addReference = self->ase_baseclass.ase_baseinterface.d_epv->addReference;
  ASE_BaseInterface_epv->deleteReference = self->ase_baseclass.ase_baseinterface.d_epv->deleteReference;
  ASE_BaseInterface_epv->isSame = self->ase_baseclass.ase_baseinterface.d_epv->isSame;
  ASE_BaseInterface_epv->getClassName = self->ase_baseclass.ase_baseinterface.d_epv->getClassName;
  ASE_BaseInterface_epv->getName = self->ase_baseclass.ase_baseinterface.d_epv->getName;
  ASE_BaseInterface_epv->setName = self->ase_baseclass.ase_baseinterface.d_epv->setName;
  ASE_BaseInterface_epv->isInstanceOf = self->ase_baseclass.ase_baseinterface.d_epv->isInstanceOf;
  ASE_BaseInterface_epv->getSuper = self->ase_baseclass.ase_baseinterface.d_epv->getSuper;
  ASE_BaseClass_epv->castObject = castIterator;
  ASE_BaseClass_epv->iterNext = iterNext;
  ASE_BaseInterface_epv->castObject = castIterator;
  ASE_BaseInterface_epv->iterNext = iterNext;
  self->ase_baseclass.ase_baseinterface.d_epv = ASE_BaseInterface_epv;
  self->ase_baseclass.d_epv = ASE_BaseClass_epv;
  self->iterator = iterator;
  self->objWrapper = NULL;
  return self;
}

static void destroyIterator(/*in*/ struct ASE_Compiler_Cxx_DepthFirstVisitor__iterator *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_BaseClass__object *parent = &self->ase_baseclass;
  
  self->iterator = NULL;
  self->objWrapper = NULL;
  free(self->ase_baseclass.ase_baseinterface.d_epv);
  free(self->ase_baseclass.d_epv);
  self->ase_baseclass.d_epv = self->ase_baseclass.d_oldEpv;
  (*(ASE_BaseClass__externals()->finiObject))(parent, _exception);
  memset(self, 0, sizeof(struct ASE_Compiler_Cxx_DepthFirstVisitor__iterator));
  free(self);
}

/* The entry points into the DLL containing this type */
static struct ASE_Compiler_Cxx_DepthFirstVisitor__external externalEntryPoints = {
  createObject,
  initObject,
  finiObject,
  createArray,
  borrowArray,
  destroyArray,
  getDimen,
  getLower,
  getUpper,
  getElement,
  getElement4,
  setElement,
  setElement4,
  createIterator,
  destroyIterator};

const struct ASE_Compiler_Cxx_DepthFirstVisitor__external *ASE_Compiler_Cxx_DepthFirstVisitor__externals(void)
{
  return &externalEntryPoints;
}
