# Starting imports section
pass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.Attribute
import ASE.Compiler.Comment
import ASE.Compiler.CompilerException
import ASE.Compiler.Python.Import
import ASE.Compiler.Python.Vertex
import ASE.Compiler.Python.Visitor
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class From:
  '''
  A Python from statement
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.importedNames = {}

  
  def accept(self, visitor):
    '''
    Overridden to dispatch correctly
    '''
    visitor.visitFrom(self.__IORself)
  
  def copy(self):
    '''
    Need to override this
    '''
    root = ASE.Compiler.Cxx.From.From()
    root.setIdentifier(self.__IORself.getIdentifier())
    root.setAttributes(self.__IORself.getAttributes())
    root.setLineNumber(self.__IORself.getLineNumber())
    root.setComments(self.__IORself.getComments())
    root.setChildren([child.copy() for child in self.__IORself.getChildren()])
    root.setImportedNames([name for name in self.__IORself.getImportedNames()])
    for name in self.__IORself.getImportedNames():
      if self.__IORself.getAlias(name):
        root.setAlias(name, self.__IORself.getAlias(name))
    return root
  
  def getImportedNames(self):
    '''
    Retrieve the imported names
    '''
    return self.importedNames.keys()
  
  def setImportedNames(self, importedNames):
    '''
    Set the imported names
    '''
    self.importedNames = {}

    for name in importedNames:
      self.importedNames[name] = ''
  
  def getAlias(self, name):
    '''
    Retrieve a name alias
    Throws an exception if name does not exist
    '''
    if not (name in self.importedNames):
      e = ASE.Compiler.CompilerException.CompilerException()
      e.setMessage('The imported name ' + str(name) + ' does not exist')
      raise e
    return self.importedNames[name]
  
  def setAlias(self, name, alias):
    '''
    Set a name alias
    Throws an exception if name does not exist
    '''
    self.importedNames[name] = alias
  # Ending class methods section
  pass
