# Starting imports section
pass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.Attribute
import ASE.Compiler.Comment
import ASE.Compiler.CompilerException
import ASE.Compiler.Python.Vertex
import ASE.Compiler.Python.Visitor
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class Import:
  '''
  A Python import statement
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.moduleNames = {}

  
  def accept(self, visitor):
    '''
    Overridden to dispatch correctly
    '''
    visitor.visitImport(self.__IORself)
  
  def copy(self):
    '''
    Need to override this
    '''
    root = ASE.Compiler.Cxx.Import.Import()
    root.setIdentifier(self.__IORself.getIdentifier())
    root.setAttributes(self.__IORself.getAttributes())
    root.setLineNumber(self.__IORself.getLineNumber())
    root.setComments(self.__IORself.getComments())
    root.setChildren([child.copy() for child in self.__IORself.getChildren()])
    root.setModuleNames([name for name in self.__IORself.getModuleNames()])
    for name in self.__IORself.getModuleNames():
      if self.__IORself.getAlias(name):
        root.setAlias(name, self.__IORself.getAlias(name))
    return root
  
  def getModuleNames(self):
    '''
    Retrieve the module names
    '''
    return self.moduleNames.keys()
  
  def setModuleNames(self, moduleNames):
    '''
    Set the module names
    '''
    self.moduleNames = {}

    for name in moduleNames:
      self.moduleNames[name] = ''
  
  def getAlias(self, name):
    '''
    Retrieve a name alias
    Throws an exception if name does not exist
    '''
    if not (name in self.moduleNames):
      e = ASE.Compiler.CompilerException.CompilerException()
      e.setMessage('The imported name ' + str(name) + ' does not exist')
      raise e
    return self.moduleNames[name]
  
  def setAlias(self, name, alias):
    '''
    Set a name alias
    Throws an exception if name does not exist
    '''
    self.moduleNames[name] = alias
  # Ending class methods section
  pass
