#include <stdlib.h>

#include <string.h>

#ifndef included_ASE_Compiler_Python_DepthFirstVisitor
#include <ASE/Compiler/Python/DepthFirstVisitor_IOR.h>
#endif

#ifndef included_ASE_Loader
#include <ASE/Loader_IOR.h>
#endif

/* Initialization routine defined in the skeleton */
extern void ASE_Compiler_Python_DepthFirstVisitor__set_epv(struct ASE_Compiler_Python_DepthFirstVisitor__epv *epv, struct ASE_BaseException__object **_exception);

static const char *getClassName(struct ASE_Compiler_Python_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return strdup("ASE.Compiler.Python.DepthFirstVisitor");
}

#ifndef included_ASE_ASEException
#include <ASE/ASEException_IOR.h>
#endif

static void *castObject(struct ASE_Compiler_Python_DepthFirstVisitor__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  /* We are guaranteed here that the first member in any IOR is a ASE.BaseInterface object */
  struct ASE_Compiler_Python_DepthFirstVisitor__object *obj = ((struct ASE_BaseInterface__object *) self)->d_object;
  void *cast = NULL;
  
  if (!strcmp(name, "ASE.Compiler.Python.DepthFirstVisitor"))
  {
    cast = obj;
  }
  else
  if (!strcmp(name, "ASE.BaseClass"))
  {
    cast = (&obj->ase_baseclass);
  }
  else
  if (!strcmp(name, "ASE.BaseInterface"))
  {
    cast = (&(&obj->ase_baseclass)->ase_baseinterface);
  }
  else
  if (!strcmp(name, "ASE.Compiler.Python.Visitor"))
  {
    cast = (&obj->ase_compiler_python_visitor);
  }
  else
  if (!strcmp(name, "ASE.Compiler.Visitor"))
  {
    cast = (&(&obj->ase_compiler_python_visitor)->ase_compiler_visitor);
  }
  else
  if (!strcmp(name, "ASE.Compiler.Search"))
  {
    cast = (&obj->ase_compiler_search);
  }
  return cast;
}

static const char *strObject(struct ASE_Compiler_Python_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return "ASE.Compiler.Python.DepthFirstVisitor";
}

static void finiObject(/*in*/ struct ASE_Compiler_Python_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_BaseClass__object *parent = &self->ase_baseclass;
  const struct ASE_BaseClass__external *(*extFunc)(void) = (const struct ASE_BaseClass__external *(*)(void)) ASE_Loader__externals()->getStaticEPV(_exception)->getClassMethodTable("ASE.BaseClass", _exception);
  void (*parentFini)(/*in*/ struct ASE_BaseClass__object *, /*out*/ struct ASE_BaseException__object **_exception) = (extFunc())->finiObject;
  
  self->ase_compiler_python_visitor.d_epv = self->ase_compiler_python_visitor.d_oldEpv;
  self->ase_compiler_search.d_epv = self->ase_compiler_search.d_oldEpv;
  self->ase_baseclass.d_epv = self->ase_baseclass.d_oldEpv;
  (*(self->d_epv->DepthFirstVisitor_))(self, _exception);
  if (!parentFini)
  {
    struct ASE_ASEException__object *_local_exception = ASE_ASEException__externals()->createObject(NULL);
    
    _local_exception->d_epv->setMessage(_local_exception, "Unable to find finalizer for ASE.BaseClass", _exception);
    if (_exception)
    {
      *_exception = (struct ASE_BaseException__object *) _local_exception;
    }
    return;
  }
  (*parentFini)(parent, _exception);
}

static void destroyObject(struct ASE_Compiler_Python_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  finiObject(self->d_object, _exception);
  memset(self->d_object, 0, sizeof(struct ASE_Compiler_Python_DepthFirstVisitor__object));
  free(self->d_object);
}

static void initObject(/*in*/ struct ASE_Compiler_Python_DepthFirstVisitor__object *self, /*in*/ void *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_BaseClass__object *parent = &self->ase_baseclass;
  const struct ASE_BaseClass__external *(*extFunc)(void) = (const struct ASE_BaseClass__external *(*)(void)) ASE_Loader__externals()->getStaticEPV(_exception)->getClassMethodTable("ASE.BaseClass", _exception);
  void (*parentInit)(/*in*/ struct ASE_BaseClass__object *, /*in*/ void *, /*out*/ struct ASE_BaseException__object **_exception) = (extFunc())->initObject;
  static int epvInitialized = 0;
  static struct ASE_Compiler_Python_DepthFirstVisitor__epv ASE_Compiler_Python_DepthFirstVisitor_epv;
  static struct ASE_BaseClass__epv ASE_BaseClass_epv;
  static struct ASE_BaseInterface__epv ASE_BaseInterface_epv;
  static struct ASE_Compiler_Python_Visitor__epv ASE_Compiler_Python_Visitor_epv;
  static struct ASE_Compiler_Visitor__epv ASE_Compiler_Visitor_epv;
  static struct ASE_Compiler_Search__epv ASE_Compiler_Search_epv;
  
  if (!parentInit)
  {
    struct ASE_ASEException__object *_local_exception = ASE_ASEException__externals()->createObject(NULL);
    
    _local_exception->d_epv->setMessage(_local_exception, "Unable to find initializer for ASE.BaseClass", _exception);
    if (_exception)
    {
      *_exception = (struct ASE_BaseException__object *) _local_exception;
    }
    return;
  }
  (*parentInit)(parent, obj, _exception);
  if (!epvInitialized)
  {
    ASE_Compiler_Python_DepthFirstVisitor_epv.castObject = (void *(*)(struct ASE_Compiler_Python_DepthFirstVisitor__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)) castObject;
    ASE_Compiler_Python_DepthFirstVisitor_epv.destroyObject = (void (*)(struct ASE_Compiler_Python_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) destroyObject;
    ASE_Compiler_Python_DepthFirstVisitor_epv.strObject = (const char *(*)(struct ASE_Compiler_Python_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) strObject;
    ASE_Compiler_Python_DepthFirstVisitor_epv.getClassName = (const char *(*)(struct ASE_Compiler_Python_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) getClassName;
    ASE_Compiler_Python_DepthFirstVisitor__set_epv(&ASE_Compiler_Python_DepthFirstVisitor_epv, _exception);
    /* Override class ASE.Compiler.Python.DepthFirstVisitor methods with those of superclass ASE.BaseClass */
    ASE_Compiler_Python_DepthFirstVisitor_epv.getReferenceCount = (int32_t (*)(struct ASE_Compiler_Python_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_baseclass.d_epv->getReferenceCount;
    ASE_Compiler_Python_DepthFirstVisitor_epv.addReference = (void (*)(struct ASE_Compiler_Python_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_baseclass.d_epv->addReference;
    ASE_Compiler_Python_DepthFirstVisitor_epv.deleteReference = (void (*)(struct ASE_Compiler_Python_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_baseclass.d_epv->deleteReference;
    ASE_Compiler_Python_DepthFirstVisitor_epv.isSame = (int (*)(struct ASE_Compiler_Python_DepthFirstVisitor__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_baseclass.d_epv->isSame;
    ASE_Compiler_Python_DepthFirstVisitor_epv.getName = (const char *(*)(struct ASE_Compiler_Python_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_baseclass.d_epv->getName;
    ASE_Compiler_Python_DepthFirstVisitor_epv.setName = (void (*)(struct ASE_Compiler_Python_DepthFirstVisitor__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_baseclass.d_epv->setName;
    ASE_Compiler_Python_DepthFirstVisitor_epv.isInstanceOf = (int (*)(struct ASE_Compiler_Python_DepthFirstVisitor__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_baseclass.d_epv->isInstanceOf;
    ASE_Compiler_Python_DepthFirstVisitor_epv.getSuper = (struct ASE_BaseInterface__object *(*)(struct ASE_Compiler_Python_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_baseclass.d_epv->getSuper;
    /* Virtualize superclass ASE.BaseClass methods with those of class ASE.Compiler.Python.DepthFirstVisitor */
    ASE_BaseClass_epv.castObject = (void *(*)(struct ASE_BaseClass__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.castObject;
    ASE_BaseClass_epv.iterNext = (struct ASE_Compiler_Python_DepthFirstVisitor__object *(*)(struct ASE_BaseClass__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.iterNext;
    ASE_BaseClass_epv.destroyObject = (void (*)(struct ASE_BaseClass__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.destroyObject;
    ASE_BaseClass_epv.strObject = (const char *(*)(struct ASE_BaseClass__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.strObject;
    ASE_BaseClass_epv.getReferenceCount = (int32_t (*)(struct ASE_BaseClass__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.getReferenceCount;
    ASE_BaseClass_epv.addReference = (void (*)(struct ASE_BaseClass__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.addReference;
    ASE_BaseClass_epv.deleteReference = (void (*)(struct ASE_BaseClass__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.deleteReference;
    ASE_BaseClass_epv.isSame = (int (*)(struct ASE_BaseClass__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.isSame;
    ASE_BaseClass_epv.getClassName = (const char *(*)(struct ASE_BaseClass__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.getClassName;
    ASE_BaseClass_epv.getName = (const char *(*)(struct ASE_BaseClass__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.getName;
    ASE_BaseClass_epv.setName = (void (*)(struct ASE_BaseClass__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.setName;
    ASE_BaseClass_epv.isInstanceOf = (int (*)(struct ASE_BaseClass__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.isInstanceOf;
    ASE_BaseClass_epv.getSuper = (struct ASE_BaseInterface__object *(*)(struct ASE_BaseClass__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.getSuper;
    /* Initialize interface ASE.Compiler.Python.Visitor methods with those of class ASE.Compiler.Python.DepthFirstVisitor */
    ASE_Compiler_Python_Visitor_epv.castObject = (void *(*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.castObject;
    ASE_Compiler_Python_Visitor_epv.iterNext = (struct ASE_Compiler_Python_Visitor__object *(*)(struct ASE_Compiler_Python_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.iterNext;
    ASE_Compiler_Python_Visitor_epv.destroyObject = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.destroyObject;
    ASE_Compiler_Python_Visitor_epv.strObject = (const char *(*)(struct ASE_Compiler_Python_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.strObject;
    ASE_Compiler_Python_Visitor_epv.getReferenceCount = (int32_t (*)(struct ASE_Compiler_Python_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.getReferenceCount;
    ASE_Compiler_Python_Visitor_epv.addReference = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.addReference;
    ASE_Compiler_Python_Visitor_epv.deleteReference = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.deleteReference;
    ASE_Compiler_Python_Visitor_epv.isSame = (int (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.isSame;
    ASE_Compiler_Python_Visitor_epv.getClassName = (const char *(*)(struct ASE_Compiler_Python_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.getClassName;
    ASE_Compiler_Python_Visitor_epv.getName = (const char *(*)(struct ASE_Compiler_Python_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.getName;
    ASE_Compiler_Python_Visitor_epv.setName = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.setName;
    ASE_Compiler_Python_Visitor_epv.isInstanceOf = (int (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.isInstanceOf;
    ASE_Compiler_Python_Visitor_epv.getSuper = (struct ASE_BaseInterface__object *(*)(struct ASE_Compiler_Python_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.getSuper;
    ASE_Compiler_Python_Visitor_epv.getRepository = (struct ASE_Compiler_Vertex__array *(*)(struct ASE_Compiler_Python_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.getRepository;
    ASE_Compiler_Python_Visitor_epv.setRepository = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Vertex__array *repository, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.setRepository;
    ASE_Compiler_Python_Visitor_epv.visitVertex = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitVertex;
    ASE_Compiler_Python_Visitor_epv.visitAdd = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Add__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitAdd;
    ASE_Compiler_Python_Visitor_epv.visitAnd = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_And__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitAnd;
    ASE_Compiler_Python_Visitor_epv.visitAssAttr = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_AssAttr__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitAssAttr;
    ASE_Compiler_Python_Visitor_epv.visitAssList = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_AssList__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitAssList;
    ASE_Compiler_Python_Visitor_epv.visitAssName = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_AssName__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitAssName;
    ASE_Compiler_Python_Visitor_epv.visitAssTuple = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_AssTuple__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitAssTuple;
    ASE_Compiler_Python_Visitor_epv.visitAssign = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Assign__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitAssign;
    ASE_Compiler_Python_Visitor_epv.visitAugAssign = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_AugAssign__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitAugAssign;
    ASE_Compiler_Python_Visitor_epv.visitBitand = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Bitand__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitBitand;
    ASE_Compiler_Python_Visitor_epv.visitBitor = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Bitor__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitBitor;
    ASE_Compiler_Python_Visitor_epv.visitBitxor = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Bitxor__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitBitxor;
    ASE_Compiler_Python_Visitor_epv.visitBreak = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Break__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitBreak;
    ASE_Compiler_Python_Visitor_epv.visitCallFunc = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_CallFunc__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitCallFunc;
    ASE_Compiler_Python_Visitor_epv.visitClass = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Class__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitClass;
    ASE_Compiler_Python_Visitor_epv.visitCompare = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Compare__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitCompare;
    ASE_Compiler_Python_Visitor_epv.visitConst = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Const__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitConst;
    ASE_Compiler_Python_Visitor_epv.visitPyNone = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_PyNone__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitPyNone;
    ASE_Compiler_Python_Visitor_epv.visitContinue = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Continue__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitContinue;
    ASE_Compiler_Python_Visitor_epv.visitDict = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Dict__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitDict;
    ASE_Compiler_Python_Visitor_epv.visitDiscard = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Discard__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitDiscard;
    ASE_Compiler_Python_Visitor_epv.visitDiv = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Div__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitDiv;
    ASE_Compiler_Python_Visitor_epv.visitEllipsis = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Ellipsis__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitEllipsis;
    ASE_Compiler_Python_Visitor_epv.visitFor = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_For__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitFor;
    ASE_Compiler_Python_Visitor_epv.visitListCompFor = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_ListCompFor__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitListCompFor;
    ASE_Compiler_Python_Visitor_epv.visitFunction = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Function__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitFunction;
    ASE_Compiler_Python_Visitor_epv.visitLambda = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Lambda__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitLambda;
    ASE_Compiler_Python_Visitor_epv.visitGetAttr = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_GetAttr__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitGetAttr;
    ASE_Compiler_Python_Visitor_epv.visitGlobal = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Global__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitGlobal;
    ASE_Compiler_Python_Visitor_epv.visitIf = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_If__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitIf;
    ASE_Compiler_Python_Visitor_epv.visitListCompIf = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_ListCompIf__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitListCompIf;
    ASE_Compiler_Python_Visitor_epv.visitImport = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Import__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitImport;
    ASE_Compiler_Python_Visitor_epv.visitFrom = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_From__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitFrom;
    ASE_Compiler_Python_Visitor_epv.visitInvert = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Invert__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitInvert;
    ASE_Compiler_Python_Visitor_epv.visitKeyword = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Keyword__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitKeyword;
    ASE_Compiler_Python_Visitor_epv.visitLeftShift = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_LeftShift__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitLeftShift;
    ASE_Compiler_Python_Visitor_epv.visitList = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_List__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitList;
    ASE_Compiler_Python_Visitor_epv.visitListComp = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_ListComp__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitListComp;
    ASE_Compiler_Python_Visitor_epv.visitMod = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Mod__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitMod;
    ASE_Compiler_Python_Visitor_epv.visitModule = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Module__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitModule;
    ASE_Compiler_Python_Visitor_epv.visitMul = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Mul__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitMul;
    ASE_Compiler_Python_Visitor_epv.visitName = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Name__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitName;
    ASE_Compiler_Python_Visitor_epv.visitNot = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Not__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitNot;
    ASE_Compiler_Python_Visitor_epv.visitOr = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Or__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitOr;
    ASE_Compiler_Python_Visitor_epv.visitPass = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Pass__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitPass;
    ASE_Compiler_Python_Visitor_epv.visitPower = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Power__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitPower;
    ASE_Compiler_Python_Visitor_epv.visitPrint = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Print__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitPrint;
    ASE_Compiler_Python_Visitor_epv.visitPrintnl = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Printnl__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitPrintnl;
    ASE_Compiler_Python_Visitor_epv.visitRaise = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Raise__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitRaise;
    ASE_Compiler_Python_Visitor_epv.visitReturn = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Return__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitReturn;
    ASE_Compiler_Python_Visitor_epv.visitRightShift = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_RightShift__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitRightShift;
    ASE_Compiler_Python_Visitor_epv.visitSlice = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Slice__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitSlice;
    ASE_Compiler_Python_Visitor_epv.visitStmt = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Stmt__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitStmt;
    ASE_Compiler_Python_Visitor_epv.visitSub = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Sub__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitSub;
    ASE_Compiler_Python_Visitor_epv.visitSubscript = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Subscript__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitSubscript;
    ASE_Compiler_Python_Visitor_epv.visitTryExcept = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_TryExcept__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitTryExcept;
    ASE_Compiler_Python_Visitor_epv.visitTryFinally = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_TryFinally__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitTryFinally;
    ASE_Compiler_Python_Visitor_epv.visitTuple = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Tuple__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitTuple;
    ASE_Compiler_Python_Visitor_epv.visitUnaryAdd = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_UnaryAdd__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitUnaryAdd;
    ASE_Compiler_Python_Visitor_epv.visitUnarySub = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_UnarySub__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitUnarySub;
    ASE_Compiler_Python_Visitor_epv.visitWhile = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_While__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitWhile;
    ASE_Compiler_Python_Visitor_epv.visitYield = (void (*)(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Yield__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitYield;
    /* Initialize interface ASE.Compiler.Visitor methods with those of class ASE.Compiler.Python.DepthFirstVisitor */
    ASE_Compiler_Visitor_epv.castObject = (void *(*)(struct ASE_Compiler_Visitor__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.castObject;
    ASE_Compiler_Visitor_epv.iterNext = (struct ASE_Compiler_Visitor__object *(*)(struct ASE_Compiler_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.iterNext;
    ASE_Compiler_Visitor_epv.destroyObject = (void (*)(struct ASE_Compiler_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.destroyObject;
    ASE_Compiler_Visitor_epv.strObject = (const char *(*)(struct ASE_Compiler_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.strObject;
    ASE_Compiler_Visitor_epv.getReferenceCount = (int32_t (*)(struct ASE_Compiler_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.getReferenceCount;
    ASE_Compiler_Visitor_epv.addReference = (void (*)(struct ASE_Compiler_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.addReference;
    ASE_Compiler_Visitor_epv.deleteReference = (void (*)(struct ASE_Compiler_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.deleteReference;
    ASE_Compiler_Visitor_epv.isSame = (int (*)(struct ASE_Compiler_Visitor__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.isSame;
    ASE_Compiler_Visitor_epv.getClassName = (const char *(*)(struct ASE_Compiler_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.getClassName;
    ASE_Compiler_Visitor_epv.getName = (const char *(*)(struct ASE_Compiler_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.getName;
    ASE_Compiler_Visitor_epv.setName = (void (*)(struct ASE_Compiler_Visitor__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.setName;
    ASE_Compiler_Visitor_epv.isInstanceOf = (int (*)(struct ASE_Compiler_Visitor__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.isInstanceOf;
    ASE_Compiler_Visitor_epv.getSuper = (struct ASE_BaseInterface__object *(*)(struct ASE_Compiler_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.getSuper;
    ASE_Compiler_Visitor_epv.getRepository = (struct ASE_Compiler_Vertex__array *(*)(struct ASE_Compiler_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.getRepository;
    ASE_Compiler_Visitor_epv.setRepository = (void (*)(struct ASE_Compiler_Visitor__object *self, /*in*/ struct ASE_Compiler_Vertex__array *repository, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.setRepository;
    ASE_Compiler_Visitor_epv.visitVertex = (void (*)(struct ASE_Compiler_Visitor__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.visitVertex;
    /* Initialize interface ASE.BaseInterface methods with those of class ASE.Compiler.Python.DepthFirstVisitor */
    ASE_BaseInterface_epv.castObject = (void *(*)(struct ASE_BaseInterface__object *self, /*in*/ const char *name, /*out*/ void **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.castObject;
    ASE_BaseInterface_epv.iterNext = (struct ASE_BaseInterface__object *(*)(struct ASE_BaseInterface__object *self, /*out*/ void **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.iterNext;
    ASE_BaseInterface_epv.destroyObject = (void (*)(struct ASE_BaseInterface__object *self, /*out*/ void **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.destroyObject;
    ASE_BaseInterface_epv.strObject = (const char *(*)(struct ASE_BaseInterface__object *self, /*out*/ void **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.strObject;
    ASE_BaseInterface_epv.getReferenceCount = (int32_t (*)(struct ASE_BaseInterface__object *self, /*out*/ void **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.getReferenceCount;
    ASE_BaseInterface_epv.addReference = (void (*)(struct ASE_BaseInterface__object *self, /*out*/ void **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.addReference;
    ASE_BaseInterface_epv.deleteReference = (void (*)(struct ASE_BaseInterface__object *self, /*out*/ void **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.deleteReference;
    ASE_BaseInterface_epv.isSame = (int (*)(struct ASE_BaseInterface__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ void **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.isSame;
    ASE_BaseInterface_epv.getClassName = (const char *(*)(struct ASE_BaseInterface__object *self, /*out*/ void **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.getClassName;
    ASE_BaseInterface_epv.getName = (const char *(*)(struct ASE_BaseInterface__object *self, /*out*/ void **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.getName;
    ASE_BaseInterface_epv.setName = (void (*)(struct ASE_BaseInterface__object *self, /*in*/ const char *name, /*out*/ void **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.setName;
    ASE_BaseInterface_epv.isInstanceOf = (int (*)(struct ASE_BaseInterface__object *self, /*in*/ const char *typeName, /*out*/ void **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.isInstanceOf;
    ASE_BaseInterface_epv.getSuper = (struct ASE_BaseInterface__object *(*)(struct ASE_BaseInterface__object *self, /*out*/ void **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.getSuper;
    /* Initialize interface ASE.Compiler.Search methods with those of class ASE.Compiler.Python.DepthFirstVisitor */
    ASE_Compiler_Search_epv.castObject = (void *(*)(struct ASE_Compiler_Search__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.castObject;
    ASE_Compiler_Search_epv.iterNext = (struct ASE_Compiler_Search__object *(*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.iterNext;
    ASE_Compiler_Search_epv.destroyObject = (void (*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.destroyObject;
    ASE_Compiler_Search_epv.strObject = (const char *(*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.strObject;
    ASE_Compiler_Search_epv.getReferenceCount = (int32_t (*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.getReferenceCount;
    ASE_Compiler_Search_epv.addReference = (void (*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.addReference;
    ASE_Compiler_Search_epv.deleteReference = (void (*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.deleteReference;
    ASE_Compiler_Search_epv.isSame = (int (*)(struct ASE_Compiler_Search__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.isSame;
    ASE_Compiler_Search_epv.getClassName = (const char *(*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.getClassName;
    ASE_Compiler_Search_epv.getName = (const char *(*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.getName;
    ASE_Compiler_Search_epv.setName = (void (*)(struct ASE_Compiler_Search__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.setName;
    ASE_Compiler_Search_epv.isInstanceOf = (int (*)(struct ASE_Compiler_Search__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.isInstanceOf;
    ASE_Compiler_Search_epv.getSuper = (struct ASE_BaseInterface__object *(*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.getSuper;
    ASE_Compiler_Search_epv.getReverseEdges = (int (*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.getReverseEdges;
    ASE_Compiler_Search_epv.setReverseEdges = (void (*)(struct ASE_Compiler_Search__object *self, /*in*/ int reverseEdges, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.setReverseEdges;
    ASE_Compiler_Search_epv.traverseVertex = (void (*)(struct ASE_Compiler_Search__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.traverseVertex;
    ASE_Compiler_Search_epv.resetVertexNumbering = (void (*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.resetVertexNumbering;
    ASE_Compiler_Search_epv.discoverVertex = (void (*)(struct ASE_Compiler_Search__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.discoverVertex;
    ASE_Compiler_Search_epv.finishVertex = (void (*)(struct ASE_Compiler_Search__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.finishVertex;
    ASE_Compiler_Search_epv.getVerticesSeen = (struct ASE_Compiler_Vertex__array *(*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.getVerticesSeen;
    ASE_Compiler_Search_epv.setVerticesSeen = (void (*)(struct ASE_Compiler_Search__object *self, /*in*/ struct ASE_Compiler_Vertex__array *seen, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.setVerticesSeen;
    ASE_Compiler_Search_epv.getVertexSeen = (int (*)(struct ASE_Compiler_Search__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.getVertexSeen;
    ASE_Compiler_Search_epv.setVertexSeen = (void (*)(struct ASE_Compiler_Search__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*in*/ int state, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_Python_DepthFirstVisitor_epv.setVertexSeen;
    epvInitialized = 1;
  }
  self->ase_baseclass.ase_baseinterface.d_epv = &ASE_BaseInterface_epv;
  self->ase_baseclass.d_epv = &ASE_BaseClass_epv;
  self->ase_compiler_python_visitor.ase_compiler_visitor.ase_baseinterface.d_epv = &ASE_BaseInterface_epv;
  self->ase_compiler_python_visitor.ase_compiler_visitor.d_epv = &ASE_Compiler_Visitor_epv;
  self->ase_compiler_python_visitor.d_epv = &ASE_Compiler_Python_Visitor_epv;
  self->ase_compiler_search.ase_baseinterface.d_epv = &ASE_BaseInterface_epv;
  self->ase_compiler_search.d_epv = &ASE_Compiler_Search_epv;
  self->d_epv = &ASE_Compiler_Python_DepthFirstVisitor_epv;
  /* Save old EPV for getSuper() */
  self->d_oldEpv = self->d_epv;
  /* Initialize pointers to the original object */
  self->d_object = obj;
  self->ase_compiler_python_visitor.d_object = obj;
  self->ase_compiler_python_visitor.ase_compiler_visitor.d_object = obj;
  self->ase_compiler_python_visitor.ase_compiler_visitor.ase_baseinterface.d_object = obj;
  self->ase_compiler_search.d_object = obj;
  self->ase_compiler_search.ase_baseinterface.d_object = obj;
  /* Setup implementation data */
  self->d_data = NULL;
  /* Call the Skeleton constructor */
  (*(self->d_epv->DepthFirstVisitor))(self, _exception);
}

static struct ASE_Compiler_Python_DepthFirstVisitor__object *createObject(/*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_Python_DepthFirstVisitor__object *self = (struct ASE_Compiler_Python_DepthFirstVisitor__object *) malloc(sizeof(struct ASE_Compiler_Python_DepthFirstVisitor__object));
  
  initObject(self, self, _exception);
  return self;
}

#ifndef included_ASE_ASEException
#include <ASE/ASEException_IOR.h>
#endif

static struct ASE_Compiler_Python_DepthFirstVisitor__array *createArray(/*in*/ int32_t dimen, /*in*/ struct int__array *lower, /*in*/ struct int__array *upper, /*out*/ struct ASE_BaseException__object **_exception)
{
  static int32_t arraySize = sizeof(struct ASE_Compiler_Python_DepthFirstVisitor__array) + (sizeof(int32_t) - (sizeof(struct ASE_Compiler_Python_DepthFirstVisitor__array)) % sizeof(int32_t)) % sizeof(int32_t);
  struct ASE_Compiler_Python_DepthFirstVisitor__array *_return_value = (struct ASE_Compiler_Python_DepthFirstVisitor__array *) malloc(arraySize + 3 * sizeof(int32_t) * (dimen ? dimen : 1));
  int32_t size = 1;
  int32_t d = 0;
  
  /* Initialize array structure */
  _return_value->d_dimen = dimen;
  _return_value->d_borrowed = 0;
  _return_value->d_lower = (int32_t *) ((char *) _return_value + arraySize);
  _return_value->d_upper = _return_value->d_lower + (dimen ? dimen : 1);
  _return_value->d_stride = _return_value->d_upper + (dimen ? dimen : 1);
  _return_value->d_lower[0] = 0;
  _return_value->d_upper[0] = 0;
  _return_value->d_stride[0] = 1;
  /* Determine array size and set bounds */
  for(d = 0; d < dimen; d++)
  {
    _return_value->d_lower[d] = lower->d_firstElement[d];
    _return_value->d_upper[d] = upper->d_firstElement[d];
    _return_value->d_stride[d] = size;
    size *= upper->d_firstElement[d] - lower->d_firstElement[d] + 1;
  }
  size *= sizeof(struct ASE_Compiler_Python_DepthFirstVisitor__object *);
  /* Allocate and initialize data */
  _return_value->d_firstElement = (struct ASE_Compiler_Python_DepthFirstVisitor__object **) malloc(size);
  memset(_return_value->d_firstElement, 0, size);
  return _return_value;
}

static struct ASE_Compiler_Python_DepthFirstVisitor__array *borrowArray(/*in*/ int32_t dimen, /*in*/ struct int__array *lower, /*in*/ struct int__array *upper, /*in*/ struct int__array *stride, /*in*/ void *first, /*out*/ struct ASE_BaseException__object **_exception)
{
  static int32_t arraySize = sizeof(struct ASE_Compiler_Python_DepthFirstVisitor__array) + (sizeof(int32_t) - (sizeof(struct ASE_Compiler_Python_DepthFirstVisitor__array)) % sizeof(int32_t)) % sizeof(int32_t);
  struct ASE_Compiler_Python_DepthFirstVisitor__array *_return_value = (struct ASE_Compiler_Python_DepthFirstVisitor__array *) malloc(arraySize + 3 * sizeof(int32_t) * (dimen ? dimen : 1));
  int32_t size = 1;
  int32_t d = 0;
  
  /* Initialize array structure */
  _return_value->d_dimen = dimen;
  _return_value->d_borrowed = 1;
  _return_value->d_lower = (int32_t *) ((char *) _return_value + arraySize);
  _return_value->d_upper = _return_value->d_lower + (dimen ? dimen : 1);
  _return_value->d_stride = _return_value->d_upper + (dimen ? dimen : 1);
  _return_value->d_lower[0] = 0;
  _return_value->d_upper[0] = 0;
  _return_value->d_stride[0] = 1;
  /* Determine array size and set bounds */
  for(d = 0; d < dimen; d++)
  {
    _return_value->d_lower[d] = lower->d_firstElement[d];
    _return_value->d_upper[d] = upper->d_firstElement[d];
    _return_value->d_stride[d] = stride->d_firstElement[d];
    size *= upper->d_firstElement[d] - lower->d_firstElement[d] + 1;
  }
  size *= sizeof(struct ASE_Compiler_Python_DepthFirstVisitor__object *);
  _return_value->d_firstElement = (struct ASE_Compiler_Python_DepthFirstVisitor__object **) first;
  return _return_value;
}

static void destroyArray(/*in*/ struct ASE_Compiler_Python_DepthFirstVisitor__array *array, /*out*/ struct ASE_BaseException__object **_exception)
{
  if (!array->d_borrowed)
  {
    free(array->d_firstElement);
  }
  free(array);
}

static int32_t getDimen(/*in*/ struct ASE_Compiler_Python_DepthFirstVisitor__array *array, /*out*/ struct ASE_BaseException__object **_exception)
{
  return array->d_dimen;
}

static int32_t getLower(/*in*/ struct ASE_Compiler_Python_DepthFirstVisitor__array *array, /*in*/ int32_t dimen, /*out*/ struct ASE_BaseException__object **_exception)
{
  return array->d_lower[dimen];
}

static int32_t getUpper(/*in*/ struct ASE_Compiler_Python_DepthFirstVisitor__array *array, /*in*/ int32_t dimen, /*out*/ struct ASE_BaseException__object **_exception)
{
  return array->d_upper[dimen];
}

static struct ASE_Compiler_Python_DepthFirstVisitor__object *getElement(/*in*/ struct ASE_Compiler_Python_DepthFirstVisitor__array *array, /*in*/ struct int__array *indices, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_Python_DepthFirstVisitor__object *_result = NULL;
  struct ASE_Compiler_Python_DepthFirstVisitor__object **_element = NULL;
  int32_t d = 0;
  
  _element = array->d_firstElement;
  for(d = 0; d < array->d_dimen; d++)
  {
    if (indices->d_firstElement[d] < array->d_lower[d] || indices->d_firstElement[d] > array->d_upper[d])
    {
      struct ASE_ASEException__object *_local_exception = ASE_ASEException__externals()->createObject(NULL);
      
      _local_exception->d_epv->setMessage(_local_exception, "Invalid indices", _exception);
      if (_exception)
      {
        *_exception = (struct ASE_BaseException__object *) _local_exception;
      }
      return _result;
    }
    _element += array->d_stride[d] * (indices->d_firstElement[d] - array->d_lower[d]);
  }
  if (*_element)
  {
    (*(((struct ASE_BaseInterface__object *) (*_element)->d_object)->d_epv->deleteReference))((*_element)->d_object, (void **) _exception);
  }
  return *_element;
}

static struct ASE_Compiler_Python_DepthFirstVisitor__object *getElement4(/*in*/ struct ASE_Compiler_Python_DepthFirstVisitor__array *array, /*in*/ int32_t i1, /*in*/ int32_t i2, /*in*/ int32_t i3, /*in*/ int32_t i4, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_Python_DepthFirstVisitor__object *_result = NULL;
  
  return _result;
}

static void setElement(/*in*/ struct ASE_Compiler_Python_DepthFirstVisitor__array *array, /*in*/ struct int__array *indices, /*in*/ struct ASE_Compiler_Python_DepthFirstVisitor__object *value, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_Python_DepthFirstVisitor__object **_element = NULL;
  int32_t d = 0;
  
  _element = array->d_firstElement;
  for(d = 0; d < array->d_dimen; d++)
  {
    if (indices->d_firstElement[d] < array->d_lower[d] || indices->d_firstElement[d] > array->d_upper[d])
    {
      struct ASE_ASEException__object *_local_exception = ASE_ASEException__externals()->createObject(NULL);
      
      _local_exception->d_epv->setMessage(_local_exception, "Invalid indices", _exception);
      if (_exception)
      {
        *_exception = (struct ASE_BaseException__object *) _local_exception;
      }
      return;
    }
    _element += array->d_stride[d] * (indices->d_firstElement[d] - array->d_lower[d]);
  }
  if (value)
  {
    (*(((struct ASE_BaseInterface__object *) (value)->d_object)->d_epv->addReference))((value)->d_object, (void **) _exception);
  }
  if (*_element)
  {
    (*(((struct ASE_BaseInterface__object *) (*_element)->d_object)->d_epv->deleteReference))((*_element)->d_object, (void **) _exception);
  }
  *_element = value;
}

static void setElement4(/*in*/ struct ASE_Compiler_Python_DepthFirstVisitor__array *array, /*in*/ int32_t i1, /*in*/ int32_t i2, /*in*/ int32_t i3, /*in*/ int32_t i4, /*in*/ struct ASE_Compiler_Python_DepthFirstVisitor__object *value, /*out*/ struct ASE_BaseException__object **_exception)
{
}

static void *castIterator(struct ASE_Compiler_Python_DepthFirstVisitor__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  /* We are guaranteed here that the first member in any IOR is a ASE.BaseInterface object */
  struct ASE_BaseClass__object *obj = ((struct ASE_BaseInterface__object *) self)->d_object;
  void *cast = NULL;
  
  if (!strcmp(name, "ASE.Compiler.Python.DepthFirstVisitor"))
  {
    cast = self;
  }
  else
  if (!strcmp(name, "ASE.BaseClass"))
  {
    cast = obj;
  }
  else
  if (!strcmp(name, "ASE.BaseInterface"))
  {
    cast = (&obj->ase_baseinterface);
  }
  return cast;
}

static struct ASE_Compiler_Python_DepthFirstVisitor__iterator *createIterator(/*in*/ void *iterator, /*in*/ void *iterNext, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_Python_DepthFirstVisitor__iterator *self = (struct ASE_Compiler_Python_DepthFirstVisitor__iterator *) malloc(sizeof(struct ASE_Compiler_Python_DepthFirstVisitor__iterator));
  struct ASE_BaseClass__object *parent = &self->ase_baseclass;
  struct ASE_BaseClass__epv *ASE_BaseClass_epv = (struct ASE_BaseClass__epv *) malloc(sizeof(struct ASE_BaseClass__epv));
  struct ASE_BaseInterface__epv *ASE_BaseInterface_epv = (struct ASE_BaseInterface__epv *) malloc(sizeof(struct ASE_BaseInterface__epv));
  
  (*(ASE_BaseClass__externals()->initObject))(parent, self, _exception);
  ASE_BaseClass_epv->getReferenceCount = self->ase_baseclass.d_epv->getReferenceCount;
  ASE_BaseClass_epv->addReference = self->ase_baseclass.d_epv->addReference;
  ASE_BaseClass_epv->deleteReference = self->ase_baseclass.d_epv->deleteReference;
  ASE_BaseClass_epv->isSame = self->ase_baseclass.d_epv->isSame;
  ASE_BaseClass_epv->getClassName = self->ase_baseclass.d_epv->getClassName;
  ASE_BaseClass_epv->getName = self->ase_baseclass.d_epv->getName;
  ASE_BaseClass_epv->setName = self->ase_baseclass.d_epv->setName;
  ASE_BaseClass_epv->isInstanceOf = self->ase_baseclass.d_epv->isInstanceOf;
  ASE_BaseClass_epv->getSuper = self->ase_baseclass.d_epv->getSuper;
  ASE_BaseInterface_epv->getReferenceCount = self->ase_baseclass.ase_baseinterface.d_epv->getReferenceCount;
  ASE_BaseInterface_epv->addReference = self->ase_baseclass.ase_baseinterface.d_epv->addReference;
  ASE_BaseInterface_epv->deleteReference = self->ase_baseclass.ase_baseinterface.d_epv->deleteReference;
  ASE_BaseInterface_epv->isSame = self->ase_baseclass.ase_baseinterface.d_epv->isSame;
  ASE_BaseInterface_epv->getClassName = self->ase_baseclass.ase_baseinterface.d_epv->getClassName;
  ASE_BaseInterface_epv->getName = self->ase_baseclass.ase_baseinterface.d_epv->getName;
  ASE_BaseInterface_epv->setName = self->ase_baseclass.ase_baseinterface.d_epv->setName;
  ASE_BaseInterface_epv->isInstanceOf = self->ase_baseclass.ase_baseinterface.d_epv->isInstanceOf;
  ASE_BaseInterface_epv->getSuper = self->ase_baseclass.ase_baseinterface.d_epv->getSuper;
  ASE_BaseClass_epv->castObject = castIterator;
  ASE_BaseClass_epv->iterNext = iterNext;
  ASE_BaseInterface_epv->castObject = castIterator;
  ASE_BaseInterface_epv->iterNext = iterNext;
  self->ase_baseclass.ase_baseinterface.d_epv = ASE_BaseInterface_epv;
  self->ase_baseclass.d_epv = ASE_BaseClass_epv;
  self->iterator = iterator;
  self->objWrapper = NULL;
  return self;
}

static void destroyIterator(/*in*/ struct ASE_Compiler_Python_DepthFirstVisitor__iterator *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_BaseClass__object *parent = &self->ase_baseclass;
  
  self->iterator = NULL;
  self->objWrapper = NULL;
  free(self->ase_baseclass.ase_baseinterface.d_epv);
  free(self->ase_baseclass.d_epv);
  self->ase_baseclass.d_epv = self->ase_baseclass.d_oldEpv;
  (*(ASE_BaseClass__externals()->finiObject))(parent, _exception);
  memset(self, 0, sizeof(struct ASE_Compiler_Python_DepthFirstVisitor__iterator));
  free(self);
}

/* The entry points into the DLL containing this type */
static struct ASE_Compiler_Python_DepthFirstVisitor__external externalEntryPoints = {
  createObject,
  initObject,
  finiObject,
  createArray,
  borrowArray,
  destroyArray,
  getDimen,
  getLower,
  getUpper,
  getElement,
  getElement4,
  setElement,
  setElement4,
  createIterator,
  destroyIterator};

const struct ASE_Compiler_Python_DepthFirstVisitor__external *ASE_Compiler_Python_DepthFirstVisitor__externals(void)
{
  return &externalEntryPoints;
}
