# Starting imports section
pass
import ASE.BaseClass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.CompilerException
import ASE.Compiler.Python.Add
import ASE.Compiler.Python.And
import ASE.Compiler.Python.AssAttr
import ASE.Compiler.Python.AssList
import ASE.Compiler.Python.AssName
import ASE.Compiler.Python.AssTuple
import ASE.Compiler.Python.Assign
import ASE.Compiler.Python.AugAssign
import ASE.Compiler.Python.Bitand
import ASE.Compiler.Python.Bitor
import ASE.Compiler.Python.Bitxor
import ASE.Compiler.Python.Break
import ASE.Compiler.Python.CallFunc
import ASE.Compiler.Python.Class
import ASE.Compiler.Python.Compare
import ASE.Compiler.Python.Const
import ASE.Compiler.Python.Continue
import ASE.Compiler.Python.Dict
import ASE.Compiler.Python.Discard
import ASE.Compiler.Python.Div
import ASE.Compiler.Python.Ellipsis
import ASE.Compiler.Python.For
import ASE.Compiler.Python.From
import ASE.Compiler.Python.Function
import ASE.Compiler.Python.GetAttr
import ASE.Compiler.Python.Global
import ASE.Compiler.Python.If
import ASE.Compiler.Python.Import
import ASE.Compiler.Python.Invert
import ASE.Compiler.Python.Keyword
import ASE.Compiler.Python.Lambda
import ASE.Compiler.Python.LeftShift
import ASE.Compiler.Python.List
import ASE.Compiler.Python.ListComp
import ASE.Compiler.Python.ListCompFor
import ASE.Compiler.Python.ListCompIf
import ASE.Compiler.Python.Mod
import ASE.Compiler.Python.Module
import ASE.Compiler.Python.Mul
import ASE.Compiler.Python.Name
import ASE.Compiler.Python.Not
import ASE.Compiler.Python.Or
import ASE.Compiler.Python.Pass
import ASE.Compiler.Python.Power
import ASE.Compiler.Python.Print
import ASE.Compiler.Python.Printnl
import ASE.Compiler.Python.PyNone
import ASE.Compiler.Python.Raise
import ASE.Compiler.Python.Return
import ASE.Compiler.Python.RightShift
import ASE.Compiler.Python.Slice
import ASE.Compiler.Python.Stmt
import ASE.Compiler.Python.Sub
import ASE.Compiler.Python.Subscript
import ASE.Compiler.Python.TryExcept
import ASE.Compiler.Python.TryFinally
import ASE.Compiler.Python.Tuple
import ASE.Compiler.Python.UnaryAdd
import ASE.Compiler.Python.UnarySub
import ASE.Compiler.Python.Visitor
import ASE.Compiler.Python.While
import ASE.Compiler.Python.Yield
import ASE.Compiler.Search
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class DepthFirstVisitor:
  '''
  Traverses the AST in a depth first manner
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.repository = []
    self.seen = []
    self.reverseEdges = 0
    self.vertexNumber = 0
  
  def getRepository(self):
    '''
    Retrieve auxilliary ASTs
    '''
    return self.repository
  
  def setRepository(self, repository):
    '''
    Set auxilliary ASTs
    '''
    self.repository = repository
  
  def visitVertex(self, vertex):
    self.discoverVertex(vertex)
    self.__IORself.traverseVertex(vertex)
    self.finishVertex(vertex)
  
  def visitAdd(self, node):
    self.__IORself.visitVertex(node)
  
  def visitAnd(self, node):
    self.__IORself.visitVertex(node)
  
  def visitAssAttr(self, node):
    self.__IORself.visitVertex(node)
  
  def visitAssList(self, node):
    self.__IORself.visitVertex(node)
  
  def visitAssName(self, node):
    self.__IORself.visitVertex(node)
  
  def visitAssTuple(self, node):
    self.__IORself.visitVertex(node)
  
  def visitAssign(self, node):
    self.__IORself.visitVertex(node)
  
  def visitAugAssign(self, node):
    self.__IORself.visitVertex(node)
  
  def visitBitand(self, node):
    self.__IORself.visitVertex(node)
  
  def visitBitor(self, node):
    self.__IORself.visitVertex(node)
  
  def visitBitxor(self, node):
    self.__IORself.visitVertex(node)
  
  def visitBreak(self, node):
    self.__IORself.visitVertex(node)
  
  def visitCallFunc(self, node):
    self.__IORself.visitVertex(node)
  
  def visitClass(self, node):
    self.__IORself.visitVertex(node)
  
  def visitCompare(self, node):
    self.__IORself.visitVertex(node)
  
  def visitConst(self, node):
    self.__IORself.visitVertex(node)
  
  def visitPyNone(self, node):
    self.__IORself.visitVertex(node)
  
  def visitContinue(self, node):
    self.__IORself.visitVertex(node)
  
  def visitDict(self, node):
    self.__IORself.visitVertex(node)
  
  def visitDiscard(self, node):
    self.__IORself.visitVertex(node)
  
  def visitDiv(self, node):
    self.__IORself.visitVertex(node)
  
  def visitEllipsis(self, node):
    self.__IORself.visitVertex(node)
  
  def visitFor(self, node):
    self.__IORself.visitVertex(node)
  
  def visitListCompFor(self, node):
    self.__IORself.visitVertex(node)
  
  def visitFunction(self, node):
    self.__IORself.visitVertex(node)
  
  def visitLambda(self, node):
    self.__IORself.visitVertex(node)
  
  def visitGetAttr(self, node):
    self.__IORself.visitVertex(node)
  
  def visitGlobal(self, node):
    self.__IORself.visitVertex(node)
  
  def visitIf(self, node):
    self.__IORself.visitVertex(node)
  
  def visitListCompIf(self, node):
    self.__IORself.visitVertex(node)
  
  def visitImport(self, node):
    self.__IORself.visitVertex(node)
  
  def visitFrom(self, node):
    self.__IORself.visitVertex(node)
  
  def visitInvert(self, node):
    self.__IORself.visitVertex(node)
  
  def visitKeyword(self, node):
    self.__IORself.visitVertex(node)
  
  def visitLeftShift(self, node):
    self.__IORself.visitVertex(node)
  
  def visitList(self, node):
    self.__IORself.visitVertex(node)
  
  def visitListComp(self, node):
    self.__IORself.visitVertex(node)
  
  def visitMod(self, node):
    self.__IORself.visitVertex(node)
  
  def visitModule(self, node):
    self.__IORself.visitVertex(node)
  
  def visitMul(self, node):
    self.__IORself.visitVertex(node)
  
  def visitName(self, node):
    self.__IORself.visitVertex(node)
  
  def visitNot(self, node):
    self.__IORself.visitVertex(node)
  
  def visitOr(self, node):
    self.__IORself.visitVertex(node)
  
  def visitPass(self, node):
    self.__IORself.visitVertex(node)
  
  def visitPower(self, node):
    self.__IORself.visitVertex(node)
  
  def visitPrint(self, node):
    self.__IORself.visitVertex(node)
  
  def visitPrintnl(self, node):
    self.__IORself.visitVertex(node)
  
  def visitRaise(self, node):
    self.__IORself.visitVertex(node)
  
  def visitReturn(self, node):
    self.__IORself.visitVertex(node)
  
  def visitRightShift(self, node):
    self.__IORself.visitVertex(node)
  
  def visitSlice(self, node):
    self.__IORself.visitVertex(node)
  
  def visitStmt(self, node):
    self.__IORself.visitVertex(node)
  
  def visitSub(self, node):
    self.__IORself.visitVertex(node)
  
  def visitSubscript(self, node):
    self.__IORself.visitVertex(node)
  
  def visitTryExcept(self, node):
    self.__IORself.visitVertex(node)
  
  def visitTryFinally(self, node):
    self.__IORself.visitVertex(node)
  
  def visitTuple(self, node):
    self.__IORself.visitVertex(node)
  
  def visitUnaryAdd(self, node):
    self.__IORself.visitVertex(node)
  
  def visitUnarySub(self, node):
    self.__IORself.visitVertex(node)
  
  def visitWhile(self, node):
    self.__IORself.visitVertex(node)
  
  def visitYield(self, node):
    self.__IORself.visitVertex(node)
  
  def getReverseEdges(self):
    '''
    Retrieve the flag for reversing the orientation of edges in the traversal
    '''
    return self.reverseEdges
  
  def setReverseEdges(self, reverseEdges):
    '''
    Set the flag for reversing the orientation of edges in the traversal
    '''
    self.reverseEdges = reverseEdges
  
  def traverseVertex(self, vertex):
    '''
    Traverse each edge of this vertex
    '''
    self.__IORself.setVertexSeen(vertex, 1)
    if self.__IORself.getReverseEdges():
      neighbors = [vertex.getParent()]
    else:
      neighbors = vertex.getChildren()
    for neighbor in neighbors:
      neighbor.accept(self.__IORself)
  
  def resetVertexNumbering(self):
    '''
    Reset the vertex discovery and finish numbering
    '''
    self.vertexNumber = 0
  
  def discoverVertex(self, vertex):
    '''
    Mark a vertex as discovered and increment the count
    '''
    self.vertexNumber += 1
  
  def finishVertex(self, vertex):
    '''
    Mark a vertex as finished and increment the count
    '''
    self.vertexNumber += 1
  
  def getVerticesSeen(self):
    '''
    Retrieve the list of vertices discovered
    '''
    return self.seen
  
  def setVerticesSeen(self, seen):
    '''
    Set the list of vertices discovered
    '''
    self.seen = list(seen)
  
  def getVertexSeen(self, vertex):
    '''
    Retrieve the vertex discovery state
    '''
    return vertex in self.seen
  
  def setVertexSeen(self, vertex, state):
    '''
    Set the vertex discovery state
    '''
    if state:
      if not (vertex in self.seen):
        self.seen.append(vertex)
    else:
      if vertex in self.seen:
        self.seen.remove(vertex)
  # Ending class methods section
  pass
