# Starting imports section
pass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.Attribute
import ASE.Compiler.Comment
import ASE.Compiler.CompilerException
import ASE.Compiler.SIDL.Type
import ASE.Compiler.SIDL.Vertex
import ASE.Compiler.SIDL.Visitor
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class TypeUniverse:
  '''
  A set of SIDL types
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.types = []
  
  def accept(self, visitor):
    '''
    Overridden to dispatch correctly
    '''
    visitor.visitTypeUniverse(self.__IORself)
  
  def getTypes(self):
    '''
    Retrieve the universe of types
    '''
    return self.types
  
  def setTypes(self, types):
    '''
    Set the universe of types
    '''
    self.types = list(types)
  
  def addTypes(self, types):
    '''
    Augment the universe of types
    '''
    self.types.extend(types)
  
  def removeTypes(self, types):
    '''
    Diminish the universe of types
    Throws an exception if a type does not exist
    '''
    for type in types:
      if type in self.types:
        self.types.remove(type)
      else:
        e = ASE.Compiler.CompilerException()
        e.setMessage('Type does not exist: ' + type.getIdentifier())
        raise e
  # Ending class methods section
  pass
