#include <stdlib.h>

#include <string.h>

#ifndef included_ASE_Compiler_SIDL_Resolver
#include <ASE/Compiler/SIDL/Resolver_IOR.h>
#endif

#ifndef included_ASE_Loader
#include <ASE/Loader_IOR.h>
#endif

/* Initialization routine defined in the skeleton */
extern void ASE_Compiler_SIDL_Resolver__set_epv(struct ASE_Compiler_SIDL_Resolver__epv *epv, struct ASE_BaseException__object **_exception);

static const char *getClassName(struct ASE_Compiler_SIDL_Resolver__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return strdup("ASE.Compiler.SIDL.Resolver");
}

#ifndef included_ASE_ASEException
#include <ASE/ASEException_IOR.h>
#endif

static void *castObject(struct ASE_Compiler_SIDL_Resolver__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  /* We are guaranteed here that the first member in any IOR is a ASE.BaseInterface object */
  struct ASE_Compiler_SIDL_Resolver__object *obj = ((struct ASE_BaseInterface__object *) self)->d_object;
  void *cast = NULL;
  
  if (!strcmp(name, "ASE.Compiler.SIDL.Resolver"))
  {
    cast = obj;
  }
  else
  if (!strcmp(name, "ASE.Compiler.SIDL.DepthFirstVisitor"))
  {
    cast = (&obj->ase_compiler_sidl_depthfirstvisitor);
  }
  else
  if (!strcmp(name, "ASE.BaseClass"))
  {
    cast = (&(&obj->ase_compiler_sidl_depthfirstvisitor)->ase_baseclass);
  }
  else
  if (!strcmp(name, "ASE.BaseInterface"))
  {
    cast = (&(&(&obj->ase_compiler_sidl_depthfirstvisitor)->ase_baseclass)->ase_baseinterface);
  }
  else
  if (!strcmp(name, "ASE.Compiler.SIDL.Visitor"))
  {
    cast = (&(&obj->ase_compiler_sidl_depthfirstvisitor)->ase_compiler_sidl_visitor);
  }
  else
  if (!strcmp(name, "ASE.Compiler.Visitor"))
  {
    cast = (&(&(&obj->ase_compiler_sidl_depthfirstvisitor)->ase_compiler_sidl_visitor)->ase_compiler_visitor);
  }
  else
  if (!strcmp(name, "ASE.Compiler.Search"))
  {
    cast = (&(&obj->ase_compiler_sidl_depthfirstvisitor)->ase_compiler_search);
  }
  return cast;
}

static const char *strObject(struct ASE_Compiler_SIDL_Resolver__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return "ASE.Compiler.SIDL.Resolver";
}

static void finiObject(/*in*/ struct ASE_Compiler_SIDL_Resolver__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_SIDL_DepthFirstVisitor__object *parent = &self->ase_compiler_sidl_depthfirstvisitor;
  const struct ASE_Compiler_SIDL_DepthFirstVisitor__external *(*extFunc)(void) = (const struct ASE_Compiler_SIDL_DepthFirstVisitor__external *(*)(void)) ASE_Loader__externals()->getStaticEPV(_exception)->getClassMethodTable("ASE.Compiler.SIDL.DepthFirstVisitor", _exception);
  void (*parentFini)(/*in*/ struct ASE_Compiler_SIDL_DepthFirstVisitor__object *, /*out*/ struct ASE_BaseException__object **_exception) = (extFunc())->finiObject;
  
  self->ase_compiler_sidl_depthfirstvisitor.d_epv = self->ase_compiler_sidl_depthfirstvisitor.d_oldEpv;
  (*(self->d_epv->Resolver_))(self, _exception);
  if (!parentFini)
  {
    struct ASE_ASEException__object *_local_exception = ASE_ASEException__externals()->createObject(NULL);
    
    _local_exception->d_epv->setMessage(_local_exception, "Unable to find finalizer for ASE.Compiler.SIDL.DepthFirstVisitor", _exception);
    if (_exception)
    {
      *_exception = (struct ASE_BaseException__object *) _local_exception;
    }
    return;
  }
  (*parentFini)(parent, _exception);
}

static void destroyObject(struct ASE_Compiler_SIDL_Resolver__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  finiObject(self->d_object, _exception);
  memset(self->d_object, 0, sizeof(struct ASE_Compiler_SIDL_Resolver__object));
  free(self->d_object);
}

static void initObject(/*in*/ struct ASE_Compiler_SIDL_Resolver__object *self, /*in*/ void *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_SIDL_DepthFirstVisitor__object *parent = &self->ase_compiler_sidl_depthfirstvisitor;
  const struct ASE_Compiler_SIDL_DepthFirstVisitor__external *(*extFunc)(void) = (const struct ASE_Compiler_SIDL_DepthFirstVisitor__external *(*)(void)) ASE_Loader__externals()->getStaticEPV(_exception)->getClassMethodTable("ASE.Compiler.SIDL.DepthFirstVisitor", _exception);
  void (*parentInit)(/*in*/ struct ASE_Compiler_SIDL_DepthFirstVisitor__object *, /*in*/ void *, /*out*/ struct ASE_BaseException__object **_exception) = (extFunc())->initObject;
  static int epvInitialized = 0;
  static struct ASE_Compiler_SIDL_Resolver__epv ASE_Compiler_SIDL_Resolver_epv;
  static struct ASE_Compiler_SIDL_DepthFirstVisitor__epv ASE_Compiler_SIDL_DepthFirstVisitor_epv;
  static struct ASE_BaseClass__epv ASE_BaseClass_epv;
  static struct ASE_BaseInterface__epv ASE_BaseInterface_epv;
  static struct ASE_Compiler_SIDL_Visitor__epv ASE_Compiler_SIDL_Visitor_epv;
  static struct ASE_Compiler_Visitor__epv ASE_Compiler_Visitor_epv;
  static struct ASE_Compiler_Search__epv ASE_Compiler_Search_epv;
  
  if (!parentInit)
  {
    struct ASE_ASEException__object *_local_exception = ASE_ASEException__externals()->createObject(NULL);
    
    _local_exception->d_epv->setMessage(_local_exception, "Unable to find initializer for ASE.Compiler.SIDL.DepthFirstVisitor", _exception);
    if (_exception)
    {
      *_exception = (struct ASE_BaseException__object *) _local_exception;
    }
    return;
  }
  (*parentInit)(parent, obj, _exception);
  if (!epvInitialized)
  {
    ASE_Compiler_SIDL_Resolver_epv.castObject = (void *(*)(struct ASE_Compiler_SIDL_Resolver__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)) castObject;
    ASE_Compiler_SIDL_Resolver_epv.destroyObject = (void (*)(struct ASE_Compiler_SIDL_Resolver__object *self, /*out*/ struct ASE_BaseException__object **_exception)) destroyObject;
    ASE_Compiler_SIDL_Resolver_epv.strObject = (const char *(*)(struct ASE_Compiler_SIDL_Resolver__object *self, /*out*/ struct ASE_BaseException__object **_exception)) strObject;
    ASE_Compiler_SIDL_Resolver_epv.getClassName = (const char *(*)(struct ASE_Compiler_SIDL_Resolver__object *self, /*out*/ struct ASE_BaseException__object **_exception)) getClassName;
    ASE_Compiler_SIDL_Resolver__set_epv(&ASE_Compiler_SIDL_Resolver_epv, _exception);
    /* Override class ASE.Compiler.SIDL.Resolver methods with those of superclass ASE.Compiler.SIDL.DepthFirstVisitor */
    ASE_Compiler_SIDL_Resolver_epv.getRepository = (struct ASE_Compiler_Vertex__array *(*)(struct ASE_Compiler_SIDL_Resolver__object *self, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_compiler_sidl_depthfirstvisitor.d_epv->getRepository;
    ASE_Compiler_SIDL_Resolver_epv.setRepository = (void (*)(struct ASE_Compiler_SIDL_Resolver__object *self, /*in*/ struct ASE_Compiler_Vertex__array *repository, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_compiler_sidl_depthfirstvisitor.d_epv->setRepository;
    ASE_Compiler_SIDL_Resolver_epv.visitVertex = (void (*)(struct ASE_Compiler_SIDL_Resolver__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_compiler_sidl_depthfirstvisitor.d_epv->visitVertex;
    ASE_Compiler_SIDL_Resolver_epv.visitPackage = (void (*)(struct ASE_Compiler_SIDL_Resolver__object *self, /*in*/ struct ASE_Compiler_SIDL_Package__object *node, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_compiler_sidl_depthfirstvisitor.d_epv->visitPackage;
    ASE_Compiler_SIDL_Resolver_epv.visitType = (void (*)(struct ASE_Compiler_SIDL_Resolver__object *self, /*in*/ struct ASE_Compiler_SIDL_Type__object *node, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_compiler_sidl_depthfirstvisitor.d_epv->visitType;
    ASE_Compiler_SIDL_Resolver_epv.visitEnumerator = (void (*)(struct ASE_Compiler_SIDL_Resolver__object *self, /*in*/ struct ASE_Compiler_SIDL_Enumerator__object *node, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_compiler_sidl_depthfirstvisitor.d_epv->visitEnumerator;
    ASE_Compiler_SIDL_Resolver_epv.visitArray = (void (*)(struct ASE_Compiler_SIDL_Resolver__object *self, /*in*/ struct ASE_Compiler_SIDL_Array__object *node, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_compiler_sidl_depthfirstvisitor.d_epv->visitArray;
    ASE_Compiler_SIDL_Resolver_epv.visitIterator = (void (*)(struct ASE_Compiler_SIDL_Resolver__object *self, /*in*/ struct ASE_Compiler_SIDL_Iterator__object *node, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_compiler_sidl_depthfirstvisitor.d_epv->visitIterator;
    ASE_Compiler_SIDL_Resolver_epv.getReverseEdges = (int (*)(struct ASE_Compiler_SIDL_Resolver__object *self, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_compiler_sidl_depthfirstvisitor.d_epv->getReverseEdges;
    ASE_Compiler_SIDL_Resolver_epv.setReverseEdges = (void (*)(struct ASE_Compiler_SIDL_Resolver__object *self, /*in*/ int reverseEdges, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_compiler_sidl_depthfirstvisitor.d_epv->setReverseEdges;
    ASE_Compiler_SIDL_Resolver_epv.traverseVertex = (void (*)(struct ASE_Compiler_SIDL_Resolver__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_compiler_sidl_depthfirstvisitor.d_epv->traverseVertex;
    ASE_Compiler_SIDL_Resolver_epv.resetVertexNumbering = (void (*)(struct ASE_Compiler_SIDL_Resolver__object *self, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_compiler_sidl_depthfirstvisitor.d_epv->resetVertexNumbering;
    ASE_Compiler_SIDL_Resolver_epv.discoverVertex = (void (*)(struct ASE_Compiler_SIDL_Resolver__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_compiler_sidl_depthfirstvisitor.d_epv->discoverVertex;
    ASE_Compiler_SIDL_Resolver_epv.finishVertex = (void (*)(struct ASE_Compiler_SIDL_Resolver__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_compiler_sidl_depthfirstvisitor.d_epv->finishVertex;
    ASE_Compiler_SIDL_Resolver_epv.getVerticesSeen = (struct ASE_Compiler_Vertex__array *(*)(struct ASE_Compiler_SIDL_Resolver__object *self, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_compiler_sidl_depthfirstvisitor.d_epv->getVerticesSeen;
    ASE_Compiler_SIDL_Resolver_epv.setVerticesSeen = (void (*)(struct ASE_Compiler_SIDL_Resolver__object *self, /*in*/ struct ASE_Compiler_Vertex__array *seen, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_compiler_sidl_depthfirstvisitor.d_epv->setVerticesSeen;
    ASE_Compiler_SIDL_Resolver_epv.getVertexSeen = (int (*)(struct ASE_Compiler_SIDL_Resolver__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_compiler_sidl_depthfirstvisitor.d_epv->getVertexSeen;
    ASE_Compiler_SIDL_Resolver_epv.setVertexSeen = (void (*)(struct ASE_Compiler_SIDL_Resolver__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*in*/ int state, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_compiler_sidl_depthfirstvisitor.d_epv->setVertexSeen;
    ASE_Compiler_SIDL_Resolver_epv.getReferenceCount = (int32_t (*)(struct ASE_Compiler_SIDL_Resolver__object *self, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_compiler_sidl_depthfirstvisitor.d_epv->getReferenceCount;
    ASE_Compiler_SIDL_Resolver_epv.addReference = (void (*)(struct ASE_Compiler_SIDL_Resolver__object *self, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_compiler_sidl_depthfirstvisitor.d_epv->addReference;
    ASE_Compiler_SIDL_Resolver_epv.deleteReference = (void (*)(struct ASE_Compiler_SIDL_Resolver__object *self, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_compiler_sidl_depthfirstvisitor.d_epv->deleteReference;
    ASE_Compiler_SIDL_Resolver_epv.isSame = (int (*)(struct ASE_Compiler_SIDL_Resolver__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_compiler_sidl_depthfirstvisitor.d_epv->isSame;
    ASE_Compiler_SIDL_Resolver_epv.getName = (const char *(*)(struct ASE_Compiler_SIDL_Resolver__object *self, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_compiler_sidl_depthfirstvisitor.d_epv->getName;
    ASE_Compiler_SIDL_Resolver_epv.setName = (void (*)(struct ASE_Compiler_SIDL_Resolver__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_compiler_sidl_depthfirstvisitor.d_epv->setName;
    ASE_Compiler_SIDL_Resolver_epv.isInstanceOf = (int (*)(struct ASE_Compiler_SIDL_Resolver__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_compiler_sidl_depthfirstvisitor.d_epv->isInstanceOf;
    ASE_Compiler_SIDL_Resolver_epv.getSuper = (struct ASE_BaseInterface__object *(*)(struct ASE_Compiler_SIDL_Resolver__object *self, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_compiler_sidl_depthfirstvisitor.d_epv->getSuper;
    /* Virtualize superclass ASE.Compiler.SIDL.DepthFirstVisitor methods with those of class ASE.Compiler.SIDL.Resolver */
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.castObject = (void *(*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.castObject;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.iterNext = (struct ASE_Compiler_SIDL_Resolver__object *(*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.iterNext;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.destroyObject = (void (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.destroyObject;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.strObject = (const char *(*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.strObject;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.getRepository = (struct ASE_Compiler_Vertex__array *(*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.getRepository;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.setRepository = (void (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*in*/ struct ASE_Compiler_Vertex__array *repository, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.setRepository;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.visitVertex = (void (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.visitVertex;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.visitSpecification = (void (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*in*/ struct ASE_Compiler_SIDL_Specification__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.visitSpecification;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.visitPackage = (void (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*in*/ struct ASE_Compiler_SIDL_Package__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.visitPackage;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.visitType = (void (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*in*/ struct ASE_Compiler_SIDL_Type__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.visitType;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.visitTypeUniverse = (void (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*in*/ struct ASE_Compiler_SIDL_TypeUniverse__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.visitTypeUniverse;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.visitEnumeration = (void (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*in*/ struct ASE_Compiler_SIDL_Enumeration__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.visitEnumeration;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.visitEnumerator = (void (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*in*/ struct ASE_Compiler_SIDL_Enumerator__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.visitEnumerator;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.visitArray = (void (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*in*/ struct ASE_Compiler_SIDL_Array__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.visitArray;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.visitIterator = (void (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*in*/ struct ASE_Compiler_SIDL_Iterator__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.visitIterator;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.visitInterface = (void (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*in*/ struct ASE_Compiler_SIDL_Interface__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.visitInterface;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.visitClass = (void (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*in*/ struct ASE_Compiler_SIDL_Class__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.visitClass;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.visitParameter = (void (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*in*/ struct ASE_Compiler_SIDL_Parameter__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.visitParameter;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.visitMethod = (void (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*in*/ struct ASE_Compiler_SIDL_Method__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.visitMethod;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.getReverseEdges = (int (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.getReverseEdges;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.setReverseEdges = (void (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*in*/ int reverseEdges, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.setReverseEdges;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.traverseVertex = (void (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.traverseVertex;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.resetVertexNumbering = (void (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.resetVertexNumbering;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.discoverVertex = (void (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.discoverVertex;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.finishVertex = (void (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.finishVertex;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.getVerticesSeen = (struct ASE_Compiler_Vertex__array *(*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.getVerticesSeen;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.setVerticesSeen = (void (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*in*/ struct ASE_Compiler_Vertex__array *seen, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.setVerticesSeen;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.getVertexSeen = (int (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.getVertexSeen;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.setVertexSeen = (void (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*in*/ int state, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.setVertexSeen;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.getReferenceCount = (int32_t (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.getReferenceCount;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.addReference = (void (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.addReference;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.deleteReference = (void (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.deleteReference;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.isSame = (int (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.isSame;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.getClassName = (const char *(*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.getClassName;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.getName = (const char *(*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.getName;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.setName = (void (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.setName;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.isInstanceOf = (int (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.isInstanceOf;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.getSuper = (struct ASE_BaseInterface__object *(*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_Resolver_epv.getSuper;
    /* Override class ASE.Compiler.SIDL.DepthFirstVisitor methods with those of superclass ASE.BaseClass */
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.getReferenceCount = (int32_t (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_compiler_sidl_depthfirstvisitor.ase_baseclass.d_epv->getReferenceCount;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.addReference = (void (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_compiler_sidl_depthfirstvisitor.ase_baseclass.d_epv->addReference;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.deleteReference = (void (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_compiler_sidl_depthfirstvisitor.ase_baseclass.d_epv->deleteReference;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.isSame = (int (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_compiler_sidl_depthfirstvisitor.ase_baseclass.d_epv->isSame;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.getName = (const char *(*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_compiler_sidl_depthfirstvisitor.ase_baseclass.d_epv->getName;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.setName = (void (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_compiler_sidl_depthfirstvisitor.ase_baseclass.d_epv->setName;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.isInstanceOf = (int (*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_compiler_sidl_depthfirstvisitor.ase_baseclass.d_epv->isInstanceOf;
    ASE_Compiler_SIDL_DepthFirstVisitor_epv.getSuper = (struct ASE_BaseInterface__object *(*)(struct ASE_Compiler_SIDL_DepthFirstVisitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) self->ase_compiler_sidl_depthfirstvisitor.ase_baseclass.d_epv->getSuper;
    /* Virtualize superclass ASE.BaseClass methods with those of class ASE.Compiler.SIDL.DepthFirstVisitor */
    ASE_BaseClass_epv.castObject = (void *(*)(struct ASE_BaseClass__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.castObject;
    ASE_BaseClass_epv.iterNext = (struct ASE_Compiler_SIDL_DepthFirstVisitor__object *(*)(struct ASE_BaseClass__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.iterNext;
    ASE_BaseClass_epv.destroyObject = (void (*)(struct ASE_BaseClass__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.destroyObject;
    ASE_BaseClass_epv.strObject = (const char *(*)(struct ASE_BaseClass__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.strObject;
    ASE_BaseClass_epv.getReferenceCount = (int32_t (*)(struct ASE_BaseClass__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.getReferenceCount;
    ASE_BaseClass_epv.addReference = (void (*)(struct ASE_BaseClass__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.addReference;
    ASE_BaseClass_epv.deleteReference = (void (*)(struct ASE_BaseClass__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.deleteReference;
    ASE_BaseClass_epv.isSame = (int (*)(struct ASE_BaseClass__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.isSame;
    ASE_BaseClass_epv.getClassName = (const char *(*)(struct ASE_BaseClass__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.getClassName;
    ASE_BaseClass_epv.getName = (const char *(*)(struct ASE_BaseClass__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.getName;
    ASE_BaseClass_epv.setName = (void (*)(struct ASE_BaseClass__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.setName;
    ASE_BaseClass_epv.isInstanceOf = (int (*)(struct ASE_BaseClass__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.isInstanceOf;
    ASE_BaseClass_epv.getSuper = (struct ASE_BaseInterface__object *(*)(struct ASE_BaseClass__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.getSuper;
    /* Initialize interface ASE.Compiler.SIDL.Visitor methods with those of class ASE.Compiler.SIDL.DepthFirstVisitor */
    ASE_Compiler_SIDL_Visitor_epv.castObject = (void *(*)(struct ASE_Compiler_SIDL_Visitor__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.castObject;
    ASE_Compiler_SIDL_Visitor_epv.iterNext = (struct ASE_Compiler_SIDL_Visitor__object *(*)(struct ASE_Compiler_SIDL_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.iterNext;
    ASE_Compiler_SIDL_Visitor_epv.destroyObject = (void (*)(struct ASE_Compiler_SIDL_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.destroyObject;
    ASE_Compiler_SIDL_Visitor_epv.strObject = (const char *(*)(struct ASE_Compiler_SIDL_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.strObject;
    ASE_Compiler_SIDL_Visitor_epv.getReferenceCount = (int32_t (*)(struct ASE_Compiler_SIDL_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.getReferenceCount;
    ASE_Compiler_SIDL_Visitor_epv.addReference = (void (*)(struct ASE_Compiler_SIDL_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.addReference;
    ASE_Compiler_SIDL_Visitor_epv.deleteReference = (void (*)(struct ASE_Compiler_SIDL_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.deleteReference;
    ASE_Compiler_SIDL_Visitor_epv.isSame = (int (*)(struct ASE_Compiler_SIDL_Visitor__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.isSame;
    ASE_Compiler_SIDL_Visitor_epv.getClassName = (const char *(*)(struct ASE_Compiler_SIDL_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.getClassName;
    ASE_Compiler_SIDL_Visitor_epv.getName = (const char *(*)(struct ASE_Compiler_SIDL_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.getName;
    ASE_Compiler_SIDL_Visitor_epv.setName = (void (*)(struct ASE_Compiler_SIDL_Visitor__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.setName;
    ASE_Compiler_SIDL_Visitor_epv.isInstanceOf = (int (*)(struct ASE_Compiler_SIDL_Visitor__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.isInstanceOf;
    ASE_Compiler_SIDL_Visitor_epv.getSuper = (struct ASE_BaseInterface__object *(*)(struct ASE_Compiler_SIDL_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.getSuper;
    ASE_Compiler_SIDL_Visitor_epv.getRepository = (struct ASE_Compiler_Vertex__array *(*)(struct ASE_Compiler_SIDL_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.getRepository;
    ASE_Compiler_SIDL_Visitor_epv.setRepository = (void (*)(struct ASE_Compiler_SIDL_Visitor__object *self, /*in*/ struct ASE_Compiler_Vertex__array *repository, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.setRepository;
    ASE_Compiler_SIDL_Visitor_epv.visitVertex = (void (*)(struct ASE_Compiler_SIDL_Visitor__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.visitVertex;
    ASE_Compiler_SIDL_Visitor_epv.visitSpecification = (void (*)(struct ASE_Compiler_SIDL_Visitor__object *self, /*in*/ struct ASE_Compiler_SIDL_Specification__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.visitSpecification;
    ASE_Compiler_SIDL_Visitor_epv.visitPackage = (void (*)(struct ASE_Compiler_SIDL_Visitor__object *self, /*in*/ struct ASE_Compiler_SIDL_Package__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.visitPackage;
    ASE_Compiler_SIDL_Visitor_epv.visitType = (void (*)(struct ASE_Compiler_SIDL_Visitor__object *self, /*in*/ struct ASE_Compiler_SIDL_Type__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.visitType;
    ASE_Compiler_SIDL_Visitor_epv.visitTypeUniverse = (void (*)(struct ASE_Compiler_SIDL_Visitor__object *self, /*in*/ struct ASE_Compiler_SIDL_TypeUniverse__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.visitTypeUniverse;
    ASE_Compiler_SIDL_Visitor_epv.visitEnumeration = (void (*)(struct ASE_Compiler_SIDL_Visitor__object *self, /*in*/ struct ASE_Compiler_SIDL_Enumeration__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.visitEnumeration;
    ASE_Compiler_SIDL_Visitor_epv.visitEnumerator = (void (*)(struct ASE_Compiler_SIDL_Visitor__object *self, /*in*/ struct ASE_Compiler_SIDL_Enumerator__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.visitEnumerator;
    ASE_Compiler_SIDL_Visitor_epv.visitArray = (void (*)(struct ASE_Compiler_SIDL_Visitor__object *self, /*in*/ struct ASE_Compiler_SIDL_Array__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.visitArray;
    ASE_Compiler_SIDL_Visitor_epv.visitIterator = (void (*)(struct ASE_Compiler_SIDL_Visitor__object *self, /*in*/ struct ASE_Compiler_SIDL_Iterator__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.visitIterator;
    ASE_Compiler_SIDL_Visitor_epv.visitInterface = (void (*)(struct ASE_Compiler_SIDL_Visitor__object *self, /*in*/ struct ASE_Compiler_SIDL_Interface__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.visitInterface;
    ASE_Compiler_SIDL_Visitor_epv.visitClass = (void (*)(struct ASE_Compiler_SIDL_Visitor__object *self, /*in*/ struct ASE_Compiler_SIDL_Class__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.visitClass;
    ASE_Compiler_SIDL_Visitor_epv.visitParameter = (void (*)(struct ASE_Compiler_SIDL_Visitor__object *self, /*in*/ struct ASE_Compiler_SIDL_Parameter__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.visitParameter;
    ASE_Compiler_SIDL_Visitor_epv.visitMethod = (void (*)(struct ASE_Compiler_SIDL_Visitor__object *self, /*in*/ struct ASE_Compiler_SIDL_Method__object *node, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.visitMethod;
    /* Initialize interface ASE.Compiler.Visitor methods with those of class ASE.Compiler.SIDL.DepthFirstVisitor */
    ASE_Compiler_Visitor_epv.castObject = (void *(*)(struct ASE_Compiler_Visitor__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.castObject;
    ASE_Compiler_Visitor_epv.iterNext = (struct ASE_Compiler_Visitor__object *(*)(struct ASE_Compiler_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.iterNext;
    ASE_Compiler_Visitor_epv.destroyObject = (void (*)(struct ASE_Compiler_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.destroyObject;
    ASE_Compiler_Visitor_epv.strObject = (const char *(*)(struct ASE_Compiler_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.strObject;
    ASE_Compiler_Visitor_epv.getReferenceCount = (int32_t (*)(struct ASE_Compiler_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.getReferenceCount;
    ASE_Compiler_Visitor_epv.addReference = (void (*)(struct ASE_Compiler_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.addReference;
    ASE_Compiler_Visitor_epv.deleteReference = (void (*)(struct ASE_Compiler_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.deleteReference;
    ASE_Compiler_Visitor_epv.isSame = (int (*)(struct ASE_Compiler_Visitor__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.isSame;
    ASE_Compiler_Visitor_epv.getClassName = (const char *(*)(struct ASE_Compiler_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.getClassName;
    ASE_Compiler_Visitor_epv.getName = (const char *(*)(struct ASE_Compiler_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.getName;
    ASE_Compiler_Visitor_epv.setName = (void (*)(struct ASE_Compiler_Visitor__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.setName;
    ASE_Compiler_Visitor_epv.isInstanceOf = (int (*)(struct ASE_Compiler_Visitor__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.isInstanceOf;
    ASE_Compiler_Visitor_epv.getSuper = (struct ASE_BaseInterface__object *(*)(struct ASE_Compiler_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.getSuper;
    ASE_Compiler_Visitor_epv.getRepository = (struct ASE_Compiler_Vertex__array *(*)(struct ASE_Compiler_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.getRepository;
    ASE_Compiler_Visitor_epv.setRepository = (void (*)(struct ASE_Compiler_Visitor__object *self, /*in*/ struct ASE_Compiler_Vertex__array *repository, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.setRepository;
    ASE_Compiler_Visitor_epv.visitVertex = (void (*)(struct ASE_Compiler_Visitor__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.visitVertex;
    /* Initialize interface ASE.BaseInterface methods with those of class ASE.Compiler.SIDL.DepthFirstVisitor */
    ASE_BaseInterface_epv.castObject = (void *(*)(struct ASE_BaseInterface__object *self, /*in*/ const char *name, /*out*/ void **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.castObject;
    ASE_BaseInterface_epv.iterNext = (struct ASE_BaseInterface__object *(*)(struct ASE_BaseInterface__object *self, /*out*/ void **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.iterNext;
    ASE_BaseInterface_epv.destroyObject = (void (*)(struct ASE_BaseInterface__object *self, /*out*/ void **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.destroyObject;
    ASE_BaseInterface_epv.strObject = (const char *(*)(struct ASE_BaseInterface__object *self, /*out*/ void **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.strObject;
    ASE_BaseInterface_epv.getReferenceCount = (int32_t (*)(struct ASE_BaseInterface__object *self, /*out*/ void **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.getReferenceCount;
    ASE_BaseInterface_epv.addReference = (void (*)(struct ASE_BaseInterface__object *self, /*out*/ void **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.addReference;
    ASE_BaseInterface_epv.deleteReference = (void (*)(struct ASE_BaseInterface__object *self, /*out*/ void **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.deleteReference;
    ASE_BaseInterface_epv.isSame = (int (*)(struct ASE_BaseInterface__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ void **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.isSame;
    ASE_BaseInterface_epv.getClassName = (const char *(*)(struct ASE_BaseInterface__object *self, /*out*/ void **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.getClassName;
    ASE_BaseInterface_epv.getName = (const char *(*)(struct ASE_BaseInterface__object *self, /*out*/ void **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.getName;
    ASE_BaseInterface_epv.setName = (void (*)(struct ASE_BaseInterface__object *self, /*in*/ const char *name, /*out*/ void **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.setName;
    ASE_BaseInterface_epv.isInstanceOf = (int (*)(struct ASE_BaseInterface__object *self, /*in*/ const char *typeName, /*out*/ void **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.isInstanceOf;
    ASE_BaseInterface_epv.getSuper = (struct ASE_BaseInterface__object *(*)(struct ASE_BaseInterface__object *self, /*out*/ void **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.getSuper;
    /* Initialize interface ASE.Compiler.Search methods with those of class ASE.Compiler.SIDL.DepthFirstVisitor */
    ASE_Compiler_Search_epv.castObject = (void *(*)(struct ASE_Compiler_Search__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.castObject;
    ASE_Compiler_Search_epv.iterNext = (struct ASE_Compiler_Search__object *(*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.iterNext;
    ASE_Compiler_Search_epv.destroyObject = (void (*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.destroyObject;
    ASE_Compiler_Search_epv.strObject = (const char *(*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.strObject;
    ASE_Compiler_Search_epv.getReferenceCount = (int32_t (*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.getReferenceCount;
    ASE_Compiler_Search_epv.addReference = (void (*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.addReference;
    ASE_Compiler_Search_epv.deleteReference = (void (*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.deleteReference;
    ASE_Compiler_Search_epv.isSame = (int (*)(struct ASE_Compiler_Search__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.isSame;
    ASE_Compiler_Search_epv.getClassName = (const char *(*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.getClassName;
    ASE_Compiler_Search_epv.getName = (const char *(*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.getName;
    ASE_Compiler_Search_epv.setName = (void (*)(struct ASE_Compiler_Search__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.setName;
    ASE_Compiler_Search_epv.isInstanceOf = (int (*)(struct ASE_Compiler_Search__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.isInstanceOf;
    ASE_Compiler_Search_epv.getSuper = (struct ASE_BaseInterface__object *(*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.getSuper;
    ASE_Compiler_Search_epv.getReverseEdges = (int (*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.getReverseEdges;
    ASE_Compiler_Search_epv.setReverseEdges = (void (*)(struct ASE_Compiler_Search__object *self, /*in*/ int reverseEdges, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.setReverseEdges;
    ASE_Compiler_Search_epv.traverseVertex = (void (*)(struct ASE_Compiler_Search__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.traverseVertex;
    ASE_Compiler_Search_epv.resetVertexNumbering = (void (*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.resetVertexNumbering;
    ASE_Compiler_Search_epv.discoverVertex = (void (*)(struct ASE_Compiler_Search__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.discoverVertex;
    ASE_Compiler_Search_epv.finishVertex = (void (*)(struct ASE_Compiler_Search__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.finishVertex;
    ASE_Compiler_Search_epv.getVerticesSeen = (struct ASE_Compiler_Vertex__array *(*)(struct ASE_Compiler_Search__object *self, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.getVerticesSeen;
    ASE_Compiler_Search_epv.setVerticesSeen = (void (*)(struct ASE_Compiler_Search__object *self, /*in*/ struct ASE_Compiler_Vertex__array *seen, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.setVerticesSeen;
    ASE_Compiler_Search_epv.getVertexSeen = (int (*)(struct ASE_Compiler_Search__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.getVertexSeen;
    ASE_Compiler_Search_epv.setVertexSeen = (void (*)(struct ASE_Compiler_Search__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*in*/ int state, /*out*/ struct ASE_BaseException__object **_exception)) ASE_Compiler_SIDL_DepthFirstVisitor_epv.setVertexSeen;
    epvInitialized = 1;
  }
  self->ase_compiler_sidl_depthfirstvisitor.ase_baseclass.ase_baseinterface.d_epv = &ASE_BaseInterface_epv;
  self->ase_compiler_sidl_depthfirstvisitor.ase_baseclass.d_epv = &ASE_BaseClass_epv;
  self->ase_compiler_sidl_depthfirstvisitor.ase_compiler_sidl_visitor.ase_compiler_visitor.ase_baseinterface.d_epv = &ASE_BaseInterface_epv;
  self->ase_compiler_sidl_depthfirstvisitor.ase_compiler_sidl_visitor.ase_compiler_visitor.d_epv = &ASE_Compiler_Visitor_epv;
  self->ase_compiler_sidl_depthfirstvisitor.ase_compiler_sidl_visitor.d_epv = &ASE_Compiler_SIDL_Visitor_epv;
  self->ase_compiler_sidl_depthfirstvisitor.ase_compiler_search.ase_baseinterface.d_epv = &ASE_BaseInterface_epv;
  self->ase_compiler_sidl_depthfirstvisitor.ase_compiler_search.d_epv = &ASE_Compiler_Search_epv;
  self->ase_compiler_sidl_depthfirstvisitor.d_epv = &ASE_Compiler_SIDL_DepthFirstVisitor_epv;
  self->d_epv = &ASE_Compiler_SIDL_Resolver_epv;
  /* Save old EPV for getSuper() */
  self->d_oldEpv = self->d_epv;
  /* Initialize pointers to the original object */
  self->d_object = obj;
  /* Setup implementation data */
  self->d_data = NULL;
  /* Call the Skeleton constructor */
  (*(self->d_epv->Resolver))(self, _exception);
}

static struct ASE_Compiler_SIDL_Resolver__object *createObject(/*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_SIDL_Resolver__object *self = (struct ASE_Compiler_SIDL_Resolver__object *) malloc(sizeof(struct ASE_Compiler_SIDL_Resolver__object));
  
  initObject(self, self, _exception);
  return self;
}

#ifndef included_ASE_ASEException
#include <ASE/ASEException_IOR.h>
#endif

static struct ASE_Compiler_SIDL_Resolver__array *createArray(/*in*/ int32_t dimen, /*in*/ struct int__array *lower, /*in*/ struct int__array *upper, /*out*/ struct ASE_BaseException__object **_exception)
{
  static int32_t arraySize = sizeof(struct ASE_Compiler_SIDL_Resolver__array) + (sizeof(int32_t) - (sizeof(struct ASE_Compiler_SIDL_Resolver__array)) % sizeof(int32_t)) % sizeof(int32_t);
  struct ASE_Compiler_SIDL_Resolver__array *_return_value = (struct ASE_Compiler_SIDL_Resolver__array *) malloc(arraySize + 3 * sizeof(int32_t) * (dimen ? dimen : 1));
  int32_t size = 1;
  int32_t d = 0;
  
  /* Initialize array structure */
  _return_value->d_dimen = dimen;
  _return_value->d_borrowed = 0;
  _return_value->d_lower = (int32_t *) ((char *) _return_value + arraySize);
  _return_value->d_upper = _return_value->d_lower + (dimen ? dimen : 1);
  _return_value->d_stride = _return_value->d_upper + (dimen ? dimen : 1);
  _return_value->d_lower[0] = 0;
  _return_value->d_upper[0] = 0;
  _return_value->d_stride[0] = 1;
  /* Determine array size and set bounds */
  for(d = 0; d < dimen; d++)
  {
    _return_value->d_lower[d] = lower->d_firstElement[d];
    _return_value->d_upper[d] = upper->d_firstElement[d];
    _return_value->d_stride[d] = size;
    size *= upper->d_firstElement[d] - lower->d_firstElement[d] + 1;
  }
  size *= sizeof(struct ASE_Compiler_SIDL_Resolver__object *);
  /* Allocate and initialize data */
  _return_value->d_firstElement = (struct ASE_Compiler_SIDL_Resolver__object **) malloc(size);
  memset(_return_value->d_firstElement, 0, size);
  return _return_value;
}

static struct ASE_Compiler_SIDL_Resolver__array *borrowArray(/*in*/ int32_t dimen, /*in*/ struct int__array *lower, /*in*/ struct int__array *upper, /*in*/ struct int__array *stride, /*in*/ void *first, /*out*/ struct ASE_BaseException__object **_exception)
{
  static int32_t arraySize = sizeof(struct ASE_Compiler_SIDL_Resolver__array) + (sizeof(int32_t) - (sizeof(struct ASE_Compiler_SIDL_Resolver__array)) % sizeof(int32_t)) % sizeof(int32_t);
  struct ASE_Compiler_SIDL_Resolver__array *_return_value = (struct ASE_Compiler_SIDL_Resolver__array *) malloc(arraySize + 3 * sizeof(int32_t) * (dimen ? dimen : 1));
  int32_t size = 1;
  int32_t d = 0;
  
  /* Initialize array structure */
  _return_value->d_dimen = dimen;
  _return_value->d_borrowed = 1;
  _return_value->d_lower = (int32_t *) ((char *) _return_value + arraySize);
  _return_value->d_upper = _return_value->d_lower + (dimen ? dimen : 1);
  _return_value->d_stride = _return_value->d_upper + (dimen ? dimen : 1);
  _return_value->d_lower[0] = 0;
  _return_value->d_upper[0] = 0;
  _return_value->d_stride[0] = 1;
  /* Determine array size and set bounds */
  for(d = 0; d < dimen; d++)
  {
    _return_value->d_lower[d] = lower->d_firstElement[d];
    _return_value->d_upper[d] = upper->d_firstElement[d];
    _return_value->d_stride[d] = stride->d_firstElement[d];
    size *= upper->d_firstElement[d] - lower->d_firstElement[d] + 1;
  }
  size *= sizeof(struct ASE_Compiler_SIDL_Resolver__object *);
  _return_value->d_firstElement = (struct ASE_Compiler_SIDL_Resolver__object **) first;
  return _return_value;
}

static void destroyArray(/*in*/ struct ASE_Compiler_SIDL_Resolver__array *array, /*out*/ struct ASE_BaseException__object **_exception)
{
  if (!array->d_borrowed)
  {
    free(array->d_firstElement);
  }
  free(array);
}

static int32_t getDimen(/*in*/ struct ASE_Compiler_SIDL_Resolver__array *array, /*out*/ struct ASE_BaseException__object **_exception)
{
  return array->d_dimen;
}

static int32_t getLower(/*in*/ struct ASE_Compiler_SIDL_Resolver__array *array, /*in*/ int32_t dimen, /*out*/ struct ASE_BaseException__object **_exception)
{
  return array->d_lower[dimen];
}

static int32_t getUpper(/*in*/ struct ASE_Compiler_SIDL_Resolver__array *array, /*in*/ int32_t dimen, /*out*/ struct ASE_BaseException__object **_exception)
{
  return array->d_upper[dimen];
}

static struct ASE_Compiler_SIDL_Resolver__object *getElement(/*in*/ struct ASE_Compiler_SIDL_Resolver__array *array, /*in*/ struct int__array *indices, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_SIDL_Resolver__object *_result = NULL;
  struct ASE_Compiler_SIDL_Resolver__object **_element = NULL;
  int32_t d = 0;
  
  _element = array->d_firstElement;
  for(d = 0; d < array->d_dimen; d++)
  {
    if (indices->d_firstElement[d] < array->d_lower[d] || indices->d_firstElement[d] > array->d_upper[d])
    {
      struct ASE_ASEException__object *_local_exception = ASE_ASEException__externals()->createObject(NULL);
      
      _local_exception->d_epv->setMessage(_local_exception, "Invalid indices", _exception);
      if (_exception)
      {
        *_exception = (struct ASE_BaseException__object *) _local_exception;
      }
      return _result;
    }
    _element += array->d_stride[d] * (indices->d_firstElement[d] - array->d_lower[d]);
  }
  if (*_element)
  {
    (*(((struct ASE_BaseInterface__object *) (*_element)->d_object)->d_epv->deleteReference))((*_element)->d_object, (void **) _exception);
  }
  return *_element;
}

static struct ASE_Compiler_SIDL_Resolver__object *getElement4(/*in*/ struct ASE_Compiler_SIDL_Resolver__array *array, /*in*/ int32_t i1, /*in*/ int32_t i2, /*in*/ int32_t i3, /*in*/ int32_t i4, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_SIDL_Resolver__object *_result = NULL;
  
  return _result;
}

static void setElement(/*in*/ struct ASE_Compiler_SIDL_Resolver__array *array, /*in*/ struct int__array *indices, /*in*/ struct ASE_Compiler_SIDL_Resolver__object *value, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_SIDL_Resolver__object **_element = NULL;
  int32_t d = 0;
  
  _element = array->d_firstElement;
  for(d = 0; d < array->d_dimen; d++)
  {
    if (indices->d_firstElement[d] < array->d_lower[d] || indices->d_firstElement[d] > array->d_upper[d])
    {
      struct ASE_ASEException__object *_local_exception = ASE_ASEException__externals()->createObject(NULL);
      
      _local_exception->d_epv->setMessage(_local_exception, "Invalid indices", _exception);
      if (_exception)
      {
        *_exception = (struct ASE_BaseException__object *) _local_exception;
      }
      return;
    }
    _element += array->d_stride[d] * (indices->d_firstElement[d] - array->d_lower[d]);
  }
  if (value)
  {
    (*(((struct ASE_BaseInterface__object *) (value)->d_object)->d_epv->addReference))((value)->d_object, (void **) _exception);
  }
  if (*_element)
  {
    (*(((struct ASE_BaseInterface__object *) (*_element)->d_object)->d_epv->deleteReference))((*_element)->d_object, (void **) _exception);
  }
  *_element = value;
}

static void setElement4(/*in*/ struct ASE_Compiler_SIDL_Resolver__array *array, /*in*/ int32_t i1, /*in*/ int32_t i2, /*in*/ int32_t i3, /*in*/ int32_t i4, /*in*/ struct ASE_Compiler_SIDL_Resolver__object *value, /*out*/ struct ASE_BaseException__object **_exception)
{
}

static void *castIterator(struct ASE_Compiler_SIDL_Resolver__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  /* We are guaranteed here that the first member in any IOR is a ASE.BaseInterface object */
  struct ASE_BaseClass__object *obj = ((struct ASE_BaseInterface__object *) self)->d_object;
  void *cast = NULL;
  
  if (!strcmp(name, "ASE.Compiler.SIDL.Resolver"))
  {
    cast = self;
  }
  else
  if (!strcmp(name, "ASE.BaseClass"))
  {
    cast = obj;
  }
  else
  if (!strcmp(name, "ASE.BaseInterface"))
  {
    cast = (&obj->ase_baseinterface);
  }
  return cast;
}

static struct ASE_Compiler_SIDL_Resolver__iterator *createIterator(/*in*/ void *iterator, /*in*/ void *iterNext, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_SIDL_Resolver__iterator *self = (struct ASE_Compiler_SIDL_Resolver__iterator *) malloc(sizeof(struct ASE_Compiler_SIDL_Resolver__iterator));
  struct ASE_BaseClass__object *parent = &self->ase_baseclass;
  struct ASE_BaseClass__epv *ASE_BaseClass_epv = (struct ASE_BaseClass__epv *) malloc(sizeof(struct ASE_BaseClass__epv));
  struct ASE_BaseInterface__epv *ASE_BaseInterface_epv = (struct ASE_BaseInterface__epv *) malloc(sizeof(struct ASE_BaseInterface__epv));
  
  (*(ASE_BaseClass__externals()->initObject))(parent, self, _exception);
  ASE_BaseClass_epv->getReferenceCount = self->ase_baseclass.d_epv->getReferenceCount;
  ASE_BaseClass_epv->addReference = self->ase_baseclass.d_epv->addReference;
  ASE_BaseClass_epv->deleteReference = self->ase_baseclass.d_epv->deleteReference;
  ASE_BaseClass_epv->isSame = self->ase_baseclass.d_epv->isSame;
  ASE_BaseClass_epv->getClassName = self->ase_baseclass.d_epv->getClassName;
  ASE_BaseClass_epv->getName = self->ase_baseclass.d_epv->getName;
  ASE_BaseClass_epv->setName = self->ase_baseclass.d_epv->setName;
  ASE_BaseClass_epv->isInstanceOf = self->ase_baseclass.d_epv->isInstanceOf;
  ASE_BaseClass_epv->getSuper = self->ase_baseclass.d_epv->getSuper;
  ASE_BaseInterface_epv->getReferenceCount = self->ase_baseclass.ase_baseinterface.d_epv->getReferenceCount;
  ASE_BaseInterface_epv->addReference = self->ase_baseclass.ase_baseinterface.d_epv->addReference;
  ASE_BaseInterface_epv->deleteReference = self->ase_baseclass.ase_baseinterface.d_epv->deleteReference;
  ASE_BaseInterface_epv->isSame = self->ase_baseclass.ase_baseinterface.d_epv->isSame;
  ASE_BaseInterface_epv->getClassName = self->ase_baseclass.ase_baseinterface.d_epv->getClassName;
  ASE_BaseInterface_epv->getName = self->ase_baseclass.ase_baseinterface.d_epv->getName;
  ASE_BaseInterface_epv->setName = self->ase_baseclass.ase_baseinterface.d_epv->setName;
  ASE_BaseInterface_epv->isInstanceOf = self->ase_baseclass.ase_baseinterface.d_epv->isInstanceOf;
  ASE_BaseInterface_epv->getSuper = self->ase_baseclass.ase_baseinterface.d_epv->getSuper;
  ASE_BaseClass_epv->castObject = castIterator;
  ASE_BaseClass_epv->iterNext = iterNext;
  ASE_BaseInterface_epv->castObject = castIterator;
  ASE_BaseInterface_epv->iterNext = iterNext;
  self->ase_baseclass.ase_baseinterface.d_epv = ASE_BaseInterface_epv;
  self->ase_baseclass.d_epv = ASE_BaseClass_epv;
  self->iterator = iterator;
  self->objWrapper = NULL;
  return self;
}

static void destroyIterator(/*in*/ struct ASE_Compiler_SIDL_Resolver__iterator *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_BaseClass__object *parent = &self->ase_baseclass;
  
  self->iterator = NULL;
  self->objWrapper = NULL;
  free(self->ase_baseclass.ase_baseinterface.d_epv);
  free(self->ase_baseclass.d_epv);
  self->ase_baseclass.d_epv = self->ase_baseclass.d_oldEpv;
  (*(ASE_BaseClass__externals()->finiObject))(parent, _exception);
  memset(self, 0, sizeof(struct ASE_Compiler_SIDL_Resolver__iterator));
  free(self);
}

/* The entry points into the DLL containing this type */
static struct ASE_Compiler_SIDL_Resolver__external externalEntryPoints = {
  createObject,
  initObject,
  finiObject,
  createArray,
  borrowArray,
  destroyArray,
  getDimen,
  getLower,
  getUpper,
  getElement,
  getElement4,
  setElement,
  setElement4,
  createIterator,
  destroyIterator};

const struct ASE_Compiler_SIDL_Resolver__external *ASE_Compiler_SIDL_Resolver__externals(void)
{
  return &externalEntryPoints;
}
