#include <Python.h>

#include <Numeric/arrayobject.h>

#ifndef included_ASE_Compiler_Cxx_Printer
#include <ASE/Compiler/Cxx/Printer_IOR.h>
#endif

#ifndef included_ASE_Loader
#include <ASE/Loader_IOR.h>
#endif

#ifndef included_ASE_BaseException
#include <ASE/BaseException_IOR.h>
#endif

static const struct ASE_Compiler_Cxx_Printer__external *_epv = NULL;

enum ReferenceType {STOLEN_REF, WEAK_REF, NEW_REF};

struct ASE_Compiler_Cxx_Printer_PythonObject {
  PyObject_HEAD;
  struct ASE_Compiler_Cxx_Printer__object *ior;
  enum ReferenceType refType;
  PyObject *weakRefList;
};

/* Need to forward declare the type structure */
static PyTypeObject SIDLPythonObjectType;

static PyObject *sidl_new(PyTypeObject *type, struct ASE_BaseInterface__object *ior, enum ReferenceType refType)
{
  PyObject *return_value = NULL;
  
  if (ior)
  {
    struct ASE_Compiler_Cxx_Printer_PythonObject *self = (struct ASE_Compiler_Cxx_Printer_PythonObject *) type->tp_alloc(type, 0);
    
    self->weakRefList = NULL;
    if (self)
    {
      struct ASE_BaseClass__object *baseIor = (*(ior->d_epv->castObject))(ior->d_object, "ASE.BaseClass", NULL);
      
      self->ior = ((*(ior->d_epv->castObject)))(ior->d_object, type->tp_name, NULL);
      self->refType = refType;
      /* Allow objects without an attached implementation (used in the skeleton constructor) */
      if (baseIor->d_data)
      {
        if (refType == NEW_REF)
        {
          (*(baseIor->d_epv->addReference))(baseIor->d_object, NULL);
        }
      }
      return_value = (PyObject *) self;
    }
    else
    {
      PyErr_SetString(PyExc_MemoryError, (char *) "Unable to allocate interface object");
    }
  }
  else
  {
    return_value = Py_None;
    Py_INCREF(return_value);
  }
  return return_value;
}

static PyObject *ASE_Compiler_Cxx_Printer__wrap_ior_weak(struct ASE_Compiler_Cxx_Printer__object *ior)
{
  PyObject *module = PyImport_ImportModule((char *) "ASE.Compiler.Cxx.Printer");
  PyTypeObject *type = (PyTypeObject *) PyObject_GetAttrString(module, (char *) "Printer");
  
  if (!module)
  {
    PyErr_SetString(PyExc_ImportError, "Could not import module ASE.Compiler.Cxx.Printer");
    return 0;
  }
  if (!type)
  {
    PyErr_SetString(PyExc_TypeError, "Could not find type ASE.Compiler.Cxx.Printer");
    return 0;
  }
  return sidl_new(type, (struct ASE_BaseInterface__object *) ior, WEAK_REF);
}

static PyObject *ASE_BaseInterface__wrap_ior(struct ASE_BaseInterface__object *ior)
{
  PyObject *module = PyImport_ImportModule((char *) "ASE.BaseInterface");
  PyTypeObject *type = (PyTypeObject *) PyObject_GetAttrString(module, (char *) "BaseInterface");
  
  if (!module)
  {
    PyErr_SetString(PyExc_ImportError, "Could not import module ASE.BaseInterface");
    return 0;
  }
  if (!type)
  {
    PyErr_SetString(PyExc_TypeError, "Could not find type ASE.BaseInterface");
    return 0;
  }
  return sidl_new(type, (struct ASE_BaseInterface__object *) ior, STOLEN_REF);
}

static PyObject *ASE_Compiler_Vertex__wrap_ior(struct ASE_Compiler_Vertex__object *ior)
{
  PyObject *module = PyImport_ImportModule((char *) "ASE.Compiler.Vertex");
  PyTypeObject *type = (PyTypeObject *) PyObject_GetAttrString(module, (char *) "Vertex");
  
  if (!module)
  {
    PyErr_SetString(PyExc_ImportError, "Could not import module ASE.Compiler.Vertex");
    return 0;
  }
  if (!type)
  {
    PyErr_SetString(PyExc_TypeError, "Could not find type ASE.Compiler.Vertex");
    return 0;
  }
  return sidl_new(type, (struct ASE_BaseInterface__object *) ior, STOLEN_REF);
}

static PyObject *ASE_BaseException__wrap_ior(struct ASE_BaseException__object *ior)
{
  PyObject *module = PyImport_ImportModule((char *) "ASE.BaseException");
  PyTypeObject *type = (PyTypeObject *) PyObject_GetAttrString(module, (char *) "BaseException");
  
  if (!module)
  {
    PyErr_SetString(PyExc_ImportError, "Could not import module ASE.BaseException");
    return 0;
  }
  if (!type)
  {
    PyErr_SetString(PyExc_TypeError, "Could not find type ASE.BaseException");
    return 0;
  }
  return sidl_new(type, (struct ASE_BaseInterface__object *) ior, STOLEN_REF);
}

static PyObject *ASE_Compiler_Cxx_Printer__wrap_ior(struct ASE_Compiler_Cxx_Printer__object *ior)
{
  PyObject *module = PyImport_ImportModule((char *) "ASE.Compiler.Cxx.Printer");
  PyTypeObject *type = (PyTypeObject *) PyObject_GetAttrString(module, (char *) "Printer");
  
  if (!module)
  {
    PyErr_SetString(PyExc_ImportError, "Could not import module ASE.Compiler.Cxx.Printer");
    return 0;
  }
  if (!type)
  {
    PyErr_SetString(PyExc_TypeError, "Could not find type ASE.Compiler.Cxx.Printer");
    return 0;
  }
  return sidl_new(type, (struct ASE_BaseInterface__object *) ior, STOLEN_REF);
}

static PyObject *ASE_Compiler_CompilerException__wrap_ior(struct ASE_Compiler_CompilerException__object *ior)
{
  PyObject *module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
  PyTypeObject *type = (PyTypeObject *) PyObject_GetAttrString(module, (char *) "CompilerException");
  
  if (!module)
  {
    PyErr_SetString(PyExc_ImportError, "Could not import module ASE.Compiler.CompilerException");
    return 0;
  }
  if (!type)
  {
    PyErr_SetString(PyExc_TypeError, "Could not find type ASE.Compiler.CompilerException");
    return 0;
  }
  return sidl_new(type, (struct ASE_BaseInterface__object *) ior, STOLEN_REF);
}

static long ASE_Compiler_Cxx_Source__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Source__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Source", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Source");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Struct__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Struct__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Struct", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Struct");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Return__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Return__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Return", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Return");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Subtraction__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Subtraction__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Subtraction", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Subtraction");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Group__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Group__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Group", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Group");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_DeclaratorGroup__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_DeclaratorGroup__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.DeclaratorGroup", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.DeclaratorGroup");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Modulo__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Modulo__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Modulo", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Modulo");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_ModuloAssignment__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_ModuloAssignment__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.ModuloAssignment", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.ModuloAssignment");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_SubtractionAssignment__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_SubtractionAssignment__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.SubtractionAssignment", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.SubtractionAssignment");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_PreprocessorConditional__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_PreprocessorConditional__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.PreprocessorConditional", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.PreprocessorConditional");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_While__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_While__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.While", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.While");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Division__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Division__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Division", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Division");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_ExclusiveOr__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_ExclusiveOr__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.ExclusiveOr", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.ExclusiveOr");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_LessThan__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_LessThan__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.LessThan", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.LessThan");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Parameter__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Parameter__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Parameter", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Parameter");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Enumeration__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Enumeration__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Enumeration", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Enumeration");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Break__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Break__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Break", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Break");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_AndAssignment__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_AndAssignment__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.AndAssignment", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.AndAssignment");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_DivisionAssignment__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_DivisionAssignment__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.DivisionAssignment", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.DivisionAssignment");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Inequality__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Inequality__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Inequality", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Inequality");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Header__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Header__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Header", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Header");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Typedef__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Typedef__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Typedef", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Typedef");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Goto__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Goto__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Goto", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Goto");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Addition__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Addition__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Addition", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Addition");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_LogicalOr__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_LogicalOr__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.LogicalOr", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.LogicalOr");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Initializer__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Initializer__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Initializer", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Initializer");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_RightShift__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_RightShift__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.RightShift", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.RightShift");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Negation__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Negation__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Negation", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Negation");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Continue__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Continue__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Continue", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Continue");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_And__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_And__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.And", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.And");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_LogicalAnd__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_LogicalAnd__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.LogicalAnd", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.LogicalAnd");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_CompoundStatement__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_CompoundStatement__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.CompoundStatement", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.CompoundStatement");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_InclusiveOr__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_InclusiveOr__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.InclusiveOr", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.InclusiveOr");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Function__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Function__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Function", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Function");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Define__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Define__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Define", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Define");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_AdditionAssignment__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_AdditionAssignment__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.AdditionAssignment", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.AdditionAssignment");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_LessThanOrEqual__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_LessThanOrEqual__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.LessThanOrEqual", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.LessThanOrEqual");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Switch__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Switch__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Switch", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Switch");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Macro__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Macro__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Macro", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Macro");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_StructReference__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_StructReference__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.StructReference", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.StructReference");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_LeftShiftAssignment__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_LeftShiftAssignment__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.LeftShiftAssignment", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.LeftShiftAssignment");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Increment__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Increment__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Increment", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Increment");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Type__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Type__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Type", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Type");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Array__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Array__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Array", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Array");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_ArrayReference__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_ArrayReference__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.ArrayReference", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.ArrayReference");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Expression__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Expression__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Expression", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Expression");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Indirection__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Indirection__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Indirection", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Indirection");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_RightShiftAssignment__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_RightShiftAssignment__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.RightShiftAssignment", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.RightShiftAssignment");
    return 0;
  }
  return 1;
}

static long ASE_BaseInterface__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_BaseInterface__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.BaseInterface", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.BaseInterface");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_BitField__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_BitField__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.BitField", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.BitField");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_UnaryPlus__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_UnaryPlus__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.UnaryPlus", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.UnaryPlus");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Constant__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Constant__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Constant", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Constant");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_FunctionCall__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_FunctionCall__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.FunctionCall", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.FunctionCall");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Vertex__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Vertex__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Vertex", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Vertex");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Cast__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Cast__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Cast", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Cast");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Address__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Address__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Address", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Address");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Multiplication__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Multiplication__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Multiplication", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Multiplication");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Equality__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Equality__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Equality", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Equality");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Declaration__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Declaration__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Declaration", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Declaration");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Enumerator__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Enumerator__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Enumerator", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Enumerator");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Pointer__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Pointer__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Pointer", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Pointer");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Variable__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Variable__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Variable", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Variable");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Complement__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Complement__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Complement", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Complement");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_ExclusiveOrAssignment__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_ExclusiveOrAssignment__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.ExclusiveOrAssignment", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.ExclusiveOrAssignment");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Statement__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Statement__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Statement", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Statement");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_If__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_If__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.If", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.If");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_GreaterThanOrEqual__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_GreaterThanOrEqual__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.GreaterThanOrEqual", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.GreaterThanOrEqual");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_UnaryMinus__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_UnaryMinus__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.UnaryMinus", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.UnaryMinus");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_LeftShift__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_LeftShift__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.LeftShift", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.LeftShift");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Include__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Include__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Include", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Include");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_ExpressionStatement__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_ExpressionStatement__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.ExpressionStatement", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.ExpressionStatement");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Declarator__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Declarator__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Declarator", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Declarator");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_InclusiveOrAssignment__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_InclusiveOrAssignment__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.InclusiveOrAssignment", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.InclusiveOrAssignment");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_For__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_For__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.For", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.For");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_PythonModule__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_PythonModule__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.PythonModule", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.PythonModule");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_GreaterThan__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_GreaterThan__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.GreaterThan", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.GreaterThan");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Sizeof__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Sizeof__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Sizeof", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Sizeof");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_MultiplicationAssignment__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_MultiplicationAssignment__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.MultiplicationAssignment", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.MultiplicationAssignment");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Printer__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Printer__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Printer", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Printer");
    return 0;
  }
  return 1;
}

static long ASE_Compiler_Cxx_Assignment__extract_ior(struct ASE_Compiler_Cxx_Printer_PythonObject *obj, struct ASE_Compiler_Cxx_Assignment__object **ior)
{
  struct ASE_BaseInterface__object *objIor = (struct ASE_BaseInterface__object *) obj->ior;
  
  if ((PyObject *) obj == Py_None)
  {
    *ior = NULL;
    return 1;
  }
  *ior = (*(objIor->d_epv->castObject))(objIor->d_object, "ASE.Compiler.Cxx.Assignment", NULL);
  if (!(*ior))
  {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ASE.Compiler.Cxx.Assignment");
    return 0;
  }
  return 1;
}

#ifndef included_ASE_Compiler_Vertex
#include <ASE/Compiler/Vertex_IOR.h>
#endif

static PyObject *ASE_Compiler_Vertex__wrap_array_copy(struct ASE_Compiler_Vertex__array *array)
{
  PyArrayObject *_return_value = NULL;
  
  if (array)
  {
    const struct ASE_Compiler_Vertex__external *(*_externals)(void) = (const struct ASE_Compiler_Vertex__external *(*)(void)) ASE_Loader__externals()->getStaticEPV(NULL)->getClassMethodTable("ASE.Compiler.Vertex", NULL);
    const struct ASE_Compiler_Vertex__external *_extFunc = (*_externals)();
    long dimen = (*_extFunc->getDimen)(array, NULL);
    int32_t indLower[1] = {0};
    int32_t indUpper[1] = {0};
    int32_t indStride[1] = {0};
    struct int__array lower = {
      malloc(sizeof(int32_t) * (dimen ? dimen : 1)),
      indLower,
      indUpper,
      indStride,
      0,
      1};
    struct int__array upper = {
      malloc(sizeof(int32_t) * (dimen ? dimen : 1)),
      indLower,
      indUpper,
      indStride,
      0,
      1};
    struct int__array numElem = {
      malloc(sizeof(int32_t) * (dimen ? dimen : 1)),
      indLower,
      indUpper,
      indStride,
      0,
      1};
    long i = 0;
    
    for(i = 0; i < dimen; i++)
    {
      lower.d_firstElement[i] = (*_extFunc->getLower)(array, i, NULL);
      upper.d_firstElement[i] = (*_extFunc->getUpper)(array, i, NULL);
      numElem.d_firstElement[i] = upper.d_firstElement[i] - lower.d_firstElement[i] + 1;
    }
    _return_value = (PyArrayObject *) PyArray_FromDims(dimen, numElem.d_firstElement, PyArray_OBJECT);
    if (_return_value)
    {
      long size = 1;
      char *data = _return_value->data;
      
      for(i = 0; i < dimen; i++)
      {
        size *= numElem.d_firstElement[i];
      }
      while(size--)
      {
        struct ASE_Compiler_Vertex__object *elem = (*_extFunc->getElement)(array, &lower, NULL);
        
        (*(elem->d_epv->addReference))(elem->d_object, NULL);
        *(PyObject **) data = ASE_Compiler_Vertex__wrap_ior(elem);
        if (!(*(PyObject **) data))
        {
          Py_DECREF(_return_value);
          _return_value = NULL;
          goto error;
        }
        for(i = 0; i < dimen; i++)
        {
          data += _return_value->strides[i];
          if (++(lower.d_firstElement[i]) <= upper.d_firstElement[i])
          {
            break;
          }
          else
          {
            data -= _return_value->strides[i] * numElem.d_firstElement[i];
            lower.d_firstElement[i] -= numElem.d_firstElement[i];
          }
        }
      }
    }
    error: free(lower.d_firstElement);
    free(upper.d_firstElement);
    free(numElem.d_firstElement);
  }
  return (PyObject *) _return_value;
}

#ifndef included_ASE_Compiler_Vertex
#include <ASE/Compiler/Vertex_IOR.h>
#endif

static long ASE_Compiler_Vertex__extract_array(PyObject *obj, struct ASE_Compiler_Vertex__array **array)
{
  /* This will create a new Numeric array from a Python sequence */
  PyArrayObject *pyArray = (PyArrayObject *) PyArray_FromObject(obj, PyArray_OBJECT, 0, 0);
  long _return_value = 0;
  
  *array = NULL;
  if (pyArray)
  {
    int32_t dimen = pyArray->nd;
    int32_t indLower[1] = {0};
    int32_t indUpper[1] = {dimen - 1};
    int32_t indStride[1] = {1};
    struct int__array lower = {
      malloc(sizeof(int32_t) * (dimen ? dimen : 1)),
      indLower,
      indUpper,
      indStride,
      0,
      1};
    struct int__array upper = {
      malloc(sizeof(int32_t) * (dimen ? dimen : 1)),
      indLower,
      indUpper,
      indStride,
      0,
      1};
    struct int__array stride = {
      malloc(sizeof(int32_t) * (dimen ? dimen : 1)),
      indLower,
      indUpper,
      indStride,
      0,
      1};
    int32_t d = 0;
    const struct ASE_Compiler_Vertex__external *(*_externals)(void) = (const struct ASE_Compiler_Vertex__external *(*)(void)) ASE_Loader__externals()->getStaticEPV(NULL)->getClassMethodTable("ASE.Compiler.Vertex", NULL);
    const struct ASE_Compiler_Vertex__external *_extFunc = (*_externals)();
    long size = PyArray_Size((PyObject *) pyArray);
    char *data = pyArray->data;
    long i;
    struct int__array indices = {
      malloc(sizeof(long) * (dimen ? dimen : 1)),
      indLower,
      indUpper,
      indStride,
      0,
      1};
    
    for(d = 0; d < dimen; d++)
    {
      lower.d_firstElement[d] = 0;
      upper.d_firstElement[d] = pyArray->dimensions[d] - 1;
      stride.d_firstElement[d] = pyArray->strides[d] / pyArray->descr->elsize;
      if (pyArray->strides[d] % pyArray->descr->elsize)
      {
        free(lower.d_firstElement);
        free(upper.d_firstElement);
        free(stride.d_firstElement);
        return 0;
      }
    }
    *array = (*_extFunc->createArray)(dimen, &lower, &upper, NULL);
    free(lower.d_firstElement);
    free(upper.d_firstElement);
    free(stride.d_firstElement);
    memset(indices.d_firstElement, 0, sizeof(long) * (dimen ? dimen : 1));
    for(i = 0; i < size; i++)
    {
      struct ASE_Compiler_Vertex__object *elem;
      
      if (!ASE_Compiler_Vertex__extract_ior((struct ASE_Compiler_Cxx_Printer_PythonObject *) *(PyObject **) data, &elem))
      {
        (*_extFunc->destroyArray)(*array, NULL);
        *array = NULL;
        goto error;
      }
      (*_extFunc->setElement)(*array, &indices, elem, NULL);
      for(d = 0; d < dimen; d++)
      {
        data += pyArray->strides[d];
        if (++(indices.d_firstElement[d]) < pyArray->dimensions[d])
        {
          break;
        }
        else
        {
          indices.d_firstElement[d] = 0;
          data -= pyArray->dimensions[d] * pyArray->strides[d];
        }
      }
    }
    _return_value = 1;
    error: free(indices.d_firstElement);
    Py_DECREF(pyArray);
  }
  return _return_value;
}

static PyObject *ASE_Compiler_Printer_getTab(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {NULL};
  long _okay = 0;
  struct ASE_BaseException__object *_exception = NULL;
  const char *_return_value = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getTab");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getTab");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "", _kwlist);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  _return_value = (*(_self_ior->d_epv->getTab))(_self_ior, &_exception);
  if (_exception)
  {
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_BuildValue((char *) "z", _return_value);
  /* Freeing IOR memory since Python has made a copy of the string */
  free((void *) _return_value);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Printer_setTab(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "tab",
    NULL};
  long _okay = 0;
  const char *tab = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setTab");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setTab");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "z", _kwlist, &tab);
  /* Copying the Python string to IOR controlled memory */
  tab = tab ? strcpy(malloc(strlen(tab) + 1), tab) : NULL;
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->setTab))(_self_ior, tab, &_exception);
  if (_exception)
  {
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  /* Freeing IOR memory since Python has made a copy of the string */
  free((void *) tab);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Printer_getIndentSize(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {NULL};
  long _okay = 0;
  struct ASE_BaseException__object *_exception = NULL;
  int32_t _return_value = 0;
  long _local__return_value = 0;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getIndentSize");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getIndentSize");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "", _kwlist);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  _return_value = (*(_self_ior->d_epv->getIndentSize))(_self_ior, &_exception);
  if (_exception)
  {
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Convert int32_t to long */
  _local__return_value = _return_value;
  /* Build return values */
  _pyReturn = Py_BuildValue((char *) "l", _local__return_value);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Printer_setIndentSize(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "indentSize",
    NULL};
  long _okay = 0;
  int32_t indentSize = 0;
  long _local_indentSize = 0;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setIndentSize");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setIndentSize");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "l", _kwlist, &_local_indentSize);
  /* Convert long to int32_t */
  indentSize = _local_indentSize;
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->setIndentSize))(_self_ior, indentSize, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Printer_increaseIndent(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {NULL};
  long _okay = 0;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for increaseIndent");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in increaseIndent");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "", _kwlist);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->increaseIndent))(_self_ior, &_exception);
  if (_exception)
  {
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Printer_decreaseIndent(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {NULL};
  long _okay = 0;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for decreaseIndent");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in decreaseIndent");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "", _kwlist);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->decreaseIndent))(_self_ior, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Printer_indent(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {NULL};
  long _okay = 0;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for indent");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in indent");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "", _kwlist);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->indent))(_self_ior, &_exception);
  if (_exception)
  {
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Printer_write(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "s",
    NULL};
  long _okay = 0;
  const char *s = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for write");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in write");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "z", _kwlist, &s);
  /* Copying the Python string to IOR controlled memory */
  s = s ? strcpy(malloc(strlen(s) + 1), s) : NULL;
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->write))(_self_ior, s, &_exception);
  if (_exception)
  {
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  /* Freeing IOR memory since Python has made a copy of the string */
  free((void *) s);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Printer_println(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "s",
    NULL};
  long _okay = 0;
  const char *s = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for println");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in println");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "z", _kwlist, &s);
  /* Copying the Python string to IOR controlled memory */
  s = s ? strcpy(malloc(strlen(s) + 1), s) : NULL;
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->println))(_self_ior, s, &_exception);
  if (_exception)
  {
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  /* Freeing IOR memory since Python has made a copy of the string */
  free((void *) s);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Visitor_getRepository(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {NULL};
  long _okay = 0;
  struct ASE_BaseException__object *_exception = NULL;
  struct ASE_Compiler_Vertex__array *_return_value = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getRepository");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getRepository");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "", _kwlist);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  _return_value = (*(_self_ior->d_epv->getRepository))(_self_ior, &_exception);
  if (_exception)
  {
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_BuildValue((char *) "O&", (void *) ASE_Compiler_Vertex__wrap_array_copy, _return_value);
  (*((*((const struct ASE_Compiler_Vertex__external *(*)(void)) ASE_Loader__externals()->getStaticEPV(NULL)->getClassMethodTable("ASE.Compiler.Vertex", NULL)))()->destroyArray))(_return_value, NULL);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Visitor_setRepository(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "repository",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Vertex__array *repository = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setRepository");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setRepository");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Vertex__extract_array, &repository);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->setRepository))(_self_ior, repository, &_exception);
  if (_exception)
  {
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Visitor_visitVertex(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Vertex__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitVertex");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitVertex");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Vertex__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitVertex))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Visitor_visitSource(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Source__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitSource");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitSource");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Source__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitSource))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Visitor_visitHeader(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Header__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitHeader");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitHeader");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Header__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitHeader))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Visitor_visitPythonModule(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_PythonModule__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitPythonModule");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitPythonModule");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_PythonModule__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitPythonModule))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Visitor_visitExpression(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Expression__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitExpression");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitExpression");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Expression__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitExpression))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Search_getReverseEdges(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {NULL};
  long _okay = 0;
  struct ASE_BaseException__object *_exception = NULL;
  int _return_value = 0;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getReverseEdges");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getReverseEdges");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "", _kwlist);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  _return_value = (*(_self_ior->d_epv->getReverseEdges))(_self_ior, &_exception);
  if (_exception)
  {
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_BuildValue((char *) "i", _return_value);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Search_setReverseEdges(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "reverseEdges",
    NULL};
  long _okay = 0;
  int reverseEdges = 0;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setReverseEdges");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setReverseEdges");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "i", _kwlist, &reverseEdges);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->setReverseEdges))(_self_ior, reverseEdges, &_exception);
  if (_exception)
  {
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Search_traverseVertex(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Vertex__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for traverseVertex");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in traverseVertex");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Vertex__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->traverseVertex))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Search_resetVertexNumbering(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {NULL};
  long _okay = 0;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for resetVertexNumbering");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in resetVertexNumbering");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "", _kwlist);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->resetVertexNumbering))(_self_ior, &_exception);
  if (_exception)
  {
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Search_discoverVertex(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Vertex__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for discoverVertex");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in discoverVertex");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Vertex__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->discoverVertex))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Search_finishVertex(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Vertex__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for finishVertex");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in finishVertex");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Vertex__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->finishVertex))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Search_getVerticesSeen(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {NULL};
  long _okay = 0;
  struct ASE_BaseException__object *_exception = NULL;
  struct ASE_Compiler_Vertex__array *_return_value = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getVerticesSeen");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getVerticesSeen");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "", _kwlist);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  _return_value = (*(_self_ior->d_epv->getVerticesSeen))(_self_ior, &_exception);
  if (_exception)
  {
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_BuildValue((char *) "O&", (void *) ASE_Compiler_Vertex__wrap_array_copy, _return_value);
  (*((*((const struct ASE_Compiler_Vertex__external *(*)(void)) ASE_Loader__externals()->getStaticEPV(NULL)->getClassMethodTable("ASE.Compiler.Vertex", NULL)))()->destroyArray))(_return_value, NULL);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Search_setVerticesSeen(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "seen",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Vertex__array *seen = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setVerticesSeen");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setVerticesSeen");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Vertex__extract_array, &seen);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->setVerticesSeen))(_self_ior, seen, &_exception);
  if (_exception)
  {
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Search_getVertexSeen(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Vertex__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  int _return_value = 0;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getVertexSeen");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getVertexSeen");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Vertex__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  _return_value = (*(_self_ior->d_epv->getVertexSeen))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_BuildValue((char *) "i", _return_value);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Search_setVertexSeen(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    (char *) "state",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Vertex__object *vertex = NULL;
  int state = 0;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setVertexSeen");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setVertexSeen");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&i", _kwlist, (void *) ASE_Compiler_Vertex__extract_ior, &vertex, &state);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->setVertexSeen))(_self_ior, vertex, state, &_exception);
  if (_exception)
  {
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_BaseInterface_getReferenceCount(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {NULL};
  long _okay = 0;
  struct ASE_BaseException__object *_exception = NULL;
  int32_t _return_value = 0;
  long _local__return_value = 0;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getReferenceCount");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getReferenceCount");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "", _kwlist);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  _return_value = (*(_self_ior->d_epv->getReferenceCount))(_self_ior, &_exception);
  if (_exception)
  {
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Convert int32_t to long */
  _local__return_value = _return_value;
  /* Build return values */
  _pyReturn = Py_BuildValue((char *) "l", _local__return_value);
  return _pyReturn;
}

static PyObject *ASE_BaseInterface_addReference(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {NULL};
  long _okay = 0;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for addReference");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in addReference");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "", _kwlist);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->addReference))(_self_ior, &_exception);
  if (_exception)
  {
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_BaseInterface_deleteReference(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {NULL};
  long _okay = 0;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for deleteReference");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in deleteReference");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "", _kwlist);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->deleteReference))(_self_ior, &_exception);
  if (_exception)
  {
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_BaseInterface_isSame(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "obj",
    NULL};
  long _okay = 0;
  struct ASE_BaseInterface__object *obj = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  int _return_value = 0;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for isSame");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in isSame");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_BaseInterface__extract_ior, &obj);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  _return_value = (*(_self_ior->d_epv->isSame))(_self_ior, obj, &_exception);
  if (_exception)
  {
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_BuildValue((char *) "i", _return_value);
  return _pyReturn;
}

static PyObject *ASE_BaseInterface_getClassName(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {NULL};
  long _okay = 0;
  struct ASE_BaseException__object *_exception = NULL;
  const char *_return_value = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getClassName");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getClassName");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "", _kwlist);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  _return_value = (*(_self_ior->d_epv->getClassName))(_self_ior, &_exception);
  if (_exception)
  {
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_BuildValue((char *) "z", _return_value);
  /* Freeing IOR memory since Python has made a copy of the string */
  free((void *) _return_value);
  return _pyReturn;
}

static PyObject *ASE_BaseInterface_getName(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {NULL};
  long _okay = 0;
  struct ASE_BaseException__object *_exception = NULL;
  const char *_return_value = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getName");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getName");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "", _kwlist);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  _return_value = (*(_self_ior->d_epv->getName))(_self_ior, &_exception);
  if (_exception)
  {
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_BuildValue((char *) "z", _return_value);
  /* Freeing IOR memory since Python has made a copy of the string */
  free((void *) _return_value);
  return _pyReturn;
}

static PyObject *ASE_BaseInterface_setName(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "name",
    NULL};
  long _okay = 0;
  const char *name = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setName");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setName");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "z", _kwlist, &name);
  /* Copying the Python string to IOR controlled memory */
  name = name ? strcpy(malloc(strlen(name) + 1), name) : NULL;
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->setName))(_self_ior, name, &_exception);
  if (_exception)
  {
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  /* Freeing IOR memory since Python has made a copy of the string */
  free((void *) name);
  return _pyReturn;
}

static PyObject *ASE_BaseInterface_isInstanceOf(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "typeName",
    NULL};
  long _okay = 0;
  const char *typeName = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  int _return_value = 0;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for isInstanceOf");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in isInstanceOf");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "z", _kwlist, &typeName);
  /* Copying the Python string to IOR controlled memory */
  typeName = typeName ? strcpy(malloc(strlen(typeName) + 1), typeName) : NULL;
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  _return_value = (*(_self_ior->d_epv->isInstanceOf))(_self_ior, typeName, &_exception);
  if (_exception)
  {
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_BuildValue((char *) "i", _return_value);
  /* Freeing IOR memory since Python has made a copy of the string */
  free((void *) typeName);
  return _pyReturn;
}

static PyObject *ASE_BaseInterface_getSuper(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {NULL};
  long _okay = 0;
  struct ASE_BaseException__object *_exception = NULL;
  struct ASE_BaseInterface__object *_return_value = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getSuper");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getSuper");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "", _kwlist);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  _return_value = (*(_self_ior->d_epv->getSuper))(_self_ior, &_exception);
  if (_exception)
  {
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_BuildValue((char *) "O&", (void *) ASE_BaseInterface__wrap_ior, _return_value);
  if (_return_value)
  {
    (*((((struct ASE_BaseInterface__object *) _return_value))->d_epv->addReference))(((struct ASE_BaseInterface__object *) _return_value)->d_object, NULL);
  }
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitInclude(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Include__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitInclude");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitInclude");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Include__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitInclude))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitDefine(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Define__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitDefine");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitDefine");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Define__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitDefine))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitMacro(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Macro__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitMacro");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitMacro");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Macro__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitMacro))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitPreprocessorConditional(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_PreprocessorConditional__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitPreprocessorConditional");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitPreprocessorConditional");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_PreprocessorConditional__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitPreprocessorConditional))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitType(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Type__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitType");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitType");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Type__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitType))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitPointer(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Pointer__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitPointer");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitPointer");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Pointer__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitPointer))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitStruct(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Struct__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitStruct");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitStruct");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Struct__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitStruct))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitBitField(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_BitField__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitBitField");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitBitField");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_BitField__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitBitField))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitEnumeration(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Enumeration__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitEnumeration");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitEnumeration");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Enumeration__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitEnumeration))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitEnumerator(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Enumerator__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitEnumerator");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitEnumerator");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Enumerator__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitEnumerator))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitTypedef(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Typedef__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitTypedef");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitTypedef");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Typedef__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitTypedef))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitGroup(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Group__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitGroup");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitGroup");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Group__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitGroup))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitDeclarator(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Declarator__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitDeclarator");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitDeclarator");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Declarator__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitDeclarator))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitDeclaratorGroup(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_DeclaratorGroup__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitDeclaratorGroup");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitDeclaratorGroup");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_DeclaratorGroup__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitDeclaratorGroup))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitArray(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Array__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitArray");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitArray");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Array__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitArray))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitFunction(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Function__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitFunction");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitFunction");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Function__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitFunction))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitParameter(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Parameter__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitParameter");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitParameter");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Parameter__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitParameter))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitDeclaration(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Declaration__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitDeclaration");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitDeclaration");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Declaration__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitDeclaration))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitStatement(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Statement__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitStatement");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitStatement");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Statement__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitStatement))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitExpressionStatement(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_ExpressionStatement__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitExpressionStatement");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitExpressionStatement");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_ExpressionStatement__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitExpressionStatement))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitCompoundStatement(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_CompoundStatement__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitCompoundStatement");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitCompoundStatement");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_CompoundStatement__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitCompoundStatement))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitIf(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_If__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitIf");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitIf");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_If__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitIf))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitSwitch(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Switch__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitSwitch");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitSwitch");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Switch__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitSwitch))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitWhile(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_While__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitWhile");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitWhile");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_While__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitWhile))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitFor(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_For__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitFor");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitFor");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_For__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitFor))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitGoto(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Goto__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitGoto");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitGoto");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Goto__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitGoto))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitContinue(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Continue__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitContinue");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitContinue");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Continue__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitContinue))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitBreak(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Break__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitBreak");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitBreak");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Break__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitBreak))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitReturn(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Return__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitReturn");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitReturn");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Return__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitReturn))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitInitializer(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Initializer__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitInitializer");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitInitializer");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Initializer__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitInitializer))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitAssignment(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Assignment__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitAssignment");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitAssignment");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Assignment__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitAssignment))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitInclusiveOrAssignment(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_InclusiveOrAssignment__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitInclusiveOrAssignment");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitInclusiveOrAssignment");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_InclusiveOrAssignment__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitInclusiveOrAssignment))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitExclusiveOrAssignment(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_ExclusiveOrAssignment__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitExclusiveOrAssignment");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitExclusiveOrAssignment");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_ExclusiveOrAssignment__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitExclusiveOrAssignment))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitAndAssignment(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_AndAssignment__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitAndAssignment");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitAndAssignment");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_AndAssignment__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitAndAssignment))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitLeftShiftAssignment(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_LeftShiftAssignment__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitLeftShiftAssignment");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitLeftShiftAssignment");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_LeftShiftAssignment__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitLeftShiftAssignment))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitRightShiftAssignment(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_RightShiftAssignment__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitRightShiftAssignment");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitRightShiftAssignment");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_RightShiftAssignment__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitRightShiftAssignment))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitAdditionAssignment(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_AdditionAssignment__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitAdditionAssignment");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitAdditionAssignment");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_AdditionAssignment__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitAdditionAssignment))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitSubtractionAssignment(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_SubtractionAssignment__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitSubtractionAssignment");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitSubtractionAssignment");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_SubtractionAssignment__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitSubtractionAssignment))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitMultiplicationAssignment(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_MultiplicationAssignment__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitMultiplicationAssignment");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitMultiplicationAssignment");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_MultiplicationAssignment__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitMultiplicationAssignment))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitDivisionAssignment(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_DivisionAssignment__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitDivisionAssignment");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitDivisionAssignment");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_DivisionAssignment__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitDivisionAssignment))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitModuloAssignment(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_ModuloAssignment__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitModuloAssignment");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitModuloAssignment");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_ModuloAssignment__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitModuloAssignment))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitLogicalOr(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_LogicalOr__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitLogicalOr");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitLogicalOr");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_LogicalOr__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitLogicalOr))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitLogicalAnd(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_LogicalAnd__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitLogicalAnd");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitLogicalAnd");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_LogicalAnd__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitLogicalAnd))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitInclusiveOr(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_InclusiveOr__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitInclusiveOr");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitInclusiveOr");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_InclusiveOr__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitInclusiveOr))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitExclusiveOr(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_ExclusiveOr__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitExclusiveOr");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitExclusiveOr");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_ExclusiveOr__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitExclusiveOr))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitAnd(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_And__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitAnd");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitAnd");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_And__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitAnd))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitEquality(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Equality__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitEquality");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitEquality");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Equality__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitEquality))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitInequality(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Inequality__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitInequality");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitInequality");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Inequality__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitInequality))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitLessThan(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_LessThan__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitLessThan");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitLessThan");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_LessThan__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitLessThan))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitGreaterThan(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_GreaterThan__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitGreaterThan");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitGreaterThan");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_GreaterThan__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitGreaterThan))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitLessThanOrEqual(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_LessThanOrEqual__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitLessThanOrEqual");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitLessThanOrEqual");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_LessThanOrEqual__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitLessThanOrEqual))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitGreaterThanOrEqual(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_GreaterThanOrEqual__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitGreaterThanOrEqual");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitGreaterThanOrEqual");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_GreaterThanOrEqual__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitGreaterThanOrEqual))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitLeftShift(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_LeftShift__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitLeftShift");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitLeftShift");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_LeftShift__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitLeftShift))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitRightShift(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_RightShift__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitRightShift");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitRightShift");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_RightShift__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitRightShift))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitAddition(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Addition__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitAddition");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitAddition");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Addition__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitAddition))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitSubtraction(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Subtraction__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitSubtraction");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitSubtraction");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Subtraction__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitSubtraction))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitMultiplication(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Multiplication__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitMultiplication");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitMultiplication");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Multiplication__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitMultiplication))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitDivision(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Division__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitDivision");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitDivision");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Division__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitDivision))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitModulo(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Modulo__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitModulo");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitModulo");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Modulo__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitModulo))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitCast(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Cast__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitCast");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitCast");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Cast__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitCast))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitSizeof(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Sizeof__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitSizeof");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitSizeof");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Sizeof__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitSizeof))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitAddress(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Address__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitAddress");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitAddress");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Address__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitAddress))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitIndirection(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Indirection__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitIndirection");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitIndirection");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Indirection__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitIndirection))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitUnaryPlus(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_UnaryPlus__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitUnaryPlus");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitUnaryPlus");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_UnaryPlus__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitUnaryPlus))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitUnaryMinus(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_UnaryMinus__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitUnaryMinus");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitUnaryMinus");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_UnaryMinus__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitUnaryMinus))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitComplement(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Complement__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitComplement");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitComplement");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Complement__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitComplement))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitNegation(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Negation__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitNegation");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitNegation");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Negation__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitNegation))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitIncrement(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Increment__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitIncrement");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitIncrement");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Increment__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitIncrement))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitStructReference(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_StructReference__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitStructReference");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitStructReference");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_StructReference__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitStructReference))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitArrayReference(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_ArrayReference__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitArrayReference");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitArrayReference");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_ArrayReference__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitArrayReference))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitFunctionCall(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_FunctionCall__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitFunctionCall");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitFunctionCall");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_FunctionCall__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitFunctionCall))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitVariable(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Variable__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitVariable");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitVariable");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Variable__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitVariable))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_visitConstant(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  PyObject *_pyReturn = NULL;
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {
    (char *) "vertex",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Constant__object *vertex = NULL;
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for visitConstant");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in visitConstant");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "O&", _kwlist, (void *) ASE_Compiler_Cxx_Constant__extract_ior, &vertex);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->visitConstant))(_self_ior, vertex, &_exception);
  if (_exception)
  {
    PyObject *ASE_Compiler_CompilerException_module = PyImport_ImportModule((char *) "ASE.Compiler.CompilerException");
    PyObject *ASE_Compiler_CompilerException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_Compiler_CompilerException_module), (char *) "Exception");
    struct ASE_Compiler_CompilerException__object *ASE_Compiler_CompilerException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.Compiler.CompilerException", NULL);
    PyObject *ASE_BaseException_module = PyImport_ImportModule((char *) "ASE.BaseException");
    PyObject *ASE_BaseException_type = PyMapping_GetItemString(PyModule_GetDict(ASE_BaseException_module), (char *) "Exception");
    struct ASE_BaseException__object *ASE_BaseException_obj = (*(_exception->d_epv->castObject))(_exception->d_object, "ASE.BaseException", NULL);
    
    if (ASE_Compiler_CompilerException_obj)
    {
      PyObject *_obj = ASE_Compiler_CompilerException__wrap_ior(ASE_Compiler_CompilerException_obj);
      
      PyErr_SetObject(ASE_Compiler_CompilerException_type, _obj);
    }
    else
    if (ASE_BaseException_obj)
    {
      PyObject *_obj = ASE_BaseException__wrap_ior(ASE_BaseException_obj);
      
      PyErr_SetObject(ASE_BaseException_type, _obj);
    }
    else
    {
      _exception = (*((struct ASE_BaseInterface__object *) _exception->d_object)->d_epv->castObject)(_exception->d_object, "ASE.BaseException", NULL);
      PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    }
    Py_DECREF(ASE_Compiler_CompilerException_module);
    Py_DECREF(ASE_Compiler_CompilerException_type);
    Py_DECREF(ASE_BaseException_module);
    Py_DECREF(ASE_BaseException_type);
    return _pyReturn;
  }
  /* Build return values */
  _pyReturn = Py_None;
  Py_INCREF(_pyReturn);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_weakReference(PyObject *_self, PyObject *_args, PyObject *_kwdict)
{
  /* Retrieve the IOR pointer */
  struct ASE_Compiler_Cxx_Printer__object *_self_ior = ((struct ASE_Compiler_Cxx_Printer_PythonObject *) _self)->ior;
  static char *_kwlist[] = {NULL};
  long _okay = 0;
  PyObject *_pyReturn = NULL;
  struct ASE_Compiler_Cxx_Printer__object *_return_value = NULL;
  
  /* Check for a valid SIDL Object */
  if (_self->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for weakReference");
    return _pyReturn;
  }
  if (!_self_ior)
  {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in weakReference");
    return _pyReturn;
  }
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "", _kwlist);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  _return_value = _self_ior;
  /* Build return values */
  _pyReturn = Py_BuildValue((char *) "O&", (void *) ASE_Compiler_Cxx_Printer__wrap_ior_weak, _return_value);
  return _pyReturn;
}

static PyObject *ASE_Compiler_Cxx_Printer_Printer(PyObject *_type, PyObject *_args, PyObject *_kwdict)
{
  static char *_kwlist[] = {
    (char *) "obj",
    NULL};
  long _okay = 0;
  struct ASE_Compiler_Cxx_Printer__object *obj = NULL;
  int created = 0;
  struct ASE_Compiler_Cxx_Printer__object *_return_value = NULL;
  PyObject *_pyReturn = NULL;
  
  /* Parse arguments */
  _okay = PyArg_ParseTupleAndKeywords(_args, _kwdict, (char *) "|O&", _kwlist, (void *) ASE_Compiler_Cxx_Printer__extract_ior, &obj);
  if (!_okay)
  {
    /* Let exceptions propagate */
    return _pyReturn;
  }
  if (obj)
  {
    created = 0;
  }
  else
  {
    created = 1;
    obj = (*(_epv->createObject))(NULL);
  }
  _return_value = obj;
  /* Build return values */
  _pyReturn = Py_BuildValue((char *) "O&", (void *) ASE_Compiler_Cxx_Printer__wrap_ior, _return_value);
  if (_return_value)
  {
    (*((((struct ASE_BaseInterface__object *) _return_value))->d_epv->addReference))(((struct ASE_BaseInterface__object *) _return_value)->d_object, NULL);
  }
  if (created)
  {
    (*(obj->d_epv->deleteReference))(obj->d_object, NULL);
  }
  return _pyReturn;
}

static struct PyMethodDef _PrinterObjectMethods[] = {
  {(char *) "getTab", (PyCFunction) ASE_Compiler_Printer_getTab, (METH_VARARGS | METH_KEYWORDS), (char *) "getTab()\n\
RETURNS (return string _return_value)\n\
 Retrieve the tab string"},
  {(char *) "setTab", (PyCFunction) ASE_Compiler_Printer_setTab, (METH_VARARGS | METH_KEYWORDS), (char *) "setTab(in string tab)\n\
RETURNS None\n\
\n\
 Set the tab string"},
  {(char *) "getIndentSize", (PyCFunction) ASE_Compiler_Printer_getIndentSize, (METH_VARARGS | METH_KEYWORDS), (char *) "getIndentSize()\n\
RETURNS (return int _return_value)\n\
 Retrieve the number of tabs of the current indent"},
  {(char *) "setIndentSize", (PyCFunction) ASE_Compiler_Printer_setIndentSize, (METH_VARARGS | METH_KEYWORDS), (char *) "setIndentSize(in int indentSize)\n\
RETURNS None\n\
\n\
 Set the number of tabs of the current indent   Throws an exception on a negative indent size"},
  {(char *) "increaseIndent", (PyCFunction) ASE_Compiler_Printer_increaseIndent, (METH_VARARGS | METH_KEYWORDS), (char *) "increaseIndent()\n\
RETURNS None\n\
\n\
 Increase the index size by one"},
  {(char *) "decreaseIndent", (PyCFunction) ASE_Compiler_Printer_decreaseIndent, (METH_VARARGS | METH_KEYWORDS), (char *) "decreaseIndent()\n\
RETURNS None\n\
\n\
 Decrease the index size by one   Throws an exception on a negative indent size"},
  {(char *) "indent", (PyCFunction) ASE_Compiler_Printer_indent, (METH_VARARGS | METH_KEYWORDS), (char *) "indent()\n\
RETURNS None\n\
\n\
 Output the current indent (the indent size in tabs)"},
  {(char *) "write", (PyCFunction) ASE_Compiler_Printer_write, (METH_VARARGS | METH_KEYWORDS), (char *) "write(in string s)\n\
RETURNS None\n\
\n\
 Output a string"},
  {(char *) "println", (PyCFunction) ASE_Compiler_Printer_println, (METH_VARARGS | METH_KEYWORDS), (char *) "println(in string s)\n\
RETURNS None\n\
\n\
 Output a string, properly indented and followed by a newline"},
  {(char *) "getRepository", (PyCFunction) ASE_Compiler_Visitor_getRepository, (METH_VARARGS | METH_KEYWORDS), (char *) "getRepository()\n\
RETURNS (return array _return_value)\n\
 Retrieve auxilliary ASTs"},
  {(char *) "setRepository", (PyCFunction) ASE_Compiler_Visitor_setRepository, (METH_VARARGS | METH_KEYWORDS), (char *) "setRepository(in array repository)\n\
RETURNS None\n\
\n\
 Set auxilliary ASTs"},
  {(char *) "visitVertex", (PyCFunction) ASE_Compiler_Visitor_visitVertex, (METH_VARARGS | METH_KEYWORDS), (char *) "visitVertex(in ASE.Compiler.Vertex vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitSource", (PyCFunction) ASE_Compiler_Cxx_Visitor_visitSource, (METH_VARARGS | METH_KEYWORDS), (char *) "visitSource(in ASE.Compiler.Cxx.Source vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitHeader", (PyCFunction) ASE_Compiler_Cxx_Visitor_visitHeader, (METH_VARARGS | METH_KEYWORDS), (char *) "visitHeader(in ASE.Compiler.Cxx.Header vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitPythonModule", (PyCFunction) ASE_Compiler_Cxx_Visitor_visitPythonModule, (METH_VARARGS | METH_KEYWORDS), (char *) "visitPythonModule(in ASE.Compiler.Cxx.PythonModule vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitExpression", (PyCFunction) ASE_Compiler_Cxx_Visitor_visitExpression, (METH_VARARGS | METH_KEYWORDS), (char *) "visitExpression(in ASE.Compiler.Cxx.Expression vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "getReverseEdges", (PyCFunction) ASE_Compiler_Search_getReverseEdges, (METH_VARARGS | METH_KEYWORDS), (char *) "getReverseEdges()\n\
RETURNS (return bool _return_value)\n\
 Retrieve the flag for reversing the orientation of edges in the traversal"},
  {(char *) "setReverseEdges", (PyCFunction) ASE_Compiler_Search_setReverseEdges, (METH_VARARGS | METH_KEYWORDS), (char *) "setReverseEdges(in bool reverseEdges)\n\
RETURNS None\n\
\n\
 Set the flag for reversing the orientation of edges in the traversal"},
  {(char *) "traverseVertex", (PyCFunction) ASE_Compiler_Search_traverseVertex, (METH_VARARGS | METH_KEYWORDS), (char *) "traverseVertex(in ASE.Compiler.Vertex vertex)\n\
RETURNS None\n\
\n\
 Traverse each edge of this vertex"},
  {(char *) "resetVertexNumbering", (PyCFunction) ASE_Compiler_Search_resetVertexNumbering, (METH_VARARGS | METH_KEYWORDS), (char *) "resetVertexNumbering()\n\
RETURNS None\n\
\n\
 Reset the vertex discovery and finish numbering"},
  {(char *) "discoverVertex", (PyCFunction) ASE_Compiler_Search_discoverVertex, (METH_VARARGS | METH_KEYWORDS), (char *) "discoverVertex(in ASE.Compiler.Vertex vertex)\n\
RETURNS None\n\
\n\
 Mark a vertex as discovered and increment the count"},
  {(char *) "finishVertex", (PyCFunction) ASE_Compiler_Search_finishVertex, (METH_VARARGS | METH_KEYWORDS), (char *) "finishVertex(in ASE.Compiler.Vertex vertex)\n\
RETURNS None\n\
\n\
 Mark a vertex as finished and increment the count"},
  {(char *) "getVerticesSeen", (PyCFunction) ASE_Compiler_Search_getVerticesSeen, (METH_VARARGS | METH_KEYWORDS), (char *) "getVerticesSeen()\n\
RETURNS (return array _return_value)\n\
 Retrieve the list of vertices discovered"},
  {(char *) "setVerticesSeen", (PyCFunction) ASE_Compiler_Search_setVerticesSeen, (METH_VARARGS | METH_KEYWORDS), (char *) "setVerticesSeen(in array seen)\n\
RETURNS None\n\
\n\
 Set the list of vertices discovered"},
  {(char *) "getVertexSeen", (PyCFunction) ASE_Compiler_Search_getVertexSeen, (METH_VARARGS | METH_KEYWORDS), (char *) "getVertexSeen(in ASE.Compiler.Vertex vertex)\n\
RETURNS (return bool _return_value)\n\
 Retrieve the vertex discovery state"},
  {(char *) "setVertexSeen", (PyCFunction) ASE_Compiler_Search_setVertexSeen, (METH_VARARGS | METH_KEYWORDS), (char *) "setVertexSeen(in ASE.Compiler.Vertex vertex, in bool state)\n\
RETURNS None\n\
\n\
 Set the vertex discovery state"},
  {(char *) "getReferenceCount", (PyCFunction) ASE_BaseInterface_getReferenceCount, (METH_VARARGS | METH_KEYWORDS), (char *) "getReferenceCount()\n\
RETURNS (return int _return_value)\n\
 Retrieve the intrinsic reference count of the underlying object"},
  {(char *) "addReference", (PyCFunction) ASE_BaseInterface_addReference, (METH_VARARGS | METH_KEYWORDS), (char *) "addReference()\n\
RETURNS None\n\
\n\
 Add one to the intrinsic reference count of the underlying object - Objects continue to exist as long as the reference count is positive - Clients should call this method whenever they create another ongoing reference to an object or interface"},
  {(char *) "deleteReference", (PyCFunction) ASE_BaseInterface_deleteReference, (METH_VARARGS | METH_KEYWORDS), (char *) "deleteReference()\n\
RETURNS None\n\
\n\
 Decrease by one the intrinsic reference count of the underlying object - Delete the object if the reference count is non-positive - Clients should call this method whenever they remove a reference to an object or interface"},
  {(char *) "isSame", (PyCFunction) ASE_BaseInterface_isSame, (METH_VARARGS | METH_KEYWORDS), (char *) "isSame(in ASE.BaseInterface obj)\n\
RETURNS (return bool _return_value)\n\
 Return true if and only if <code>obj</code> refers to the same underlying object as this object"},
  {(char *) "getClassName", (PyCFunction) ASE_BaseInterface_getClassName, (METH_VARARGS | METH_KEYWORDS), (char *) "getClassName()\n\
RETURNS (return string _return_value)\n\
 Return the type name of the underlying class object"},
  {(char *) "getName", (PyCFunction) ASE_BaseInterface_getName, (METH_VARARGS | METH_KEYWORDS), (char *) "getName()\n\
RETURNS (return string _return_value)\n\
 Retrieve the object name"},
  {(char *) "setName", (PyCFunction) ASE_BaseInterface_setName, (METH_VARARGS | METH_KEYWORDS), (char *) "setName(in string name)\n\
RETURNS None\n\
\n\
 Set the object name"},
  {(char *) "isInstanceOf", (PyCFunction) ASE_BaseInterface_isInstanceOf, (METH_VARARGS | METH_KEYWORDS), (char *) "isInstanceOf(in string typeName)\n\
RETURNS (return bool _return_value)\n\
 Return <code>true</code> if this object is an instance of the specified type - This routine will return <code>true</code> if and only if a cast to the specified type would succeed"},
  {(char *) "getSuper", (PyCFunction) ASE_BaseInterface_getSuper, (METH_VARARGS | METH_KEYWORDS), (char *) "getSuper()\n\
RETURNS (return ASE.BaseInterface _return_value)\n\
 Retrieve an object with the parent interface IMPL: Obviously, this must be implemented in the IOR of each interface/class"},
  {(char *) "visitInclude", (PyCFunction) ASE_Compiler_Cxx_Printer_visitInclude, (METH_VARARGS | METH_KEYWORDS), (char *) "visitInclude(in ASE.Compiler.Cxx.Include vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitDefine", (PyCFunction) ASE_Compiler_Cxx_Printer_visitDefine, (METH_VARARGS | METH_KEYWORDS), (char *) "visitDefine(in ASE.Compiler.Cxx.Define vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitMacro", (PyCFunction) ASE_Compiler_Cxx_Printer_visitMacro, (METH_VARARGS | METH_KEYWORDS), (char *) "visitMacro(in ASE.Compiler.Cxx.Macro vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitPreprocessorConditional", (PyCFunction) ASE_Compiler_Cxx_Printer_visitPreprocessorConditional, (METH_VARARGS | METH_KEYWORDS), (char *) "visitPreprocessorConditional(in ASE.Compiler.Cxx.PreprocessorConditional vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitType", (PyCFunction) ASE_Compiler_Cxx_Printer_visitType, (METH_VARARGS | METH_KEYWORDS), (char *) "visitType(in ASE.Compiler.Cxx.Type vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitPointer", (PyCFunction) ASE_Compiler_Cxx_Printer_visitPointer, (METH_VARARGS | METH_KEYWORDS), (char *) "visitPointer(in ASE.Compiler.Cxx.Pointer vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitStruct", (PyCFunction) ASE_Compiler_Cxx_Printer_visitStruct, (METH_VARARGS | METH_KEYWORDS), (char *) "visitStruct(in ASE.Compiler.Cxx.Struct vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitBitField", (PyCFunction) ASE_Compiler_Cxx_Printer_visitBitField, (METH_VARARGS | METH_KEYWORDS), (char *) "visitBitField(in ASE.Compiler.Cxx.BitField vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitEnumeration", (PyCFunction) ASE_Compiler_Cxx_Printer_visitEnumeration, (METH_VARARGS | METH_KEYWORDS), (char *) "visitEnumeration(in ASE.Compiler.Cxx.Enumeration vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitEnumerator", (PyCFunction) ASE_Compiler_Cxx_Printer_visitEnumerator, (METH_VARARGS | METH_KEYWORDS), (char *) "visitEnumerator(in ASE.Compiler.Cxx.Enumerator vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitTypedef", (PyCFunction) ASE_Compiler_Cxx_Printer_visitTypedef, (METH_VARARGS | METH_KEYWORDS), (char *) "visitTypedef(in ASE.Compiler.Cxx.Typedef vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitGroup", (PyCFunction) ASE_Compiler_Cxx_Printer_visitGroup, (METH_VARARGS | METH_KEYWORDS), (char *) "visitGroup(in ASE.Compiler.Cxx.Group vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitDeclarator", (PyCFunction) ASE_Compiler_Cxx_Printer_visitDeclarator, (METH_VARARGS | METH_KEYWORDS), (char *) "visitDeclarator(in ASE.Compiler.Cxx.Declarator vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitDeclaratorGroup", (PyCFunction) ASE_Compiler_Cxx_Printer_visitDeclaratorGroup, (METH_VARARGS | METH_KEYWORDS), (char *) "visitDeclaratorGroup(in ASE.Compiler.Cxx.DeclaratorGroup vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitArray", (PyCFunction) ASE_Compiler_Cxx_Printer_visitArray, (METH_VARARGS | METH_KEYWORDS), (char *) "visitArray(in ASE.Compiler.Cxx.Array vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitFunction", (PyCFunction) ASE_Compiler_Cxx_Printer_visitFunction, (METH_VARARGS | METH_KEYWORDS), (char *) "visitFunction(in ASE.Compiler.Cxx.Function vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitParameter", (PyCFunction) ASE_Compiler_Cxx_Printer_visitParameter, (METH_VARARGS | METH_KEYWORDS), (char *) "visitParameter(in ASE.Compiler.Cxx.Parameter vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitDeclaration", (PyCFunction) ASE_Compiler_Cxx_Printer_visitDeclaration, (METH_VARARGS | METH_KEYWORDS), (char *) "visitDeclaration(in ASE.Compiler.Cxx.Declaration vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitStatement", (PyCFunction) ASE_Compiler_Cxx_Printer_visitStatement, (METH_VARARGS | METH_KEYWORDS), (char *) "visitStatement(in ASE.Compiler.Cxx.Statement vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitExpressionStatement", (PyCFunction) ASE_Compiler_Cxx_Printer_visitExpressionStatement, (METH_VARARGS | METH_KEYWORDS), (char *) "visitExpressionStatement(in ASE.Compiler.Cxx.ExpressionStatement vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitCompoundStatement", (PyCFunction) ASE_Compiler_Cxx_Printer_visitCompoundStatement, (METH_VARARGS | METH_KEYWORDS), (char *) "visitCompoundStatement(in ASE.Compiler.Cxx.CompoundStatement vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitIf", (PyCFunction) ASE_Compiler_Cxx_Printer_visitIf, (METH_VARARGS | METH_KEYWORDS), (char *) "visitIf(in ASE.Compiler.Cxx.If vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitSwitch", (PyCFunction) ASE_Compiler_Cxx_Printer_visitSwitch, (METH_VARARGS | METH_KEYWORDS), (char *) "visitSwitch(in ASE.Compiler.Cxx.Switch vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitWhile", (PyCFunction) ASE_Compiler_Cxx_Printer_visitWhile, (METH_VARARGS | METH_KEYWORDS), (char *) "visitWhile(in ASE.Compiler.Cxx.While vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitFor", (PyCFunction) ASE_Compiler_Cxx_Printer_visitFor, (METH_VARARGS | METH_KEYWORDS), (char *) "visitFor(in ASE.Compiler.Cxx.For vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitGoto", (PyCFunction) ASE_Compiler_Cxx_Printer_visitGoto, (METH_VARARGS | METH_KEYWORDS), (char *) "visitGoto(in ASE.Compiler.Cxx.Goto vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitContinue", (PyCFunction) ASE_Compiler_Cxx_Printer_visitContinue, (METH_VARARGS | METH_KEYWORDS), (char *) "visitContinue(in ASE.Compiler.Cxx.Continue vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitBreak", (PyCFunction) ASE_Compiler_Cxx_Printer_visitBreak, (METH_VARARGS | METH_KEYWORDS), (char *) "visitBreak(in ASE.Compiler.Cxx.Break vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitReturn", (PyCFunction) ASE_Compiler_Cxx_Printer_visitReturn, (METH_VARARGS | METH_KEYWORDS), (char *) "visitReturn(in ASE.Compiler.Cxx.Return vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitInitializer", (PyCFunction) ASE_Compiler_Cxx_Printer_visitInitializer, (METH_VARARGS | METH_KEYWORDS), (char *) "visitInitializer(in ASE.Compiler.Cxx.Initializer vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitAssignment", (PyCFunction) ASE_Compiler_Cxx_Printer_visitAssignment, (METH_VARARGS | METH_KEYWORDS), (char *) "visitAssignment(in ASE.Compiler.Cxx.Assignment vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitInclusiveOrAssignment", (PyCFunction) ASE_Compiler_Cxx_Printer_visitInclusiveOrAssignment, (METH_VARARGS | METH_KEYWORDS), (char *) "visitInclusiveOrAssignment(in ASE.Compiler.Cxx.InclusiveOrAssignment vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitExclusiveOrAssignment", (PyCFunction) ASE_Compiler_Cxx_Printer_visitExclusiveOrAssignment, (METH_VARARGS | METH_KEYWORDS), (char *) "visitExclusiveOrAssignment(in ASE.Compiler.Cxx.ExclusiveOrAssignment vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitAndAssignment", (PyCFunction) ASE_Compiler_Cxx_Printer_visitAndAssignment, (METH_VARARGS | METH_KEYWORDS), (char *) "visitAndAssignment(in ASE.Compiler.Cxx.AndAssignment vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitLeftShiftAssignment", (PyCFunction) ASE_Compiler_Cxx_Printer_visitLeftShiftAssignment, (METH_VARARGS | METH_KEYWORDS), (char *) "visitLeftShiftAssignment(in ASE.Compiler.Cxx.LeftShiftAssignment vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitRightShiftAssignment", (PyCFunction) ASE_Compiler_Cxx_Printer_visitRightShiftAssignment, (METH_VARARGS | METH_KEYWORDS), (char *) "visitRightShiftAssignment(in ASE.Compiler.Cxx.RightShiftAssignment vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitAdditionAssignment", (PyCFunction) ASE_Compiler_Cxx_Printer_visitAdditionAssignment, (METH_VARARGS | METH_KEYWORDS), (char *) "visitAdditionAssignment(in ASE.Compiler.Cxx.AdditionAssignment vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitSubtractionAssignment", (PyCFunction) ASE_Compiler_Cxx_Printer_visitSubtractionAssignment, (METH_VARARGS | METH_KEYWORDS), (char *) "visitSubtractionAssignment(in ASE.Compiler.Cxx.SubtractionAssignment vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitMultiplicationAssignment", (PyCFunction) ASE_Compiler_Cxx_Printer_visitMultiplicationAssignment, (METH_VARARGS | METH_KEYWORDS), (char *) "visitMultiplicationAssignment(in ASE.Compiler.Cxx.MultiplicationAssignment vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitDivisionAssignment", (PyCFunction) ASE_Compiler_Cxx_Printer_visitDivisionAssignment, (METH_VARARGS | METH_KEYWORDS), (char *) "visitDivisionAssignment(in ASE.Compiler.Cxx.DivisionAssignment vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitModuloAssignment", (PyCFunction) ASE_Compiler_Cxx_Printer_visitModuloAssignment, (METH_VARARGS | METH_KEYWORDS), (char *) "visitModuloAssignment(in ASE.Compiler.Cxx.ModuloAssignment vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitLogicalOr", (PyCFunction) ASE_Compiler_Cxx_Printer_visitLogicalOr, (METH_VARARGS | METH_KEYWORDS), (char *) "visitLogicalOr(in ASE.Compiler.Cxx.LogicalOr vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitLogicalAnd", (PyCFunction) ASE_Compiler_Cxx_Printer_visitLogicalAnd, (METH_VARARGS | METH_KEYWORDS), (char *) "visitLogicalAnd(in ASE.Compiler.Cxx.LogicalAnd vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitInclusiveOr", (PyCFunction) ASE_Compiler_Cxx_Printer_visitInclusiveOr, (METH_VARARGS | METH_KEYWORDS), (char *) "visitInclusiveOr(in ASE.Compiler.Cxx.InclusiveOr vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitExclusiveOr", (PyCFunction) ASE_Compiler_Cxx_Printer_visitExclusiveOr, (METH_VARARGS | METH_KEYWORDS), (char *) "visitExclusiveOr(in ASE.Compiler.Cxx.ExclusiveOr vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitAnd", (PyCFunction) ASE_Compiler_Cxx_Printer_visitAnd, (METH_VARARGS | METH_KEYWORDS), (char *) "visitAnd(in ASE.Compiler.Cxx.And vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitEquality", (PyCFunction) ASE_Compiler_Cxx_Printer_visitEquality, (METH_VARARGS | METH_KEYWORDS), (char *) "visitEquality(in ASE.Compiler.Cxx.Equality vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitInequality", (PyCFunction) ASE_Compiler_Cxx_Printer_visitInequality, (METH_VARARGS | METH_KEYWORDS), (char *) "visitInequality(in ASE.Compiler.Cxx.Inequality vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitLessThan", (PyCFunction) ASE_Compiler_Cxx_Printer_visitLessThan, (METH_VARARGS | METH_KEYWORDS), (char *) "visitLessThan(in ASE.Compiler.Cxx.LessThan vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitGreaterThan", (PyCFunction) ASE_Compiler_Cxx_Printer_visitGreaterThan, (METH_VARARGS | METH_KEYWORDS), (char *) "visitGreaterThan(in ASE.Compiler.Cxx.GreaterThan vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitLessThanOrEqual", (PyCFunction) ASE_Compiler_Cxx_Printer_visitLessThanOrEqual, (METH_VARARGS | METH_KEYWORDS), (char *) "visitLessThanOrEqual(in ASE.Compiler.Cxx.LessThanOrEqual vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitGreaterThanOrEqual", (PyCFunction) ASE_Compiler_Cxx_Printer_visitGreaterThanOrEqual, (METH_VARARGS | METH_KEYWORDS), (char *) "visitGreaterThanOrEqual(in ASE.Compiler.Cxx.GreaterThanOrEqual vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitLeftShift", (PyCFunction) ASE_Compiler_Cxx_Printer_visitLeftShift, (METH_VARARGS | METH_KEYWORDS), (char *) "visitLeftShift(in ASE.Compiler.Cxx.LeftShift vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitRightShift", (PyCFunction) ASE_Compiler_Cxx_Printer_visitRightShift, (METH_VARARGS | METH_KEYWORDS), (char *) "visitRightShift(in ASE.Compiler.Cxx.RightShift vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitAddition", (PyCFunction) ASE_Compiler_Cxx_Printer_visitAddition, (METH_VARARGS | METH_KEYWORDS), (char *) "visitAddition(in ASE.Compiler.Cxx.Addition vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitSubtraction", (PyCFunction) ASE_Compiler_Cxx_Printer_visitSubtraction, (METH_VARARGS | METH_KEYWORDS), (char *) "visitSubtraction(in ASE.Compiler.Cxx.Subtraction vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitMultiplication", (PyCFunction) ASE_Compiler_Cxx_Printer_visitMultiplication, (METH_VARARGS | METH_KEYWORDS), (char *) "visitMultiplication(in ASE.Compiler.Cxx.Multiplication vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitDivision", (PyCFunction) ASE_Compiler_Cxx_Printer_visitDivision, (METH_VARARGS | METH_KEYWORDS), (char *) "visitDivision(in ASE.Compiler.Cxx.Division vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitModulo", (PyCFunction) ASE_Compiler_Cxx_Printer_visitModulo, (METH_VARARGS | METH_KEYWORDS), (char *) "visitModulo(in ASE.Compiler.Cxx.Modulo vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitCast", (PyCFunction) ASE_Compiler_Cxx_Printer_visitCast, (METH_VARARGS | METH_KEYWORDS), (char *) "visitCast(in ASE.Compiler.Cxx.Cast vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitSizeof", (PyCFunction) ASE_Compiler_Cxx_Printer_visitSizeof, (METH_VARARGS | METH_KEYWORDS), (char *) "visitSizeof(in ASE.Compiler.Cxx.Sizeof vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitAddress", (PyCFunction) ASE_Compiler_Cxx_Printer_visitAddress, (METH_VARARGS | METH_KEYWORDS), (char *) "visitAddress(in ASE.Compiler.Cxx.Address vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitIndirection", (PyCFunction) ASE_Compiler_Cxx_Printer_visitIndirection, (METH_VARARGS | METH_KEYWORDS), (char *) "visitIndirection(in ASE.Compiler.Cxx.Indirection vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitUnaryPlus", (PyCFunction) ASE_Compiler_Cxx_Printer_visitUnaryPlus, (METH_VARARGS | METH_KEYWORDS), (char *) "visitUnaryPlus(in ASE.Compiler.Cxx.UnaryPlus vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitUnaryMinus", (PyCFunction) ASE_Compiler_Cxx_Printer_visitUnaryMinus, (METH_VARARGS | METH_KEYWORDS), (char *) "visitUnaryMinus(in ASE.Compiler.Cxx.UnaryMinus vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitComplement", (PyCFunction) ASE_Compiler_Cxx_Printer_visitComplement, (METH_VARARGS | METH_KEYWORDS), (char *) "visitComplement(in ASE.Compiler.Cxx.Complement vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitNegation", (PyCFunction) ASE_Compiler_Cxx_Printer_visitNegation, (METH_VARARGS | METH_KEYWORDS), (char *) "visitNegation(in ASE.Compiler.Cxx.Negation vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitIncrement", (PyCFunction) ASE_Compiler_Cxx_Printer_visitIncrement, (METH_VARARGS | METH_KEYWORDS), (char *) "visitIncrement(in ASE.Compiler.Cxx.Increment vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitStructReference", (PyCFunction) ASE_Compiler_Cxx_Printer_visitStructReference, (METH_VARARGS | METH_KEYWORDS), (char *) "visitStructReference(in ASE.Compiler.Cxx.StructReference vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitArrayReference", (PyCFunction) ASE_Compiler_Cxx_Printer_visitArrayReference, (METH_VARARGS | METH_KEYWORDS), (char *) "visitArrayReference(in ASE.Compiler.Cxx.ArrayReference vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitFunctionCall", (PyCFunction) ASE_Compiler_Cxx_Printer_visitFunctionCall, (METH_VARARGS | METH_KEYWORDS), (char *) "visitFunctionCall(in ASE.Compiler.Cxx.FunctionCall vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitVariable", (PyCFunction) ASE_Compiler_Cxx_Printer_visitVariable, (METH_VARARGS | METH_KEYWORDS), (char *) "visitVariable(in ASE.Compiler.Cxx.Variable vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "visitConstant", (PyCFunction) ASE_Compiler_Cxx_Printer_visitConstant, (METH_VARARGS | METH_KEYWORDS), (char *) "visitConstant(in ASE.Compiler.Cxx.Constant vertex)\n\
RETURNS None\n\
\n\
"},
  {(char *) "weakReference", (PyCFunction) ASE_Compiler_Cxx_Printer_weakReference, (METH_VARARGS | METH_KEYWORDS), (char *) "weakReference()\n\
RETURNS (return ASE.Compiler.Cxx.Printer _return_value)\n\
"},
  {NULL, NULL}};

static struct PyMethodDef _PrinterModuleMethods[] = {{NULL, NULL}};

static void sidl_dealloc(struct ASE_Compiler_Cxx_Printer_PythonObject *self)
{
  if (self->weakRefList)
  {
    PyObject_ClearWeakRefs((PyObject *) self);
  }
  if ((self->refType != WEAK_REF) && (self->ior->d_data))
  {
    (*(((struct ASE_BaseInterface__object *) self->ior)->d_epv->deleteReference))(self->ior->d_object, NULL);
  }
  self->ob_type->tp_free(self);
}

static int sidl_cmp(struct ASE_Compiler_Cxx_Printer_PythonObject *self, PyObject *arg)
{
  struct ASE_Compiler_Cxx_Printer__object *ior1 = self->ior;
  struct ASE_BaseInterface__object *ior2 = (struct ASE_BaseInterface__object *) ((struct ASE_Compiler_Cxx_Printer_PythonObject *) arg)->ior;
  PyObject *o1 = NULL;
  PyObject *o2 = NULL;
  int _return_value = 0;
  
  /* Check for a valid SIDL Object */
  if (arg->ob_type != &SIDLPythonObjectType)
  {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for sidl_cmp");
    return _return_value;
  }
  if (!ior1)
  {
    PyErr_SetString(PyExc_ValueError, "Null IOR pointer in sidl_cmp()");
    return _return_value;
  }
  if (!ior2)
  {
    PyErr_SetString(PyExc_ValueError, "Null IOR pointer in sidl_cmp()");
    return _return_value;
  }
  o1 = Py_BuildValue((char *) "i", ior1->d_object);
  if (!o1)
  {
    PyErr_SetString(PyExc_RuntimeError, "Could not build integer from IOR pointer in sidl_cmp()");
    return _return_value;
  }
  o2 = Py_BuildValue((char *) "i", ior2->d_object);
  if (!o2)
  {
    PyErr_SetString(PyExc_RuntimeError, "Could not build integer from IOR pointer in sidl_cmp()");
    return _return_value;
  }
  _return_value = PyObject_Compare(o1, o2);
  Py_DECREF(o1);
  Py_DECREF(o2);
  return _return_value;
}

static long sidl_hash(struct ASE_Compiler_Cxx_Printer_PythonObject *self)
{
  struct ASE_Compiler_Cxx_Printer__object *ior = self->ior;
  PyObject *_hash_arg = NULL;
  long _return_value = 0;
  
  if (!ior)
  {
    PyErr_SetString(PyExc_ValueError, "Null IOR pointer in sidl_hash()");
    return _return_value;
  }
  _hash_arg = Py_BuildValue((char *) "i", ior->d_object);
  if (!_hash_arg)
  {
    PyErr_SetString(PyExc_RuntimeError, "Could not hash IOR pointer in sidl_hash()");
    return _return_value;
  }
  _return_value = PyObject_Hash(_hash_arg);
  Py_DECREF(_hash_arg);
  return _return_value;
}

static PyObject *sidl_str(struct ASE_Compiler_Cxx_Printer_PythonObject *self)
{
  struct ASE_Compiler_Cxx_Printer__object *ior = self->ior;
  const char *_str = NULL;
  PyObject *_return_value = NULL;
  
  _str = (*(ior->d_epv->strObject))(ior, NULL);
  _return_value = PyString_FromString(_str);
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *sidl_richcmp(struct ASE_Compiler_Cxx_Printer_PythonObject *self, PyObject *arg, int op)
{
  struct ASE_Compiler_Cxx_Printer__object *ior1 = self->ior;
  struct ASE_BaseInterface__object *ior2 = (struct ASE_BaseInterface__object *) ((struct ASE_Compiler_Cxx_Printer_PythonObject *) arg)->ior;
  PyObject *o1 = NULL;
  PyObject *o2 = NULL;
  PyObject *_return_value = NULL;
  
  /* Check for a valid SIDL Object */
  if (!PyObject_HasAttrString(arg, (char *) "getClassName"))
  {
    switch(op) {
      case Py_EQ:
        _return_value = Py_False;
        Py_INCREF(_return_value);
        break;
      case Py_NE:
        _return_value = Py_True;
        Py_INCREF(_return_value);
        break;
      case Py_LT:
      case Py_LE:
      case Py_GT:
      case Py_GE:
        PyErr_SetString(PyExc_TypeError, (char *) "sidl_richcmp: Cannot order non-SIDL object");
    }
    return _return_value;
  }
  if (!ior1)
  {
    PyErr_SetString(PyExc_ValueError, "Null IOR pointer in sidl_richcmp()");
    return _return_value;
  }
  if (!ior2)
  {
    PyErr_SetString(PyExc_ValueError, "Null IOR pointer in sidl_richcmp()");
    return _return_value;
  }
  o1 = Py_BuildValue((char *) "i", ior1->d_object);
  if (!o1)
  {
    PyErr_SetString(PyExc_RuntimeError, "Could not build integer from IOR pointer in sidl_richcmp()");
    return _return_value;
  }
  o2 = Py_BuildValue((char *) "i", ior2->d_object);
  if (!o2)
  {
    PyErr_SetString(PyExc_RuntimeError, "Could not build integer from IOR pointer in sidl_richcmp()");
    return _return_value;
  }
  _return_value = PyObject_RichCompare(o1, o2, op);
  Py_DECREF(o1);
  Py_DECREF(o2);
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *sidl_getiter(struct ASE_Compiler_Cxx_Printer_PythonObject *self)
{
  Py_INCREF(self);
  return (PyObject *) self;
}

static PyObject *sidl_iternext(struct ASE_Compiler_Cxx_Printer_PythonObject *self)
{
  struct ASE_Compiler_Cxx_Printer__iterator *ior = self->ior;
  struct ASE_Compiler_Cxx_Printer__object *nextIorObj = (*(((struct ASE_BaseInterface__object *) ior)->d_epv->iterNext))(ior, NULL);
  static struct ASE_Compiler_Cxx_Printer_PythonObject *nextPyObj = NULL;
  
  if (!nextIorObj)
  {
    if (nextPyObj)
    {
      Py_DECREF(nextPyObj);
      nextPyObj = NULL;
      (*(_epv->destroyIterator))(ior, NULL);
      self->ior = NULL;
    }
    return NULL;
  }
  if (!ior->objWrapper)
  {
    ior->objWrapper = sidl_new(&SIDLPythonObjectType, (struct ASE_BaseInterface__object *) nextIorObj, WEAK_REF);
    nextPyObj = (struct ASE_Compiler_Cxx_Printer_PythonObject *) ior->objWrapper;
  }
  else
  {
    nextPyObj = (struct ASE_Compiler_Cxx_Printer_PythonObject *) ior->objWrapper;
    nextPyObj->ior = nextIorObj;
  }
  Py_INCREF(nextPyObj);
  return (PyObject *) nextPyObj;
}

static PyTypeObject SIDLPythonObjectType = {
  PyObject_HEAD_INIT(NULL)
  0,
  (char *) "ASE.Compiler.Cxx.Printer",
  sizeof(struct ASE_Compiler_Cxx_Printer_PythonObject),
  0,
  (destructor) sidl_dealloc,
  (printfunc) 0,
  (getattrfunc) 0,
  (setattrfunc) 0,
  (cmpfunc) sidl_cmp,
  (reprfunc) 0,
  (PyNumberMethods *) 0,
  (PySequenceMethods *) 0,
  (PyMappingMethods *) 0,
  (hashfunc) sidl_hash,
  (ternaryfunc) 0,
  (reprfunc) sidl_str,
  (getattrofunc) 0,
  (setattrofunc) 0,
  (PyBufferProcs *) 0,
  Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE | Py_TPFLAGS_HAVE_WEAKREFS,
  (char *) "This is a Python wrapper for a SIDL object of type ASE.Compiler.Cxx.Printer",
  (traverseproc) 0,
  (inquiry) 0,
  (richcmpfunc) sidl_richcmp,
  (int) &((struct ASE_Compiler_Cxx_Printer_PythonObject *) 0)->weakRefList,
  (getiterfunc) sidl_getiter,
  (iternextfunc) sidl_iternext,
  _PrinterObjectMethods,
  (struct PyMemberDef *) 0,
  (struct PyGetSetDef *) 0,
  0,
  0,
  (descrgetfunc) 0,
  (descrsetfunc) 0,
  0,
  (initproc) 0,
  (allocfunc) 0,
  (newfunc) ASE_Compiler_Cxx_Printer_Printer,
  (freefunc) 0,
  (inquiry) 0};

void initPrinter(void)
{
  PyObject *module = NULL;
  const struct ASE_Compiler_Cxx_Printer__external *(*_extFunc)(void);
  struct ASE_BaseException__object *_exception = NULL;
  
  /* Setup the python type */
  if (PyType_Ready(&SIDLPythonObjectType) < 0)
  {
    return;
  }
  /* Initialize the module */
  module = Py_InitModule3((char *) "Printer", _PrinterModuleMethods, (char *) " This class prints a Cxx AST to standard output as Cxx source");
  if (PyErr_Occurred())
  {
    PyErr_SetString(PyExc_ImportError, "Could not initialize module ASE.Compiler.Cxx.Printer");
    return;
  }
  /* Add the type to the module and increment the ref count */
  Py_INCREF(&SIDLPythonObjectType);
  PyModule_AddObject(module, (char *) "Printer", (PyObject *) &SIDLPythonObjectType);
  /* Set externals function */
  _extFunc = (const struct ASE_Compiler_Cxx_Printer__external *(*)(void)) ASE_Loader__externals()->getStaticEPV(&_exception)->getClassMethodTable("ASE.Compiler.Cxx.Printer", &_exception);
  /* Check exception */
  if (_exception)
  {
    _exception = _exception->d_epv->castObject(_exception, "ASE.BaseException", NULL);
    PyErr_SetString(PyExc_RuntimeError, _exception->d_epv->getMessage(_exception->d_object, NULL));
    return;
  }
  /* Set epv pointer */
  if (_extFunc)
  {
    _epv = (*_extFunc)();
  }
  if (!_epv)
  {
    PyErr_SetString(PyExc_ImportError, "Cannot load SIDL implementation for ASE.Compiler.Cxx.Printer");
    return;
  }
  /* Import Numeric */
  import_array();
  if (PyErr_Occurred())
  {
    PyErr_SetString(PyExc_ImportError, "Cannot import Numeric Python array module");
    return;
  }
}
